#include "qdragenterevent.h"
#include "qevent.h"

using namespace v8;

Persistent<Function> QDragEnterEventWrap::constructor;

QDragEnterEventWrap::QDragEnterEventWrap(const v8::Arguments& args) : q_(NULL) {
  // Standalone constructor not implemented
  // Use SetWrapped()
  
  //test
//  if (args[0]->IsObject() && qt_v8::ToQString(args[0]->ToObject()->GetConstructorName())=="QEvent") {
//  	QEventWrap* evt_wrap = ObjectWrap::Unwrap<QEventWrap>(args[0]->ToObject());
//	  QEvent* event = evt_wrap->GetWrapped();
//    q_ = static_cast<QDragEnterEvent *>(event);
//  }
  
}

QDragEnterEventWrap::~QDragEnterEventWrap() {
  //delete q_;
}

void QDragEnterEventWrap::Initialize(Handle<Object> target) {
  // Prepare constructor template
  Local<FunctionTemplate> tpl = FunctionTemplate::New(New);
  tpl->SetClassName(String::NewSymbol("QDragEnterEvent"));
  tpl->InstanceTemplate()->SetInternalFieldCount(1);  

  // Wrapped methods  
	ADD_METHOD(destroy)
	
	ADD_METHOD(accept)
	ADD_METHOD(ignore)
	ADD_METHOD(isAccepted)
	ADD_METHOD(setAccepted)
	ADD_METHOD(type)
	
	//ADD_METHOD(spontaneous)

	ADD_METHOD(acceptProposedAction)
	ADD_METHOD(mimeData)
//	ADD_METHOD(pos)
//	ADD_METHOD(source)
	
  constructor = Persistent<Function>::New(tpl->GetFunction());
  target->Set(String::NewSymbol("QDragEnterEvent"), constructor);
}

Handle<Value> QDragEnterEventWrap::New(const Arguments& args) {
  HandleScope scope;

  QDragEnterEventWrap* w = new QDragEnterEventWrap(args);
  w->Wrap(args.This());

  return args.This();
}

Handle<Value> QDragEnterEventWrap::NewInstance(QDragEnterEvent *q) {
  HandleScope scope;
  
  Local<Object> instance = constructor->NewInstance(0, NULL);
  QDragEnterEventWrap* w = node::ObjectWrap::Unwrap<QDragEnterEventWrap>(instance);
  w->SetWrapped(q);

  return scope.Close(instance);
}

//void 	accept ()
Handle<Value> QDragEnterEventWrap::accept(const Arguments& args) {
  HandleScope scope;

  QDragEnterEventWrap* w = node::ObjectWrap::Unwrap<QDragEnterEventWrap>(args.This());
  QDragEnterEvent* q = w->GetWrapped();

	q->accept();
	
	return scope.Close(Undefined());
}

//void 	ignore ()
Handle<Value> QDragEnterEventWrap::ignore(const Arguments& args) {
  HandleScope scope;

  QDragEnterEventWrap* w = node::ObjectWrap::Unwrap<QDragEnterEventWrap>(args.This());
  QDragEnterEvent* q = w->GetWrapped();

	q->ignore();
	
	return scope.Close(Undefined());
}

//bool 	isAccepted () const
Handle<Value> QDragEnterEventWrap::isAccepted(const Arguments& args) {
  HandleScope scope;

  QDragEnterEventWrap* w = node::ObjectWrap::Unwrap<QDragEnterEventWrap>(args.This());
  QDragEnterEvent* q = w->GetWrapped();
	
	return scope.Close(Boolean::New(q->isAccepted()));
}

//void 	setAccepted ( bool accepted )
Handle<Value> QDragEnterEventWrap::setAccepted(const Arguments& args) {
  HandleScope scope;

  QDragEnterEventWrap* w = node::ObjectWrap::Unwrap<QDragEnterEventWrap>(args.This());
  QDragEnterEvent* q = w->GetWrapped();

	q->setAccepted(args[0]->BooleanValue());
	
	return scope.Close(Undefined());
}

//int 	type () const
Handle<Value> QDragEnterEventWrap::type(const Arguments& args) {
  HandleScope scope;

  QDragEnterEventWrap* w = node::ObjectWrap::Unwrap<QDragEnterEventWrap>(args.This());
  QDragEnterEvent* q = w->GetWrapped();
	
	return scope.Close(Integer::New(q->type()));
}

//mimeData () -> object QMimeData
//Handle<Value> QDragEnterEventWrap::mimeData(const Arguments& args) {
//  HandleScope scope;
//
//  QDragEnterEventWrap* w = node::ObjectWrap::Unwrap<QDragEnterEventWrap>(args.This());
//  QDragEnterEvent* q = w->GetWrapped();
//	
//	return scope.Close(QMimeDataWrap::NewInstance((QMimeData *)q->mimeData()));
//}

Handle<Value> QDragEnterEventWrap::mimeData(const Arguments& args) {
  HandleScope scope;

  QDragEnterEventWrap* w = node::ObjectWrap::Unwrap<QDragEnterEventWrap>(args.This());
  QDragEnterEvent* q = w->GetWrapped();
  
  const QMimeData * m = q->mimeData();
  
  // convert to native JS object
	Handle<Object> dataObj = v8::Object::New(); //m->formats().count()
	foreach(QString format, m->formats()){
		QByteArray ba = m->data(format);
		node::Buffer *buf = node::Buffer::New(ba.size());
		memcpy(node::Buffer::Data(buf), ba.data(), ba.size());		
		dataObj->Set(
			qt_v8::FromQString(format),
			buf->handle_
		);
	}
	
	return scope.Close(dataObj);
}




//void 	acceptProposedAction ()
Handle<Value> QDragEnterEventWrap::acceptProposedAction(const Arguments& args) {
  HandleScope scope;

  QDragEnterEventWrap* w = node::ObjectWrap::Unwrap<QDragEnterEventWrap>(args.This());
  QDragEnterEvent* q = w->GetWrapped();

	q->acceptProposedAction();
	
	return scope.Close(Undefined());
}

Handle<Value> QDragEnterEventWrap::destroy(const Arguments& args) {
  HandleScope scope;
  QDragEnterEventWrap* w = ObjectWrap::Unwrap<QDragEnterEventWrap>(args.This());
  QDragEnterEvent* q = w->GetWrapped();
	delete q;
  return scope.Close(Undefined());
}