#include "qdragmoveevent.h"
#include "qevent.h"
#include "../Types/qpoint.h"

using namespace v8;

Persistent<Function> QDragMoveEventWrap::constructor;

QDragMoveEventWrap::QDragMoveEventWrap(const v8::Arguments& args) : q_(NULL) {
  // Standalone constructor not implemented
  // Use SetWrapped()
  
  //test
//  if (args[0]->IsObject() && qt_v8::ToQString(args[0]->ToObject()->GetConstructorName())=="QEvent") {
//  	QEventWrap* evt_wrap = ObjectWrap::Unwrap<QEventWrap>(args[0]->ToObject());
//	  QEvent* event = evt_wrap->GetWrapped();
//    q_ = static_cast<QDragMoveEvent *>(event);
//  }
  
}

QDragMoveEventWrap::~QDragMoveEventWrap() {
  //delete q_;
}

void QDragMoveEventWrap::Initialize(Handle<Object> target) {
  // Prepare constructor template
  Local<FunctionTemplate> tpl = FunctionTemplate::New(New);
  tpl->SetClassName(String::NewSymbol("QDragMoveEvent"));
  tpl->InstanceTemplate()->SetInternalFieldCount(1);
  
  // Wrapped methods 
	ADD_METHOD(destroy)
	 
	ADD_METHOD(accept)
	ADD_METHOD(ignore)
	ADD_METHOD(isAccepted)
	ADD_METHOD(setAccepted)
	//ADD_METHOD(spontaneous)
	ADD_METHOD(type)
	
	ADD_METHOD(acceptProposedAction)
	ADD_METHOD(mimeData)
	ADD_METHOD(pos)
	ADD_METHOD(source)

  constructor = Persistent<Function>::New(tpl->GetFunction());
  target->Set(String::NewSymbol("QDragMoveEvent"), constructor);
}

Handle<Value> QDragMoveEventWrap::New(const Arguments& args) {
  HandleScope scope;

  QDragMoveEventWrap* w = new QDragMoveEventWrap(args);
  w->Wrap(args.This());

  return args.This();
}

Handle<Value> QDragMoveEventWrap::NewInstance(QDragMoveEvent *q) {
  HandleScope scope;
  
  Local<Object> instance = constructor->NewInstance(0, NULL);
  QDragMoveEventWrap* w = node::ObjectWrap::Unwrap<QDragMoveEventWrap>(instance);
  w->SetWrapped(q);

  return scope.Close(instance);
}

Handle<Value> QDragMoveEventWrap::destroy(const Arguments& args) {
  HandleScope scope;
  QDragMoveEventWrap* w = ObjectWrap::Unwrap<QDragMoveEventWrap>(args.This());
  QDragMoveEvent* q = w->GetWrapped();
	delete q;
  return scope.Close(Undefined());
}


//void 	accept ()
Handle<Value> QDragMoveEventWrap::accept(const Arguments& args) {
  HandleScope scope;

  QDragMoveEventWrap* w = node::ObjectWrap::Unwrap<QDragMoveEventWrap>(args.This());
  QDragMoveEvent* q = w->GetWrapped();

	q->accept();
	
	return scope.Close(Undefined());
}

//void 	ignore ()
Handle<Value> QDragMoveEventWrap::ignore(const Arguments& args) {
  HandleScope scope;

  QDragMoveEventWrap* w = node::ObjectWrap::Unwrap<QDragMoveEventWrap>(args.This());
  QDragMoveEvent* q = w->GetWrapped();

	q->ignore();
	
	return scope.Close(Undefined());
}

//bool 	isAccepted () const
Handle<Value> QDragMoveEventWrap::isAccepted(const Arguments& args) {
  HandleScope scope;

  QDragMoveEventWrap* w = node::ObjectWrap::Unwrap<QDragMoveEventWrap>(args.This());
  QDragMoveEvent* q = w->GetWrapped();
	
	return scope.Close(Boolean::New(q->isAccepted()));
}

//void 	setAccepted ( bool accepted )
Handle<Value> QDragMoveEventWrap::setAccepted(const Arguments& args) {
  HandleScope scope;

  QDragMoveEventWrap* w = node::ObjectWrap::Unwrap<QDragMoveEventWrap>(args.This());
  QDragMoveEvent* q = w->GetWrapped();

	q->setAccepted(args[0]->BooleanValue());
	
	return scope.Close(Undefined());
}

//int 	type () const
Handle<Value> QDragMoveEventWrap::type(const Arguments& args) {
  HandleScope scope;

  QDragMoveEventWrap* w = node::ObjectWrap::Unwrap<QDragMoveEventWrap>(args.This());
  QDragMoveEvent* q = w->GetWrapped();
	
	return scope.Close(Integer::New(q->type()));
}

//mimeData () -> object QMimeData
//Handle<Value> QDragMoveEventWrap::mimeData(const Arguments& args) {
//  HandleScope scope;
//
//  QDragMoveEventWrap* w = node::ObjectWrap::Unwrap<QDragMoveEventWrap>(args.This());
//  QDragMoveEvent* q = w->GetWrapped();
//	
//	return scope.Close(QMimeDataWrap::NewInstance((QMimeData *)q->mimeData()));
//}

Handle<Value> QDragMoveEventWrap::mimeData(const Arguments& args) {
  HandleScope scope;

  QDragMoveEventWrap* w = node::ObjectWrap::Unwrap<QDragMoveEventWrap>(args.This());
  QDragMoveEvent* q = w->GetWrapped();
  
  const QMimeData * m = q->mimeData();
  
  // convert to native JS object
	Handle<Object> dataObj = v8::Object::New(); //m->formats().count()
	foreach(QString format, m->formats()){
		QByteArray ba = m->data(format);
		node::Buffer *buf = node::Buffer::New(ba.size());
		memcpy(node::Buffer::Data(buf), ba.data(), ba.size());		
		dataObj->Set(
			qt_v8::FromQString(format),
			buf->handle_
		);
	}
	
	return scope.Close(dataObj);
}
//void 	acceptProposedAction ()
Handle<Value> QDragMoveEventWrap::acceptProposedAction(const Arguments& args) {
  HandleScope scope;

  QDragMoveEventWrap* w = node::ObjectWrap::Unwrap<QDragMoveEventWrap>(args.This());
  QDragMoveEvent* q = w->GetWrapped();

	q->acceptProposedAction();
	
	return scope.Close(Undefined());
}

// pos () -> object QPoint
Handle<Value> QDragMoveEventWrap::pos(const Arguments& args) {
  HandleScope scope;

  QDragMoveEventWrap* w = node::ObjectWrap::Unwrap<QDragMoveEventWrap>(args.This());
  QDragMoveEvent* q = w->GetWrapped();
	
  return scope.Close( QPointWrap::NewInstance(q->pos()) );
}

// CUSTOM: source () -> objectName | undefined
Handle<Value> QDragMoveEventWrap::source(const Arguments& args) {
  HandleScope scope;

  QDragMoveEventWrap* w = node::ObjectWrap::Unwrap<QDragMoveEventWrap>(args.This());
  QDragMoveEvent* q = w->GetWrapped();
	
	QWidget* src = q->source();
	if (src)
  	return scope.Close(qt_v8::FromQString(src->objectName()));
  else
 		return scope.Close(Undefined());
}