
#include "qkeyevent.h"
#include "qevent.h"

using namespace v8;

Persistent<Function> QKeyEventWrap::constructor;

QKeyEventWrap::QKeyEventWrap(const v8::Arguments& args) : q_(NULL) {
  // Standalone constructor not implemented
  // Use SetWrapped()
  
  //test
  if (args[0]->IsObject() && qt_v8::ToQString(args[0]->ToObject()->GetConstructorName())=="QEvent") {
  	QEventWrap* evt_wrap = ObjectWrap::Unwrap<QEventWrap>(args[0]->ToObject());
	  QEvent* event = evt_wrap->GetWrapped();
    q_ = static_cast<QKeyEvent *>(event);
  }
}

QKeyEventWrap::~QKeyEventWrap() {
  //delete q_;
}

void QKeyEventWrap::Initialize(Handle<Object> target) {
  // Prepare constructor template
  Local<FunctionTemplate> tpl = FunctionTemplate::New(New);
  tpl->SetClassName(String::NewSymbol("QKeyEvent"));
  tpl->InstanceTemplate()->SetInternalFieldCount(1);  
      
	ADD_METHOD(key)
	ADD_METHOD(text)
	
	ADD_METHOD(destroy)
	
  constructor = Persistent<Function>::New(tpl->GetFunction());
  target->Set(String::NewSymbol("QKeyEvent"), constructor);
}

Handle<Value> QKeyEventWrap::New(const Arguments& args) {
  HandleScope scope;

  QKeyEventWrap* w = new QKeyEventWrap(args);
  w->Wrap(args.This());

  return args.This();
}

Handle<Value> QKeyEventWrap::NewInstance(QKeyEvent *q) {
  HandleScope scope;
    
  Local<Object> instance = constructor->NewInstance(0, NULL);
  QKeyEventWrap* w = node::ObjectWrap::Unwrap<QKeyEventWrap>(instance);
  w->SetWrapped(q);

  return scope.Close(instance);
}

Handle<Value> QKeyEventWrap::key(const Arguments& args) {
  HandleScope scope;

  QKeyEventWrap* w = node::ObjectWrap::Unwrap<QKeyEventWrap>(args.This());
  QKeyEvent* q = w->GetWrapped();

  return scope.Close(Number::New(q->key()));
}

Handle<Value> QKeyEventWrap::text(const Arguments& args) {
  HandleScope scope;

  QKeyEventWrap* w = node::ObjectWrap::Unwrap<QKeyEventWrap>(args.This());
  QKeyEvent* q = w->GetWrapped();

  return scope.Close(qt_v8::FromQString(q->text()));
}

Handle<Value> QKeyEventWrap::destroy(const Arguments& args) {
  HandleScope scope;
  QKeyEventWrap* w = ObjectWrap::Unwrap<QKeyEventWrap>(args.This());
  QKeyEvent* q = w->GetWrapped();
	delete q;
  return scope.Close(Undefined());
}