#ifndef QTOUCHEVENTWRAP_H
#define QTOUCHEVENTWRAP_H

#include "../qt.h"
#include "../Widgets/qwidget.h"
#include "../Types/qtouchpoint.h"

class QTouchEventWrap : public node::ObjectWrap {
	
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  static v8::Handle<v8::Value> NewInstance(QTouchEvent *q);
  QTouchEvent* GetWrapped() const { return q_; };
  void SetWrapped(QTouchEvent *q) {
  	q_ = q;
  };

 private:
  QTouchEventWrap(const v8::Arguments& args);
  ~QTouchEventWrap();
  
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods
	DEFINE_METHOD(destroy)
	
	DEFINE_METHOD(accept)
	DEFINE_METHOD(ignore)
	DEFINE_METHOD(isAccepted)
	DEFINE_METHOD(setAccepted)
	DEFINE_METHOD(type)
	
	DEFINE_METHOD(deviceType)
	DEFINE_METHOD(touchPoints)
	DEFINE_METHOD(widget)
	
  // Wrapped object
  QTouchEvent* q_;
};

#endif
