#ifndef QUILOADERWRAP_H
#define QUILOADERWRAP_H


#include "../../qt.h"

#include "../../Widgets/qwidget.h"

class QUiLoaderWrap : public node::ObjectWrap {
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  QUiLoader* GetWrapped() const { return q_; };
  void SetWrapped(QUiLoader *q) { 
    q_ = q;
  };
  static v8::Handle<v8::Value> NewInstance(QUiLoader *q);
  
 private:
  QUiLoaderWrap(const v8::Arguments& args);
  ~QUiLoaderWrap();
  
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods
  DEFINE_METHOD(load)
  
//void 	addPluginPath ( const QString & path )
		//QStringList 	availableLayouts () const
		//QStringList 	availableWidgets () const
//void 	clearPluginPaths ()
		//bool 	isLanguageChangeEnabled () const
//QStringList 	pluginPaths () const
		//void 	setLanguageChangeEnabled ( bool enabled )
//void 	setWorkingDirectory ( const QDir & dir )
//QDir 	workingDirectory () const
	
	//	DEFINE_METHOD(availableLayouts)
	//	DEFINE_METHOD(availableWidgets)
	
	DEFINE_METHOD(addPluginPath)
	DEFINE_METHOD(clearPluginPaths)
	DEFINE_METHOD(pluginPaths)
	DEFINE_METHOD(setWorkingDirectory)
	DEFINE_METHOD(workingDirectory)
  
	DEFINE_METHOD(destroy)
	
  // Wrapped object
  QUiLoader* q_;
};

#endif
