#ifndef QACTIONWRAP_H
#define QACTIONWRAP_H

#include "../qt.h"
#include "../receiver.h"
#include "../Types/qimage.h"

class QActionWrap : public node::ObjectWrap {
	
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  QAction* GetWrapped() const { return q_; };
  void SetWrapped(QAction *q) { 
    //if (q_) delete q_; 
    //q_ = new QAction(q);
    q_ = q;
  };
  static v8::Handle<v8::Value> NewInstance(QAction *q);

 private:
  QActionWrap(const v8::Arguments& args);
  ~QActionWrap();
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods
  DEFINE_METHOD(on)
  DEFINE_METHOD(off)
  
	DEFINE_METHOD(destroy)
	DEFINE_METHOD(equals)
	
  DEFINE_METHOD(setCheckable)
	DEFINE_METHOD(setChecked)
	DEFINE_METHOD(setIcon)
	DEFINE_METHOD(setShortcut)
	DEFINE_METHOD(setStatusTip)
	DEFINE_METHOD(setText)
	DEFINE_METHOD(text)
	DEFINE_METHOD(setShortcuts)
	DEFINE_METHOD(setEnabled)
	
  // Wrapped object
  QAction* q_;
};

#endif
