#ifndef QAPPLICATIONWRAP_H
#define QAPPLICATIONWRAP_H

#include "../qt.h"
#include "../receiver.h"
#include "../Widgets/qwidget.h"

class QApplicationWrap : public node::ObjectWrap {
	
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  QApplication* GetWrapped() const { return q_; };

 private:
  QApplicationWrap();
  ~QApplicationWrap();
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods
  DEFINE_METHOD(on)
  DEFINE_METHOD(off)
	DEFINE_METHOD(destroy)
	DEFINE_METHOD(equals)
	
	DEFINE_METHOD(setObjectName)
	DEFINE_METHOD(objectName)
	
  DEFINE_METHOD(processEvents)
  DEFINE_METHOD(exec)
  
  DEFINE_METHOD(setStyleSheet)
  DEFINE_METHOD(styleSheet)
  
  DEFINE_METHOD(setQuitOnLastWindowClosed)
  DEFINE_METHOD(setActiveWindow)
  
	DEFINE_METHOD(focusWidget)
		
	DEFINE_METHOD(postEvent)
	DEFINE_METHOD(sendEvent)
	
	DEFINE_METHOD(tr)
	//DEFINE_METHOD(trUtf8)
	DEFINE_METHOD(installTranslator)
	DEFINE_METHOD(systemLocaleName)
	
	DEFINE_METHOD(applicationName)
	DEFINE_METHOD(setApplicationName)
	DEFINE_METHOD(organizationName)
	DEFINE_METHOD(setOrganizationName)
	DEFINE_METHOD(applicationVersion)
	DEFINE_METHOD(setApplicationVersion)
	
	DEFINE_METHOD(translate)
	
  // Wrapped object
  QApplication* q_;
  static int argc_;
  static char** argv_;
};

#endif
