#ifndef QCLIPBOARDWRAP_H
#define QCLIPBOARDWRAP_H


#include "../qt.h"

#include "../receiver.h"

#include "qmenu.h"
#include "qimage.h"
#include "qmimedata.h"

class QClipboardWrap : public node::ObjectWrap {
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  QClipboard* GetWrapped() const { return q_; };
  
//  void SetWrapped(QClipboard *q) { 
//    q_ = q;
//  };
//  static v8::Handle<v8::Value> NewInstance(QClipboard *q);

 private:
  QClipboardWrap(const v8::Arguments& args);
  ~QClipboardWrap();
  
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

//ACTIONS:
//	- clear ()
//  - formats () -> list
//	- image () -> int objectID
//	- mimeData (string format) -> string|bytearray
//	- setImage (int objectID|image|filename)
//	- setMimeData (string format, string|bytearray data)
//	- setText (string)
//	- text () -> string
//	
//SIGNALS:
//	- #dataChanged
	
  // Wrapped methods
  DEFINE_METHOD(on)
  DEFINE_METHOD(off)
  
  DEFINE_METHOD(clear)
  //DEFINE_METHOD(formats)
	DEFINE_METHOD(image)
	DEFINE_METHOD(mimeData)
	DEFINE_METHOD(setImage)
	DEFINE_METHOD(setMimeData)
	DEFINE_METHOD(setText)
	DEFINE_METHOD(text)
	
  // Wrapped object
  QClipboard* q_;
};

#endif
