#ifndef QFILESYSTEMMODELWRAP_H
#define QFILESYSTEMMODELWRAP_H


#include "../qt.h"

#include "../receiver.h"

#include "../Types/qmodelindex.h"

class QFileSystemModelWrap : public node::ObjectWrap {
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  QFileSystemModel* GetWrapped() const { return q_; };
  void SetWrapped(QFileSystemModel *q) { 
    //if (q_) delete q_; 
    //q_ = new QFileSystemModel(q);
    q_ = q;
  };
  static v8::Handle<v8::Value> NewInstance(QFileSystemModel *q);

 private:
  QFileSystemModelWrap(const v8::Arguments& args);
  ~QFileSystemModelWrap();
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods
  DEFINE_METHOD(on)
  DEFINE_METHOD(off)
	DEFINE_METHOD(destroy)
	DEFINE_METHOD(equals)
	
	DEFINE_METHOD(fileName)
	DEFINE_METHOD(filePath)
	DEFINE_METHOD(isDir)
	DEFINE_METHOD(setFilter)
	DEFINE_METHOD(setRootPath)
	
	DEFINE_METHOD(index)
	
  // Wrapped object
  QFileSystemModel* q_;
};

#endif
