#ifndef QOBJECTWRAP_H
#define QOBJECTWRAP_H

#include "../qt.h"

class QObjectWrap : public node::ObjectWrap {
	
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  
  QObject* GetWrapped() const { return q_; };
  
  void SetWrapped(QObject *q){
    q_ = q;
  };
  static v8::Handle<v8::Value> NewInstance(QObject *q);

 private:
  QObjectWrap(const v8::Arguments& args);
  ~QObjectWrap();
  
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods  
	DEFINE_METHOD(destroy)
	DEFINE_METHOD(equals)
		
  // Wrapped object
  QObject* q_;
};

#endif
