#ifndef QSYSTEMTRAYICONWRAP_H
#define QSYSTEMTRAYICONWRAP_H

#include "../qt.h"
#include "../receiver.h"

#include "../Widgets/qmenu.h"
#include "../Types/qimage.h"

class QSystemTrayIconWrap : public node::ObjectWrap {
	
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  QSystemTrayIcon* GetWrapped() const { return q_; };
  void SetWrapped(QSystemTrayIcon *q) { q_ = q; };
  static v8::Handle<v8::Value> NewInstance(QSystemTrayIcon *q);
	//bool hasEvents;
	
 private:
  QSystemTrayIconWrap(const v8::Arguments& args, bool eventsFlag);
  ~QSystemTrayIconWrap();
  
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods
  DEFINE_METHOD(on)
  DEFINE_METHOD(off)
	DEFINE_METHOD(destroy)
	DEFINE_METHOD(equals)
	
  DEFINE_METHOD(setContextMenu)
  DEFINE_METHOD(setIcon)
	DEFINE_METHOD(setToolTip)
	DEFINE_METHOD(show)
	DEFINE_METHOD(hide)

//- setContextMenu (int menuID)
//- setIcon (string|image icon)
//- setToolTip (string)
//- show ()
//- hide ()
	
  // Wrapped object
  QSystemTrayIcon* q_;
};

#endif
