#ifndef QVBOXLAYOUTWRAP_H
#define QVBOXLAYOUTWRAP_H

#include "../qt.h"
#include "../receiver.h"

#include "../Widgets/qwidget.h"

class QVBoxLayoutWrap : public node::ObjectWrap {
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  QVBoxLayout* GetWrapped() const { return q_; };
  void SetWrapped(QVBoxLayout *q) { 
    q_ = q;
  };
  static v8::Handle<v8::Value> NewInstance(QVBoxLayout *q);

 private:
  QVBoxLayoutWrap(const v8::Arguments& args);
  ~QVBoxLayoutWrap();
  
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);
	
  // Wrapped methods
  
//	addLayout ( QVBoxLayout * layout, int row, int column, Qt::Alignment alignment = 0 )
//	addWidget ( QWidget * widget, int row, int column, Qt::Alignment alignment = 0 )
//	
//	TODO
//	addLayout ( QVBoxLayout * layout, int row, int column, int rowSpan, int columnSpan, Qt::Alignment alignment = 0 )
//	addWidget ( QWidget * widget, int fromRow, int fromColumn, int rowSpan, int columnSpan, Qt::Alignment alignment = 0 )
	
	DEFINE_METHOD(destroy)
	DEFINE_METHOD(equals)
	
  DEFINE_METHOD(addLayout)
  DEFINE_METHOD(addWidget)
  
  DEFINE_METHOD(setSpacing)
  DEFINE_METHOD(setContentsMargins)
  
	DEFINE_METHOD(addSpacing)
  DEFINE_METHOD(addStretch)
  
	DEFINE_METHOD(setSizeConstraint)
	
  // Wrapped object
  QVBoxLayout* q_;
};

#endif
