
#include "qbrush.h"

using namespace v8;

Persistent<Function> QBrushWrap::constructor;

// Supported constructors
// QBrush(Qt::GlobalColor)
QBrushWrap::QBrushWrap(const Arguments& args) {
  if (args.Length() > 0) {
    q_ = new QBrush((Qt::GlobalColor)args[0]->IntegerValue());
  } else {
    q_ = new QBrush();
  }
}

QBrushWrap::~QBrushWrap() {
  //delete q_;
}

void QBrushWrap::Initialize(Handle<Object> target) {
  // Prepare constructor template
  Local<FunctionTemplate> tpl = FunctionTemplate::New(New);
  tpl->SetClassName(String::NewSymbol("QBrush"));
  tpl->InstanceTemplate()->SetInternalFieldCount(1);  

  // Prototype
	ADD_METHOD(destroy)
	ADD_METHOD(equals)
	
  constructor = Persistent<Function>::New(tpl->GetFunction());
  target->Set(String::NewSymbol("QBrush"), constructor);
}

Handle<Value> QBrushWrap::New(const Arguments& args) {
  HandleScope scope;

  QBrushWrap* w = new QBrushWrap(args);
  w->Wrap(args.This());

  return args.This();
}

Handle<Value> QBrushWrap::destroy(const Arguments& args) {
  HandleScope scope;
  QBrushWrap* w = ObjectWrap::Unwrap<QBrushWrap>(args.This());
  QBrush* q = w->GetWrapped();
	delete q;
  return scope.Close(Undefined());
}

// equals
Handle<Value> QBrushWrap::equals(const Arguments& args) {
  HandleScope scope;
  
  QBrushWrap* w = ObjectWrap::Unwrap<QBrushWrap>(args.This());
  QBrushWrap* w2 = ObjectWrap::Unwrap<QBrushWrap>(args[0]->ToObject());
  
  return scope.Close(Boolean::New( w->GetWrapped()==w2->GetWrapped() ));
}
