#ifndef QCOLORWRAP_H
#define QCOLORWRAP_H


#include "../qt.h"

class QColorWrap : public node::ObjectWrap {
	
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  static v8::Handle<v8::Value> NewInstance(QColor q);
  QColor* GetWrapped() const { return q_; };
  void SetWrapped(QColor q) { 
    if (q_) delete q_; 
    q_ = new QColor(q); 
  };
  
 private:
  QColorWrap(const v8::Arguments& args);
  ~QColorWrap();
  
  static v8::Persistent<v8::Function> constructor;
  //static v8::Handle<v8::Value> New(const v8::Arguments& args);
  DEFINE_METHOD(New)

  // Wrapped methods
  DEFINE_METHOD(red)
  DEFINE_METHOD(green)
  DEFINE_METHOD(blue)
  DEFINE_METHOD(alpha)
  DEFINE_METHOD(name)

	DEFINE_METHOD(destroy)
	DEFINE_METHOD(equals)
	
  // Wrapped object
  QColor* q_;
};

#endif
