#ifndef QFONTWRAP_H
#define QFONTWRAP_H


#include "../qt.h"

class QFontWrap : public node::ObjectWrap {
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  QFont* GetWrapped() const { return q_; };
  void SetWrapped(QFont q) { 
    if (q_) delete q_; 
    q_ = new QFont(q); 
  };
  static v8::Handle<v8::Value> NewInstance(QFont q);

 private:
  QFontWrap(const v8::Arguments& args);
  ~QFontWrap();
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods
	DEFINE_METHOD(destroy)
	DEFINE_METHOD(equals)
	
	DEFINE_METHOD(SetFamily)
	DEFINE_METHOD(Family)
	DEFINE_METHOD(SetPixelSize)
	DEFINE_METHOD(PixelSize)
	DEFINE_METHOD(SetPointSize)
	DEFINE_METHOD(PointSize)
	DEFINE_METHOD(SetPointSizeF)
	DEFINE_METHOD(PointSizeF)
	DEFINE_METHOD(ToString)
	
  // Wrapped object
  QFont* q_;
};

#endif
