#ifndef QIMAGEWRAP_H
#define QIMAGEWRAP_H


#include "../qt.h"

class QImageWrap : public node::ObjectWrap {
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  QImage* GetWrapped() const { return q_; };
  void SetWrapped(QImage *q) { 
    q_ = q;
  };
  static v8::Handle<v8::Value> NewInstance(QImage *q);
  
 private:
  QImageWrap(const v8::Arguments& args);
  ~QImageWrap();
  
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods
	DEFINE_METHOD(destroy)
	DEFINE_METHOD(equals)
	
  DEFINE_METHOD(isNull)
  DEFINE_METHOD(load)
  //DEFINE_METHOD(loadFromData)
  DEFINE_METHOD(save)
  //DEFINE_METHOD(grabWidget)
  //DEFINE_METHOD(grabWindow)
  DEFINE_METHOD(depth)
  DEFINE_METHOD(height)
  DEFINE_METHOD(width)
  DEFINE_METHOD(pixel)
  DEFINE_METHOD(setPixel)
  	
  // Wrapped object
  QImage* q_;
};

#endif
