#ifndef QLISTWIDGETITEMWRAP_H
#define QLISTWIDGETITEMWRAP_H

#include "../qt.h"
#include "../receiver.h"
#include "qvariant.h"
#include <QFileIconProvider>

class QListWidgetItemWrap : public node::ObjectWrap {
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  QListWidgetItem* GetWrapped() const { return q_; };
  void SetWrapped(QListWidgetItem *q) { 
    q_ = q;
  };
  static v8::Handle<v8::Value> NewInstance(QListWidgetItem *q);

 private:
  QListWidgetItemWrap(const v8::Arguments& args);
  ~QListWidgetItemWrap();
  
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods  
	DEFINE_METHOD(destroy)
	DEFINE_METHOD(equals)
	
	DEFINE_METHOD(flags)
	DEFINE_METHOD(isSelected)
	DEFINE_METHOD(setFlags)
	DEFINE_METHOD(setIcon)
	DEFINE_METHOD(setSelected)
	DEFINE_METHOD(setText)
	DEFINE_METHOD(text)
	
	DEFINE_METHOD(font)
	DEFINE_METHOD(setFont)
	
	DEFINE_METHOD(data)
	DEFINE_METHOD(setData)
	
  // Wrapped object
  QListWidgetItem* q_;
};

#endif
