#ifndef QMATRIXWRAP_H
#define QMATRIXWRAP_H


#include "../qt.h"

class QMatrixWrap : public node::ObjectWrap {
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  QMatrix* GetWrapped() const { return q_; };
  void SetWrapped(QMatrix q) { 
    if (q_) delete q_; 
    q_ = new QMatrix(q); 
  };
  static v8::Handle<v8::Value> NewInstance(QMatrix q);

 private:
  QMatrixWrap(const v8::Arguments& args);
  ~QMatrixWrap();
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods
	DEFINE_METHOD(m11)
	DEFINE_METHOD(m12)
	DEFINE_METHOD(m21)
	DEFINE_METHOD(m22)
	DEFINE_METHOD(dx)
	DEFINE_METHOD(dy)
	DEFINE_METHOD(translate)
	DEFINE_METHOD(scale)

	DEFINE_METHOD(destroy)
	
  // Wrapped object
  QMatrix* q_;
};

#endif
