#ifndef QPAINTERWRAP_H
#define QPAINTERWRAP_H


#include "../qt.h"

#include "../QtCore/qrect.h"

class QPainterWrap : public node::ObjectWrap {
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  QPainter* GetWrapped() const { return q_; };

 private:
  QPainterWrap(const v8::Arguments& args);
  ~QPainterWrap();
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  //
  // Wrapped methods exposed to JS
  //

//ACTIONS:
	//- begin (int objectID) -> QPaintDevice: QImage, QPicture, QPixmap, QPrinter
	//- end ()
//
//- drawArc (int x, int y, int width, int height, int startAngle, int spanAngle)
//- drawChord (int x, int y, int width, int height, int startAngle, int spanAngle)
//- drawEllipse (int x, int y, int width, int height)
	//- drawImage (point|rect, img|filename)
//- drawLine (int x1, int y1, int x2, int y2)
//- drawPath (pathList) [see below]
//- drawPicture (int x, int y, int objectID)
//- drawPie (int x, int y, int width, int height, int startAngle, int spanAngle)
//- drawPoint (point)
//- drawPoints (list)
//- drawPolygon (list)
//- drawRect (rect)
//- drawRoundedRect (rect, float xRadius, float yRadius) TODO: mode
	//- drawText (point|rect, text) TODO: options
//
//- strokePath (pathList) [see below] TODO: pen
//- eraseRect (rect)
//- setBackground (color)
//- setBackgroundMode (int)
//- setBrush (color, *int brushStyle)
//- setFont (string descrip) or setFont(string family, int size[, int weight, bool italic])
//- setLayoutDirection (int)
//- setOpacity (float)
//- setPen (color, *int penStyle, float lineWidth)
//- scale (float sx, float sy)
//- rotate (float angle)
//- translate (point)

	//- save ()
	//- restore ()

			//	drawConvexPolygon
			//	drawPixmap
			//	drawStaticText

//PATH OPERATIONS
//- [#moveTo, float x, float y]
//- [#lineTo, float x, float y]
//- [#cubicTo, float c1X, float c1Y, float c2X, float c2Y, float endPointX, float endPointY]
//- [#quadTo,  float cx, float cy, float endPointX, float endPointY]
//- [#arcTo, float x, float y, float width, float height, float startAngle, float sweepLength]
//- [#closeSubpath]

	DEFINE_METHOD(destroy)
	DEFINE_METHOD(equals)
	
  DEFINE_METHOD(begin)
  DEFINE_METHOD(end)
  
  DEFINE_METHOD(save)
  DEFINE_METHOD(restore)

  // DRAW
  DEFINE_METHOD(drawArc)
  DEFINE_METHOD(drawChord)
  DEFINE_METHOD(drawEllipse)
  DEFINE_METHOD(drawImage)
  DEFINE_METHOD(drawLine)
  DEFINE_METHOD(drawPath)
  	//DEFINE_METHOD(drawPicture)
  DEFINE_METHOD(drawPie)
  DEFINE_METHOD(drawPixmap)
  DEFINE_METHOD(drawPoint)
  DEFINE_METHOD(drawPoints)
  DEFINE_METHOD(drawPolygon)
  DEFINE_METHOD(drawRect)
  DEFINE_METHOD(drawRoundedRect)
  DEFINE_METHOD(drawText)
  
//- drawArc (int x, int y, int width, int height, int startAngle, int spanAngle)
//- drawChord (int x, int y, int width, int height, int startAngle, int spanAngle)
//- drawEllipse (int x, int y, int width, int height)
	//- drawImage (point|rect, img|filename)
//- drawLine (int x1, int y1, int x2, int y2)
//- drawPath (pathList) [see below]
//- drawPicture (int x, int y, int objectID)
//- drawPie (int x, int y, int width, int height, int startAngle, int spanAngle)
//- drawPoint (point)
//- drawPoints (list)
//- drawPolygon (list)
//- drawRect (rect)
//- drawRoundedRect (rect, float xRadius, float yRadius) TODO: mode
	//- drawText (point|rect, text) TODO: options
  
  
  DEFINE_METHOD(isActive)
  DEFINE_METHOD(setPen)
  DEFINE_METHOD(setFont)
  DEFINE_METHOD(setMatrix)
  DEFINE_METHOD(fillRect)
  DEFINE_METHOD(strokePath)
  
//  static v8::Handle<v8::Value> Begin(const v8::Arguments& args);
//  static v8::Handle<v8::Value> End(const v8::Arguments& args);
//  static v8::Handle<v8::Value> IsActive(const v8::Arguments& args);
//  static v8::Handle<v8::Value> Save(const v8::Arguments& args);
//  static v8::Handle<v8::Value> Restore(const v8::Arguments& args);
//
//  // State
//  static v8::Handle<v8::Value> SetPen(const v8::Arguments& args);
//  static v8::Handle<v8::Value> SetFont(const v8::Arguments& args);
//  static v8::Handle<v8::Value> SetMatrix(const v8::Arguments& args);
//
//  // Paint actions
//  static v8::Handle<v8::Value> FillRect(const v8::Arguments& args);
//  static v8::Handle<v8::Value> DrawText(const v8::Arguments& args);
//  static v8::Handle<v8::Value> DrawPixmap(const v8::Arguments& args);
//  static v8::Handle<v8::Value> DrawImage(const v8::Arguments& args);
//  static v8::Handle<v8::Value> StrokePath(const v8::Arguments& args);
	
  // Wrapped object
  QPainter* q_;
};

#endif
