#ifndef QPAINTERPATHWRAP_H
#define QPAINTERPATHWRAP_H

#include "../qt.h"

#include "qpointf.h"

class QPainterPathWrap : public node::ObjectWrap {
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  QPainterPath* GetWrapped() const { return q_; };

 private:
  QPainterPathWrap(const v8::Arguments& args);
  ~QPainterPathWrap();
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods
	DEFINE_METHOD(destroy)
	DEFINE_METHOD(equals)
	
  DEFINE_METHOD(closeSubpath)
  DEFINE_METHOD(currentPosition)

  DEFINE_METHOD(arcTo)
  DEFINE_METHOD(cubicTo)
  DEFINE_METHOD(lineTo)
  DEFINE_METHOD(moveTo)
  DEFINE_METHOD(quadTo)
  	
  // Wrapped object
  QPainterPath* q_;
};

#endif
