#ifndef QPALETTEWRAP_H
#define QPALETTEWRAP_H


#include "../qt.h"

class QPaletteWrap : public node::ObjectWrap {
	
	public:
	static void Initialize(v8::Handle<v8::Object> target);
	QPalette* GetWrapped() const { return q_; };		
  void SetWrapped(QPalette q) { 
    if (q_) delete q_; 
    q_ = new QPalette(q); 
  };
	static v8::Handle<v8::Value> NewInstance(QPalette q);
	
	private:
	QPaletteWrap(const v8::Arguments& args);
	~QPaletteWrap();
	
	static v8::Persistent<v8::Function> constructor;
	static v8::Handle<v8::Value> New(const v8::Arguments& args);
		
//		const QColor & 	color ( ColorRole role ) const
//		setColor ( ColorRole role, const QColor & color )
		
	// Wrapped methods
	DEFINE_METHOD(destroy)
	DEFINE_METHOD(equals)
	
	DEFINE_METHOD(color)
	DEFINE_METHOD(setColor)
			
	// Wrapped object
	QPalette* q_;
};

#endif
