#ifndef QPIXMAPWRAP_H
#define QPIXMAPWRAP_H


#include "../qt.h"

#include "qcolor.h"

class QPixmapWrap : public node::ObjectWrap {
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  static v8::Handle<v8::Value> NewInstance(QPixmap q);
  QPixmap* GetWrapped() const { return q_; };
  void SetWrapped(QPixmap q) { 
    if (q_) delete q_; 
    q_ = new QPixmap(q); 
  };

 private:
  QPixmapWrap(int width, int height);
  ~QPixmapWrap();
  
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods
	DEFINE_METHOD(destroy)
	DEFINE_METHOD(equals)
	
  DEFINE_METHOD(width)
	DEFINE_METHOD(height)
	DEFINE_METHOD(save)
	DEFINE_METHOD(fill)

	DEFINE_METHOD(load)
	//DEFINE_METHOD(loadFromData)
	
	// STATIC
//	fromImage
//	grabWidget
//	grabWindow

  // Wrapped object
  QPixmap* q_;
};

#endif
