#include "qpoint.h"

using namespace v8;

Persistent<Function> QPointWrap::constructor;

QPointWrap::QPointWrap(const Arguments& args) : q_(NULL) {
  if (args[0]->IsNumber() && args[1]->IsNumber()) {
    q_ = new QPoint(args[0]->IntegerValue(), args[1]->IntegerValue());
  } else {
    q_ = new QPoint;
  }
}

QPointWrap::~QPointWrap() {
  //delete q_;
}

void QPointWrap::Initialize(Handle<Object> target) {
  // Prepare constructor template
  Local<FunctionTemplate> tpl = FunctionTemplate::New(New);
  tpl->SetClassName(String::NewSymbol("QPoint"));
  tpl->InstanceTemplate()->SetInternalFieldCount(1);  

  // Wrapped methods
	ADD_METHOD(destroy)
	// ADD_METHOD(equals)
	
	ADD_METHOD(x)
	ADD_METHOD(y)
		
  constructor = Persistent<Function>::New(tpl->GetFunction());
  target->Set(String::NewSymbol("QPoint"), constructor);
}

Handle<Value> QPointWrap::New(const Arguments& args) {
  HandleScope scope;
  
  QPointWrap* w = new QPointWrap(args);// 
  w->Wrap(args.This());
  return args.This();
}

Handle<Value> QPointWrap::NewInstance(QPoint q) {
  HandleScope scope;
  
  Local<Object> instance = constructor->NewInstance(0, NULL);
  QPointWrap* w = node::ObjectWrap::Unwrap<QPointWrap>(instance);
  w->SetWrapped(q);

  return scope.Close(instance);
}

//Handle<Value> QPointWrap::On(const Arguments& args) {	
//	HandleScope scope;
////	if (!args[1]->IsFunction()) {
////		return ThrowException(Exception::TypeError(String::New("Second argument must be a callback function")));
////	}
//	
//	// There's no ToFunction(), use a Cast instead.
//	Local<Function> callback = Local<Function>::Cast(args[1]);
//
//	QPointWrap* w = ObjectWrap::Unwrap<QPointWrap>(args.This());
//	QPoint* q = w->GetWrapped();
//	
//	return args.This(); // return action ?
//}

Handle<Value> QPointWrap::x(const Arguments& args) {
  HandleScope scope;
  QPointWrap* w = ObjectWrap::Unwrap<QPointWrap>(args.This());
  QPoint* q = w->GetWrapped();
  return scope.Close(Integer::New(q->x()));
}

Handle<Value> QPointWrap::y(const Arguments& args) {
  HandleScope scope;
  QPointWrap* w = ObjectWrap::Unwrap<QPointWrap>(args.This());
  QPoint* q = w->GetWrapped();
  return scope.Close(Integer::New(q->y()));
}

Handle<Value> QPointWrap::destroy(const Arguments& args) {
  HandleScope scope;
  QPointWrap* w = ObjectWrap::Unwrap<QPointWrap>(args.This());
  QPoint* q = w->GetWrapped();
	delete q;
  return scope.Close(Undefined());
}