#ifndef QPOINTWRAP_H
#define QPOINTWRAP_H


#include "../qt.h"

class QPointWrap : public node::ObjectWrap {
	
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  QPoint* GetWrapped() const { return q_; };
  void SetWrapped(QPoint q) { 
    if (q_) delete q_; 
    q_ = new QPoint(q);
  };
  static v8::Handle<v8::Value> NewInstance(QPoint q);
  
 private:
  QPointWrap(const v8::Arguments& args);
  ~QPointWrap();
  
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods  
	DEFINE_METHOD(x)
	DEFINE_METHOD(y)
	
	DEFINE_METHOD(destroy)
	
  // Wrapped object
  QPoint* q_;
};

#endif
