#ifndef QPOINTFWRAP_H
#define QPOINTFWRAP_H


#include "../qt.h"

class QPointFWrap : public node::ObjectWrap {
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  QPointF* GetWrapped() const { return q_; };
  void SetWrapped(QPointF q) { 
    if (q_) delete q_; 
    q_ = new QPointF(q); 
  };
  static v8::Handle<v8::Value> NewInstance(QPointF q);

 private:
  QPointFWrap(const v8::Arguments& args);
  ~QPointFWrap();
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods
//  static v8::Handle<v8::Value> IsNull(const v8::Arguments& args);
//  static v8::Handle<v8::Value> X(const v8::Arguments& args);
//  static v8::Handle<v8::Value> Y(const v8::Arguments& args);

	DEFINE_METHOD(x)
	DEFINE_METHOD(y)
	DEFINE_METHOD(isNull)
	
	DEFINE_METHOD(destroy)
	
  // Wrapped object
  QPointF* q_;
};

#endif
