#include "qrect.h"

using namespace v8;

Persistent<Function> QRectWrap::constructor;

QRectWrap::QRectWrap(const Arguments& args) : q_(NULL) {
  if (args[0]->IsNumber() && args[1]->IsNumber() && args[2]->IsNumber() && args[3]->IsNumber()) {
    q_ = new QRect(args[0]->IntegerValue(), args[1]->IntegerValue(), args[2]->IntegerValue(), args[3]->IntegerValue());
  } else {
    q_ = new QRect;
  }
}

QRectWrap::~QRectWrap() {
  //delete q_;
}

void QRectWrap::Initialize(Handle<Object> target) {
  // Prepare constructor template
  Local<FunctionTemplate> tpl = FunctionTemplate::New(New);
  tpl->SetClassName(String::NewSymbol("QRect"));
  tpl->InstanceTemplate()->SetInternalFieldCount(1);  

  // Wrapped methods
	ADD_METHOD(destroy)
	// ADD_METHOD(equals)
	
	ADD_METHOD(x)
	ADD_METHOD(y)
	ADD_METHOD(width)
	ADD_METHOD(height)
		
  constructor = Persistent<Function>::New(tpl->GetFunction());
  target->Set(String::NewSymbol("QRect"), constructor);
}

Handle<Value> QRectWrap::New(const Arguments& args) {
  HandleScope scope;
  
  QRectWrap* w = new QRectWrap(args);// 
  w->Wrap(args.This());
  return args.This();
}

//org
//Handle<Value> QRectWrap::NewInstance(QRect *q) {
//  HandleScope scope;
//  
//  Local<Object> instance = constructor->NewInstance(0, NULL);
//  QRectWrap* w = node::ObjectWrap::Unwrap<QRectWrap>(instance);
//  w->SetWrapped(q);
//
//  return scope.Close(instance);
//}

Handle<Value> QRectWrap::NewInstance(QRect q) {
  HandleScope scope;
  
  Local<Object> instance = constructor->NewInstance(0, NULL);
  QRectWrap* w = node::ObjectWrap::Unwrap<QRectWrap>(instance);
  w->SetWrapped(q);

  return scope.Close(instance);
}

//Handle<Value> QRectWrap::On(const Arguments& args) {
//	HandleScope scope;
////	if (!args[1]->IsFunction()) {
////		return ThrowException(Exception::TypeError(String::New("Second argument must be a callback function")));
////	}
//	
//	// There's no ToFunction(), use a Cast instead.
//	Local<Function> callback = Local<Function>::Cast(args[1]);
//
//	QRectWrap* w = ObjectWrap::Unwrap<QRectWrap>(args.This());
//	QRect* q = w->GetWrapped();
//	
//	return args.This(); // return action ?
//}

Handle<Value> QRectWrap::x(const Arguments& args) {
  HandleScope scope;
  QRectWrap* w = ObjectWrap::Unwrap<QRectWrap>(args.This());
  QRect* q = w->GetWrapped();
  return scope.Close(Integer::New(q->x()));
}

Handle<Value> QRectWrap::y(const Arguments& args) {
  HandleScope scope;
  QRectWrap* w = ObjectWrap::Unwrap<QRectWrap>(args.This());
  QRect* q = w->GetWrapped();
  return scope.Close(Integer::New(q->y()));
}

Handle<Value> QRectWrap::width(const Arguments& args) {
  HandleScope scope;
  QRectWrap* w = ObjectWrap::Unwrap<QRectWrap>(args.This());
  QRect* q = w->GetWrapped();
  return scope.Close(Integer::New(q->width()));
}

Handle<Value> QRectWrap::height(const Arguments& args) {
  HandleScope scope;
  QRectWrap* w = ObjectWrap::Unwrap<QRectWrap>(args.This());
  QRect* q = w->GetWrapped();
  return scope.Close(Integer::New(q->height()));
}

Handle<Value> QRectWrap::destroy(const Arguments& args) {
  HandleScope scope;
  QRectWrap* w = ObjectWrap::Unwrap<QRectWrap>(args.This());
  QRect* q = w->GetWrapped();
	delete q;
  return scope.Close(Undefined());
}