#ifndef QRECTWRAP_H
#define QRECTWRAP_H


#include "../qt.h"

class QRectWrap : public node::ObjectWrap {
 public:
	static void Initialize(v8::Handle<v8::Object> target);
	QRect* GetWrapped() const { return q_; };		
  void SetWrapped(QRect q) { 
    if (q_) delete q_; 
    q_ = new QRect(q); 
  };

	static v8::Handle<v8::Value> NewInstance(QRect q);
	
 private:
	QRectWrap(const v8::Arguments& args);
	~QRectWrap();
	
	static v8::Persistent<v8::Function> constructor;
	static v8::Handle<v8::Value> New(const v8::Arguments& args);
	
	// Wrapped methods		
	DEFINE_METHOD(destroy)
	
	DEFINE_METHOD(x)
	DEFINE_METHOD(y)
	DEFINE_METHOD(width)
	DEFINE_METHOD(height)

	// Wrapped object
	QRect* q_;
};

#endif
