
#include "qsize.h"

using namespace v8;

//static
Persistent<Function> QSizeWrap::constructor;

QSizeWrap::QSizeWrap() : q_(NULL) {
  // Standalone constructor not implemented
  // Use SetWrapped()  
}

QSizeWrap::~QSizeWrap() {
  //delete q_;
}

//static
void QSizeWrap::Initialize(Handle<Object> target) {
  // Prepare constructor template
  Local<FunctionTemplate> tpl = FunctionTemplate::New(New);
  tpl->SetClassName(String::NewSymbol("QSize"));
  tpl->InstanceTemplate()->SetInternalFieldCount(1);  

  // Prototype
	ADD_METHOD(destroy)
	// ADD_METHOD(equals)
	
	ADD_METHOD(width)
	ADD_METHOD(height)
	
  constructor = Persistent<Function>::New(tpl->GetFunction());
  target->Set(String::NewSymbol("QSize"), constructor);
}

//static
Handle<Value> QSizeWrap::New(const Arguments& args) {
  HandleScope scope;

  QSizeWrap* w = new QSizeWrap();
  w->Wrap(args.This());

  return args.This();
}

//static
Handle<Value> QSizeWrap::NewInstance(QSize q) {
  HandleScope scope;
  
  Local<Object> instance = constructor->NewInstance(0, NULL);
  QSizeWrap* w = node::ObjectWrap::Unwrap<QSizeWrap>(instance);
  w->SetWrapped(q);

  return scope.Close(instance);
}

Handle<Value> QSizeWrap::width(const Arguments& args) {
  HandleScope scope;

  QSizeWrap* w = ObjectWrap::Unwrap<QSizeWrap>(args.This());
  QSize* q = w->GetWrapped();

  return scope.Close(Number::New(q->width()));
}

Handle<Value> QSizeWrap::height(const Arguments& args) {
  HandleScope scope;

  QSizeWrap* w = ObjectWrap::Unwrap<QSizeWrap>(args.This());
  QSize* q = w->GetWrapped();

  return scope.Close(Number::New(q->height()));
}

Handle<Value> QSizeWrap::destroy(const Arguments& args) {
  HandleScope scope;
  QSizeWrap* w = ObjectWrap::Unwrap<QSizeWrap>(args.This());
  QSize* q = w->GetWrapped();
	delete q;
  return scope.Close(Undefined());
}
