#ifndef QSIZEWRAP_H
#define QSIZEWRAP_H


#include "../qt.h"

class QSizeWrap : public node::ObjectWrap {
	
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  static v8::Handle<v8::Value> NewInstance(QSize q);
  QSize* GetWrapped() const { return q_; };
  void SetWrapped(QSize q) { 
    if (q_) delete q_; 
    q_ = new QSize(q); 
  };

 private:
  QSizeWrap();
  ~QSizeWrap();
  
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods
	DEFINE_METHOD(width)
	DEFINE_METHOD(height)

	DEFINE_METHOD(destroy)
	
  // Wrapped object
  QSize* q_;
};

#endif
