#ifndef QTABLEWIDGETITEMWRAP_H
#define QTABLEWIDGETITEMWRAP_H

#include "../qt.h"
#include "../receiver.h"
#include "qimage.h"
#include "qvariant.h"
#include <QFileIconProvider>


class QTableWidgetItemWrap : public node::ObjectWrap {
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  QTableWidgetItem* GetWrapped() const { return q_; };
  void SetWrapped(QTableWidgetItem *q) { 
    q_ = q;
  };
  static v8::Handle<v8::Value> NewInstance(QTableWidgetItem *q);

 private:
  QTableWidgetItemWrap(const v8::Arguments& args);
  ~QTableWidgetItemWrap();
  
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods 
	DEFINE_METHOD(destroy)
	DEFINE_METHOD(equals)
	
	DEFINE_METHOD(flags)
	DEFINE_METHOD(isSelected)
	DEFINE_METHOD(setFlags)
	DEFINE_METHOD(setIcon)
	DEFINE_METHOD(setSelected)
	DEFINE_METHOD(setText)
	//DEFINE_METHOD(setData)
	DEFINE_METHOD(text)
	DEFINE_METHOD(column)
	DEFINE_METHOD(row)
	DEFINE_METHOD(font)
	DEFINE_METHOD(setFont)
	DEFINE_METHOD(setTextAlignment)
	
	DEFINE_METHOD(data)
	DEFINE_METHOD(setData)
	
	// CUSTOM
//	DEFINE_METHOD(setNumber)
//	DEFINE_METHOD(setDate)
//	DEFINE_METHOD(getNumber)
//	DEFINE_METHOD(getDate)
	
	DEFINE_METHOD(setFolder)
	DEFINE_METHOD(setFile)
	DEFINE_METHOD(isFolder)
	

	
//TODO
//
//	setStatusTip 
//	statusTip
//	
//	icon
//	
//	background
//	setBackground
//	
//	foreground
//	setForeground
	
  // Wrapped object
  QTableWidgetItem* q_;
};

#endif
