#include "qtouchpoint.h"
#include "qpointf.h"

using namespace v8;

Persistent<Function> QTouchPointWrap::constructor;

QTouchPointWrap::QTouchPointWrap(const Arguments& args) : q_(NULL) {
  //q_ = new QTouchPoint;
}

QTouchPointWrap::~QTouchPointWrap() {
  //delete q_;
}

void QTouchPointWrap::Initialize(Handle<Object> target) {
  // Prepare constructor template
  Local<FunctionTemplate> tpl = FunctionTemplate::New(New);
  tpl->SetClassName(String::NewSymbol("QTouchPoint"));
  tpl->InstanceTemplate()->SetInternalFieldCount(1);  

  // Wrapped methods
	ADD_METHOD(destroy)
//	ADD_METHOD(equals)
	
	ADD_METHOD(id)
	ADD_METHOD(lastNormalizedPos)
	ADD_METHOD(lastPos)
		
  constructor = Persistent<Function>::New(tpl->GetFunction());
  target->Set(String::NewSymbol("QTouchPoint"), constructor);
}

Handle<Value> QTouchPointWrap::New(const Arguments& args) {
  HandleScope scope;
  QTouchPointWrap* w = new QTouchPointWrap(args);// 
  w->Wrap(args.This());
  
  return args.This();
}

Handle<Value> QTouchPointWrap::NewInstance(QTouchEvent::TouchPoint *q) {//
  HandleScope scope;
  
  Local<Object> instance = constructor->NewInstance(0, NULL);
  QTouchPointWrap* w = node::ObjectWrap::Unwrap<QTouchPointWrap>(instance);
  w->SetWrapped(q);
  
  return scope.Close(instance);
}

Handle<Value> QTouchPointWrap::destroy(const Arguments& args) {
  HandleScope scope;
  QTouchPointWrap* w = ObjectWrap::Unwrap<QTouchPointWrap>(args.This());
  QTouchEvent::TouchPoint* q = w->GetWrapped();
  
	delete q;
  return scope.Close(Undefined());
}

// equals
//Handle<Value> QTouchPointWrap::equals(const Arguments& args) {
//  HandleScope scope;
//  QTouchPointWrap* w = ObjectWrap::Unwrap<QTouchPointWrap>(args.This());
//  QTouchPointWrap* w2 = ObjectWrap::Unwrap<QTouchPointWrap>(args[0]->ToObject());
//  
//  return scope.Close(Boolean::New( *w->GetWrapped()==*w2->GetWrapped() ));
//}

// id() -> int
Handle<Value> QTouchPointWrap::id(const Arguments& args) {
  HandleScope scope;
  QTouchPointWrap* w = ObjectWrap::Unwrap<QTouchPointWrap>(args.This());
  QTouchEvent::TouchPoint* q = w->GetWrapped();
  
  return scope.Close(Integer::New(q->id()));
}

// lastNormalizedPos () -> QPointF
Handle<Value> QTouchPointWrap::lastNormalizedPos(const Arguments& args) {
  HandleScope scope;
  QTouchPointWrap* w = ObjectWrap::Unwrap<QTouchPointWrap>(args.This());
  QTouchEvent::TouchPoint* q = w->GetWrapped();
  
  return scope.Close( QPointFWrap::NewInstance(q->lastNormalizedPos()) );
}

// lastPos () -> QPointF
Handle<Value> QTouchPointWrap::lastPos(const Arguments& args) {
  HandleScope scope;
  QTouchPointWrap* w = ObjectWrap::Unwrap<QTouchPointWrap>(args.This());
  QTouchEvent::TouchPoint* q = w->GetWrapped();
    
  return scope.Close( QPointFWrap::NewInstance(q->lastPos()) );
}
