#ifndef QTOUCHPOINTWRAP_H
#define QTOUCHPOINTWRAP_H

#include "../qt.h"
#include <QTouchEvent>

class QTouchPointWrap : public node::ObjectWrap {
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  QTouchEvent::TouchPoint* GetWrapped() const { return q_; };
  void SetWrapped(QTouchEvent::TouchPoint *q) {
    q_ = q;
  };
  static v8::Handle<v8::Value> NewInstance(QTouchEvent::TouchPoint *q);

 private:
  QTouchPointWrap(const v8::Arguments& args);
  ~QTouchPointWrap();
  
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods 
	DEFINE_METHOD(destroy)
//	DEFINE_METHOD(equals)
	
	DEFINE_METHOD(id)
	DEFINE_METHOD(lastNormalizedPos)
	DEFINE_METHOD(lastPos)
	
  // Wrapped object
  QTouchEvent::TouchPoint* q_;
};

#endif
