#ifndef QTREEWIDGETITEMWRAP_H
#define QTREEWIDGETITEMWRAP_H

#include "../qt.h"
#include "../receiver.h"
#include "qimage.h"
#include "qvariant.h"
#include <QFileIconProvider>

class QTreeWidgetItemWrap : public node::ObjectWrap {
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  QTreeWidgetItem* GetWrapped() const { return q_; };
  void SetWrapped(QTreeWidgetItem *q) { 
    q_ = q;
  };
  static v8::Handle<v8::Value> NewInstance(QTreeWidgetItem *q);

	//test
//	bool operator== (const QTreeWidgetItemWrap & b) const{
//		return (q_ == b.q_);
//	}

	
 private:
  QTreeWidgetItemWrap(const v8::Arguments& args);
  ~QTreeWidgetItemWrap();
  
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods
	DEFINE_METHOD(destroy)
	DEFINE_METHOD(equals)
	
  DEFINE_METHOD(addChild)
  DEFINE_METHOD(child)
	DEFINE_METHOD(flags)
	DEFINE_METHOD(isSelected)
	DEFINE_METHOD(setFlags)
	DEFINE_METHOD(setIcon)
	DEFINE_METHOD(setSelected)
	DEFINE_METHOD(setText)
	DEFINE_METHOD(text)
		
	DEFINE_METHOD(font)
	DEFINE_METHOD(setFont)
	
	DEFINE_METHOD(removeChild)
	
	DEFINE_METHOD(childCount)
	
	DEFINE_METHOD(data)
	DEFINE_METHOD(setData)
	
	DEFINE_METHOD(parent)
		
	DEFINE_METHOD(setExpanded)
	
//TODO
//
//	setStatusTip 
//	statusTip
//	
//	icon
//	
//	background
//	setBackground
//	
//	foreground
//	setForeground
	
	 
  // Wrapped object
  QTreeWidgetItem* q_;
};

#endif
