#ifndef QVARIANTWRAP_H
#define QVARIANTWRAP_H

#include "../qt.h"

class QVariantWrap : public node::ObjectWrap {
	
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  
  static v8::Handle<v8::Value> NewInstance(QVariant q);
  
  QVariant* GetWrapped() const { return q_; };
  
  void SetWrapped(QVariant q) { 
    if (q_) delete q_; 
    q_ = new QVariant(q); 
  };

 private:
  QVariantWrap(const v8::Arguments& args);
  ~QVariantWrap();
  
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods
	//DEFINE_METHOD(destroy)
	
	DEFINE_METHOD(toBool)
	DEFINE_METHOD(toInt)
	DEFINE_METHOD(toFloat)
	DEFINE_METHOD(toString)
	DEFINE_METHOD(toDateTime)
	DEFINE_METHOD(toBuffer)
	
  // Wrapped object
  QVariant* q_;
};

#endif
