#ifndef QCOLORDIALOGWRAP_H
#define QCOLORDIALOGWRAP_H


#include "../qwidget.h"
#include "qdialogtpl.h"

/*************************************************
 QColorDialogWrap
*************************************************/

class QColorDialogWrap : public node::ObjectWrap {
	
 public:
  static void Initialize(v8::Handle<v8::Object> target);
	QColorDialog* GetWrapped() const { return q_; };
	void SetWrapped(QColorDialog *q) { q_ = q;	};
	static v8::Handle<v8::Value> NewInstance(QColorDialog *q);
	bool hasEvents;
	
 private:
  QColorDialogWrap(const v8::Arguments& args);
  ~QColorDialogWrap();
  
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods
  DEFINE_METHOD(on)
  DEFINE_METHOD(off)
  
	// OWN METHODS  
  DEFINE_METHOD(currentColor)
  DEFINE_METHOD(selectedColor)
  DEFINE_METHOD(setCurrentColor)

  // STATIC
  DEFINE_METHOD(getColor)
  
  // Wrapped object
  QColorDialog* q_;
};

#endif