#ifndef QDIALOGWRAP_H
#define QDIALOGWRAP_H


#include "../qwidget.h"
#include "qdialogtpl.h"

/*************************************************
 QDialogWrap
*************************************************/

class QDialogWrap : public node::ObjectWrap {
	
 public:
  static void Initialize(v8::Handle<v8::Object> target);
	QDialog* GetWrapped() const { return q_; };
	void SetWrapped(QDialog *q) { q_ = q;	};
	static v8::Handle<v8::Value> NewInstance(QDialog *q);
	bool hasEvents;
	
 private:
  QDialogWrap(const v8::Arguments& args);
  ~QDialogWrap();
  
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods
  DEFINE_METHOD(on)
  DEFINE_METHOD(off)
  
//  DEFINE_METHOD(result)
//  DEFINE_METHOD(setModal)
//  DEFINE_METHOD(setResult)
//  DEFINE_METHOD(setSizeGripEnabled)
//  
//  DEFINE_METHOD(exec)
//  DEFINE_METHOD(open)
  
  // Wrapped object
  QDialog* q_;
};

#endif