#ifndef QDIALOGTPL_H
#define QDIALOGTPL_H


#include "../../qt.h"

using namespace std;
using namespace v8;

#define ADD_METHOD_DIALOG_TPL(X,Y,Z) tpl->PrototypeTemplate()->Set(String::NewSymbol(#X), FunctionTemplate::New(QDialogTpl<Y,Z>::X)->GetFunction());

#define ADD_DIALOG_METHODS(TWC,TIC) \
	ADD_METHOD_DIALOG_TPL(exec,TWC,TIC) \
	ADD_METHOD_DIALOG_TPL(open,TWC,TIC) \
	ADD_METHOD_DIALOG_TPL(result,TWC,TIC) \
	ADD_METHOD_DIALOG_TPL(setModal,TWC,TIC) \
	ADD_METHOD_DIALOG_TPL(setResult,TWC,TIC) \
	ADD_METHOD_DIALOG_TPL(setSizeGripEnabled,TWC,TIC)
	
template<class TW, class TI> class QDialogTpl{
	
 public:
  DEFINE_METHOD(exec)
  DEFINE_METHOD(open)
  DEFINE_METHOD(result)
  DEFINE_METHOD(setModal)
  DEFINE_METHOD(setResult)
  DEFINE_METHOD(setSizeGripEnabled)

};

// exec () -> int
template<class TW, class TI> 
Handle<Value> QDialogTpl<TW,TI>::exec(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
	return scope.Close(Integer::New(q->exec()));
}

// open ()
template<class TW, class TI> 
Handle<Value> QDialogTpl<TW,TI>::open(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
	q->open();
  return scope.Close(Undefined());
}

// result () -> int
template<class TW, class TI> 
Handle<Value> QDialogTpl<TW,TI>::result(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
	return scope.Close(Integer::New(q->result()));
}

// setModal (bool modal)
template<class TW, class TI> 
Handle<Value> QDialogTpl<TW,TI>::setModal(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
	q->setModal(args[0]->BooleanValue());
  return scope.Close(Undefined());
}

// setResult (int i)
template<class TW, class TI> 
Handle<Value> QDialogTpl<TW,TI>::setResult(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
	q->setResult(args[0]->IntegerValue());
  return scope.Close(Undefined());
}

// setSizeGripEnabled (bool)
template<class TW, class TI> 
Handle<Value> QDialogTpl<TW,TI>::setSizeGripEnabled(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
	q->setSizeGripEnabled(args[0]->BooleanValue());
  return scope.Close(Undefined());
}

#endif