#ifndef QFILEDIALOGWRAP_H
#define QFILEDIALOGWRAP_H


#include "../qwidget.h"
#include "qdialogtpl.h"

/*************************************************
 QFileDialogWrap
*************************************************/

class QFileDialogWrap : public node::ObjectWrap {
	
 public:
  static void Initialize(v8::Handle<v8::Object> target);
	QFileDialog* GetWrapped() const { return q_; };
	void SetWrapped(QFileDialog *q) { q_ = q;	};
	static v8::Handle<v8::Value> NewInstance(QFileDialog *q);
	bool hasEvents;
	
 private:
  QFileDialogWrap(const v8::Arguments& args);
  ~QFileDialogWrap();
  
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods
  DEFINE_METHOD(on)
  DEFINE_METHOD(off)
  
  // OWN METHODS
	DEFINE_METHOD(setAcceptMode)
	DEFINE_METHOD(setDefaultSuffix)
	DEFINE_METHOD(setDirectory)
	DEFINE_METHOD(setFileMode)
	DEFINE_METHOD(setFilter)
	DEFINE_METHOD(setLabelText)
	DEFINE_METHOD(setNameFilters)
	DEFINE_METHOD(setOption)
	DEFINE_METHOD(setSidebarUrls)
	DEFINE_METHOD(setViewMode)
	
  // STATIC
  DEFINE_METHOD(getOpenFileName)
  DEFINE_METHOD(getSaveFileName)
  DEFINE_METHOD(getExistingDirectory)
    
  // Wrapped object
  QFileDialog* q_;
};

#endif