#ifndef QINPUTDIALOGWRAP_H
#define QINPUTDIALOGWRAP_H


#include "../qwidget.h"
#include "qdialogtpl.h"

/*************************************************
 QInputDialog
*************************************************/

class QInputDialogWrap : public node::ObjectWrap {
	
 public:
  static void Initialize(v8::Handle<v8::Object> target);
	QInputDialog* GetWrapped() const { return q_; };
	void SetWrapped(QInputDialog *q) { q_ = q;	};
	static v8::Handle<v8::Value> NewInstance(QInputDialog *q);
	bool hasEvents;
	
 private:
  QInputDialogWrap(const v8::Arguments& args);
  ~QInputDialogWrap();
  
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods
  DEFINE_METHOD(on)
  DEFINE_METHOD(off)
  
  // OWN METHODS
  DEFINE_METHOD(setCancelButtonText)
  DEFINE_METHOD(setLabelText)
  DEFINE_METHOD(setOkButtonText)
  DEFINE_METHOD(setOption)
  DEFINE_METHOD(setTextValue)

  // STATIC
  DEFINE_METHOD(getText)
  
  // Wrapped object
  QInputDialog* q_;
};

#endif