#ifndef QMESSAGEBOXWRAP_H
#define QMESSAGEBOXWRAP_H

#include "../qwidget.h"
#include "qdialogtpl.h"
#include "../qpushbutton.h"

/*************************************************
 QMessageBoxWrap
*************************************************/

class QMessageBoxWrap : public node::ObjectWrap {
	
 public:
  static void Initialize(v8::Handle<v8::Object> target);
	QMessageBox* GetWrapped() const { return q_; };
	void SetWrapped(QMessageBox *q) { q_ = q;	};
	static v8::Handle<v8::Value> NewInstance(QMessageBox *q);
	bool hasEvents;
	
 private:
  QMessageBoxWrap(const v8::Arguments& args);
  ~QMessageBoxWrap();
  
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods
  DEFINE_METHOD(on)
  DEFINE_METHOD(off)
  
  // OWN METHODS
  DEFINE_METHOD(setDetailedText)
  DEFINE_METHOD(setIcon)
  DEFINE_METHOD(setStandardButtons)
  DEFINE_METHOD(setText)
  DEFINE_METHOD(setTextFormat)
  
  DEFINE_METHOD(setInformativeText)
  DEFINE_METHOD(setDefaultButton)
  DEFINE_METHOD(exec)
  
  DEFINE_METHOD(addButton)
  
  // C) STATIC FUNCTIONS
  DEFINE_METHOD(about)
  DEFINE_METHOD(aboutQt)
  DEFINE_METHOD(critical)
  DEFINE_METHOD(information)
  DEFINE_METHOD(question)
  DEFINE_METHOD(warning)
  
  // Wrapped object
  QMessageBox* q_;
};

#endif