#ifndef QPROGRESSDIALOGWRAP_H
#define QPROGRESSDIALOGWRAP_H


#include "../qwidget.h"
#include "qdialogtpl.h"

/*************************************************
 QProgressDialogWrap
*************************************************/

class QProgressDialogWrap : public node::ObjectWrap {
	
 public:
  static void Initialize(v8::Handle<v8::Object> target);
	QProgressDialog* GetWrapped() const { return q_; };
	void SetWrapped(QProgressDialog *q) { q_ = q;	};
	static v8::Handle<v8::Value> NewInstance(QProgressDialog *q);
	bool hasEvents;
	
 private:
  QProgressDialogWrap(const v8::Arguments& args);
  ~QProgressDialogWrap();
  
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods
  DEFINE_METHOD(on)
  DEFINE_METHOD(off)
  
	// OWN METHODS  
//- setAutoClose (bool)
//- setAutoReset (bool)
//- setCancelButtonText (string)
//- setLabelText (string)
//- setMaximum (int)
//- setMinimum (int)
//- setValue (int)

  DEFINE_METHOD(setAutoClose)
  DEFINE_METHOD(setAutoReset)
  DEFINE_METHOD(setCancelButtonText)
  DEFINE_METHOD(setLabelText)
  DEFINE_METHOD(setMaximum)
  DEFINE_METHOD(setMinimum)
  DEFINE_METHOD(setValue)
  
  // STATIC
  //DEFINE_METHOD(getColor)
  
  // Wrapped object
  QProgressDialog* q_;
};

#endif