#ifndef QWIZARDWRAP_H
#define QWIZARDWRAP_H


#include "../qwidget.h"
#include "qdialogtpl.h"

/*************************************************
 QWizardWrap
*************************************************/

class QWizardWrap : public node::ObjectWrap {
	
 public:
  static void Initialize(v8::Handle<v8::Object> target);
	QWizard* GetWrapped() const { return q_; };
	void SetWrapped(QWizard *q) { q_ = q;	};
	static v8::Handle<v8::Value> NewInstance(QWizard *q);
	bool hasEvents;
	
 private:
  QWizardWrap(const v8::Arguments& args);
  ~QWizardWrap();
  
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods
  DEFINE_METHOD(on)
  DEFINE_METHOD(off)
  
  // OWN METHODS
  DEFINE_METHOD(addPage)
  DEFINE_METHOD(page)
  DEFINE_METHOD(removePage)
  
  // STATIC
  
  // Wrapped object
  QWizard* q_;
};

#endif