
#include "qsvgwidget.h"

using namespace v8;
	
Persistent<Function> QSvgWidgetWrap::constructor;

QSvgWidgetWrap::QSvgWidgetWrap(const Arguments& args) : q_(NULL){ //	QWidget* parent
	q_ = new QSvgWidget(); // parent
}

QSvgWidgetWrap::~QSvgWidgetWrap() {
  //delete q_;
}

void QSvgWidgetWrap::Initialize(Handle<Object> target) {
  // Prepare constructor template
  Local<FunctionTemplate> tpl = FunctionTemplate::New(New);
  tpl->SetClassName(String::NewSymbol("QSvgWidget"));
  tpl->InstanceTemplate()->SetInternalFieldCount(1);

  // Wrapped methods
  ADD_METHOD(on)
  ADD_METHOD(off)
  
	ADD_METHOD(load)
	//ADD_METHOD(loadData)
	
	// geerbt
	ADD_WIDGET_METHODS(QSvgWidgetWrap, QSvgWidget)

  constructor = Persistent<Function>::New(tpl->GetFunction());
  target->Set(String::NewSymbol("QSvgWidget"), constructor);
}

Handle<Value> QSvgWidgetWrap::New(const Arguments& args) {
  HandleScope scope;

//  QWidget* q_parent = 0;
//  if (args.Length() > 0) {
//    QWidgetWrap* w_parent = node::ObjectWrap::Unwrap<QWidgetWrap>(args[0]->ToObject()); // ???
//    q_parent = w_parent->GetWrapped();
//  }
//  QSvgWidgetWrap* w = new QSvgWidgetWrap(q_parent);
  
  QSvgWidgetWrap* w = new QSvgWidgetWrap(args);
  w->Wrap(args.This());

  return args.This();
}

Handle<Value> QSvgWidgetWrap::NewInstance(QSvgWidget *q) {
  HandleScope scope;

  Local<Object> instance = constructor->NewInstance(0, NULL);
  QSvgWidgetWrap* w = node::ObjectWrap::Unwrap<QSvgWidgetWrap>(instance);
  w->SetWrapped(q);

  return scope.Close(instance);
}

Handle<Value> QSvgWidgetWrap::on(const Arguments& args) {
	HandleScope scope;
	ASSERT_TYPE(args[0],IsString);
	ASSERT_TYPE(args[1],IsFunction);
	
	QString sign = qt_v8::ToQString(args[0]->ToString());
	Local<Function> callback = Local<Function>::Cast(args[1]);

  QSvgWidgetWrap* w = ObjectWrap::Unwrap<QSvgWidgetWrap>(args.This());
  //QSvgWidget* q = w->GetWrapped();
	QImpl<QSvgWidget>* q = (QImpl<QSvgWidget>*)(w->GetWrapped());
	
	Receiver* rec = new Receiver(callback, args.This());
	
	// SIGNALS
	if (sign=="customContextMenuRequested") //WIDGET
		QObject::connect(q, SIGNAL(customContextMenuRequested(const QPoint &)), rec, SLOT(evtP(const QPoint &)));

	else {
		delete rec;
		rec = 0;
		HANDLE_WIDGET_EVENTS
  }
	
	//return args.This();
	return scope.Close(rec ? QObjectWrap::NewInstance(rec) : Undefined());
}

Handle<Value> QSvgWidgetWrap::off(const Arguments& args) {
	HandleScope scope;
	
  QSvgWidgetWrap* w = node::ObjectWrap::Unwrap<QSvgWidgetWrap>(args.This());
 	//QSvgWidget* q = w->GetWrapped();
 	QImpl<QSvgWidget>* q = (QImpl<QSvgWidget>*)(w->GetWrapped());
 	
	if (args.Length()==0){
		
		QObject::disconnect(q, 0, 0, 0);
		HANDLE_WIDGET_EVENTS_OFF_ALL
				
	}else {
		QString sign = qt_v8::ToQString(args[0]->ToString());
		
		QObject* rec = 0;
		if (args.Length()>1){
	  	QObjectWrap* object_wrap = ObjectWrap::Unwrap<QObjectWrap>(args[1]->ToObject());
	  	rec = object_wrap->GetWrapped();
		}
		
		if (sign=="customContextMenuRequested") //WIDGET
			QObject::disconnect(q, SIGNAL(customContextMenuRequested(const QPoint &)), rec, 0);	
		// delete receivers?
		
		HANDLE_WIDGET_EVENTS_OFF
		
	}
	return args.This();
}

//- load (string filename)
Handle<Value> QSvgWidgetWrap::load(const Arguments& args) {
  HandleScope scope;

  QSvgWidgetWrap* w = node::ObjectWrap::Unwrap<QSvgWidgetWrap>(args.This());
  QSvgWidget* q = w->GetWrapped();

  if (args[0]->IsString()) {

		 q->load(qt_v8::ToQString(args[0]->ToString()));
    
  } else if (args[0]->IsObject()) {
  	
		QString arg0_constructor = qt_v8::ToQString(args[0]->ToObject()->GetConstructorName());
    if (arg0_constructor != "Buffer") ThrowException(Exception::TypeError(String::New("QSvgWidget.load: bad argument")));

		size_t size = node::Buffer::Length(args[0]->ToObject());
		char *buf = node::Buffer::Data(args[0]->ToObject());
		q->load(QByteArray(buf, size));
	}
				
  return scope.Close(Undefined());
}
