// Class QImplPrint<WC>
template<class WC> class QImplPrint : public WC {
	
 public:
  QImplPrint(QPrinter* printer=0);
  ~QImplPrint();
  
 public:
 	// TEST
 	QMultiHash<QString, v8::Persistent<v8::Value>> eventCallbacks;
 	
  v8::Persistent<v8::Value> changeEventCallback_;
  v8::Persistent<v8::Value> closeEventCallback_;
  v8::Persistent<v8::Value> contextMenuEventCallback_;
	v8::Persistent<v8::Value> dragEnterEventCallback_;
	v8::Persistent<v8::Value> dropEventCallback_;
  v8::Persistent<v8::Value> keyPressCallback_;
  v8::Persistent<v8::Value> keyReleaseCallback_;
  v8::Persistent<v8::Value> mouseMoveCallback_;
  v8::Persistent<v8::Value> mousePressCallback_;
  v8::Persistent<v8::Value> mouseReleaseCallback_;
  v8::Persistent<v8::Value> paintEventCallback_;
  
  v8::Persistent<v8::Value> hideEventCallback_;
  v8::Persistent<v8::Value> showEventCallback_;
  
 private:
  void changeEvent(QEvent* e);
  void closeEvent(QCloseEvent* e);
  void contextMenuEvent(QContextMenuEvent* e);
	void dragEnterEvent(QDragEnterEvent *event);
	void dropEvent(QDropEvent *event);
  void keyPressEvent(QKeyEvent* e);
  void keyReleaseEvent(QKeyEvent* e);
  void mouseMoveEvent(QMouseEvent* e);
  void mousePressEvent(QMouseEvent* e);
  void mouseReleaseEvent(QMouseEvent* e);
  void paintEvent(QPaintEvent* e);
  
  void hideEvent(QEvent* e);
  void showEvent(QEvent* e);
};

// QWidgetImpl()
template<class WC> QImplPrint<WC>::QImplPrint(QPrinter* printer) : WC(printer) {
	changeEventCallback_ = Persistent<Boolean>::New(Boolean::New(false));
  closeEventCallback_ = Persistent<Boolean>::New(Boolean::New(false));
  contextMenuEventCallback_ = Persistent<Boolean>::New(Boolean::New(false));
	dragEnterEventCallback_ = Persistent<Boolean>::New(Boolean::New(false));
	dropEventCallback_ = Persistent<Boolean>::New(Boolean::New(false));
  keyPressCallback_ = Persistent<Boolean>::New(Boolean::New(false));
  keyReleaseCallback_ = Persistent<Boolean>::New(Boolean::New(false));
  mouseMoveCallback_ = Persistent<Boolean>::New(Boolean::New(false));
  mousePressCallback_ = Persistent<Boolean>::New(Boolean::New(false));
  mouseReleaseCallback_ = Persistent<Boolean>::New(Boolean::New(false));
  paintEventCallback_ = Persistent<Boolean>::New(Boolean::New(false));
  
  hideEventCallback_ = Persistent<Boolean>::New(Boolean::New(false));
  showEventCallback_ = Persistent<Boolean>::New(Boolean::New(false));
}

template<class WC> QImplPrint<WC>::~QImplPrint() {
  changeEventCallback_.Dispose();
  closeEventCallback_.Dispose();
  contextMenuEventCallback_.Dispose();
	dragEnterEventCallback_.Dispose();
	dropEventCallback_.Dispose();
  keyPressCallback_.Dispose();
  keyReleaseCallback_.Dispose();
  mouseMoveCallback_.Dispose();
  mousePressCallback_.Dispose();
  mouseReleaseCallback_.Dispose();
  paintEventCallback_.Dispose();
  
  hideEventCallback_.Dispose();
  showEventCallback_.Dispose();
}

template<class WC> void QImplPrint<WC>::changeEvent(QEvent* e) {	
  HandleScope scope;
  if (!changeEventCallback_->IsFunction()) return;
  const unsigned argc = 1;
  Handle<Value> argv[argc] = {
    QEventWrap::NewInstance((QEvent*)e)
  };
  Handle<Function> cb = Persistent<Function>::Cast(changeEventCallback_);
  cb->Call(Context::GetCurrent()->Global(), argc, argv);
}

template<class WC> void QImplPrint<WC>::closeEvent(QCloseEvent* e) {	
  HandleScope scope;
  if (!closeEventCallback_->IsFunction()) return;
  const unsigned argc = 1;
  Handle<Value> argv[argc] = {
    QEventWrap::NewInstance((QEvent*)e)
  };
  Handle<Function> cb = Persistent<Function>::Cast(closeEventCallback_);
  cb->Call(Context::GetCurrent()->Global(), argc, argv);
}

template<class WC> void QImplPrint<WC>::contextMenuEvent(QContextMenuEvent* e) {
  HandleScope scope;
  if (!contextMenuEventCallback_->IsFunction()) return;
  const unsigned argc = 1;
  Handle<Value> argv[argc] = {
    QEventWrap::NewInstance((QEvent*)e) // TODO: QContextMenuEventWrap::NewInstance(*e)
  };
  Handle<Function> cb = Persistent<Function>::Cast(contextMenuEventCallback_);
  cb->Call(Context::GetCurrent()->Global(), argc, argv);
}

template<class WC> void QImplPrint<WC>::dropEvent(QDropEvent *event){
  HandleScope scope;
  if (!dropEventCallback_->IsFunction()) return;
  
//	Local<Object> data = Object::New();
//	for (int i=0;i<event->mimeData()->formats().count();i++){
//	  QByteArray ba =  event->mimeData()->data( event->mimeData()->formats()[i] );
//	  node::Buffer *buf = node::Buffer::New(ba.size());
//	  memcpy(node::Buffer::Data(buf), ba.data(), ba.size());
//	  data->Set(
//	  	String::New( event->mimeData()->formats()[i].utf16() ),
//	  	buf->handle_ //return scope.Close( buf->handle_ );
//	  	//Buffer::New( event->mimeData()->data( event->mimeData()->formats()[i]).data()) // char *
//	  );
//	}
//	const unsigned argc = 1;
//	Handle<Value> argv[1] = {
//		//TODO: QDropEventWrap::NewInstance(*e)
//		data 
//	};

  const unsigned argc = 1;
  Handle<Value> argv[argc] = {
    //QDropEventWrap::NewInstance(*event)
    QDropEventWrap::NewInstance(event)
  };
  
// QDropEventWrap:
//void 	acceptProposedAction ()
//Qt::DropAction 	dropAction () const
//Qt::KeyboardModifiers 	keyboardModifiers () const
//const QMimeData * 	mimeData () const
//Qt::MouseButtons 	mouseButtons () const
//const QPoint & 	pos () const
//Qt::DropActions 	possibleActions () const
//Qt::DropAction 	proposedAction () const
//void 	setDropAction ( Qt::DropAction action )
//QWidget * 	source () const
 

//QMimeData:
//QByteArray 	data ( const QString & mimeType ) const
//virtual QStringList 	formats () const

//QVariant 	colorData () const
//QString 	html () const
//QVariant 	imageData () const
//QString 	text () const
//QList<QUrl> 	urls () const

  Handle<Function> cb = Persistent<Function>::Cast(dropEventCallback_);
  cb->Call(Context::GetCurrent()->Global(), argc, argv);
  
	event->acceptProposedAction();
}

template<class WC> void QImplPrint<WC>::dragEnterEvent(QDragEnterEvent *event){
	event->acceptProposedAction();
	
//  HandleScope scope;
//  if (!dragEnterEventCallback_->IsFunction()) return;
//  
//  const unsigned argc = 1;
//  Handle<Value> argv[argc] = {
//    //QDragEnterEventWrap::NewInstance(*event)
//    QDragEnterEventWrap::NewInstance(event)
//  };
//  
//  Handle<Function> cb = Persistent<Function>::Cast(dragEnterEventCallback_);
//  cb->Call(Context::GetCurrent()->Global(), argc, argv);
}

template<class WC> void QImplPrint<WC>::keyPressEvent(QKeyEvent* e) {
  e->ignore(); // ensures event bubbles up
  HandleScope scope;
  if (!keyPressCallback_->IsFunction()) return;
  const unsigned argc = 1;
  Handle<Value> argv[argc] = {
    QKeyEventWrap::NewInstance(e)
  };
  Handle<Function> cb = Persistent<Function>::Cast(keyPressCallback_);
  cb->Call(Context::GetCurrent()->Global(), argc, argv);
}

template<class WC> void QImplPrint<WC>::keyReleaseEvent(QKeyEvent* e) {
  e->ignore(); // ensures event bubbles up
  HandleScope scope;
  if (!keyReleaseCallback_->IsFunction()) return;
  const unsigned argc = 1;
  Handle<Value> argv[argc] = {
    QKeyEventWrap::NewInstance(e)
  };
  Handle<Function> cb = Persistent<Function>::Cast(keyReleaseCallback_);
  cb->Call(Context::GetCurrent()->Global(), argc, argv);
}

template<class WC> void QImplPrint<WC>::mouseMoveEvent(QMouseEvent* e) {
  e->ignore(); // ensures event bubbles up
  HandleScope scope;
  if (!mouseMoveCallback_->IsFunction()) return;
  const unsigned argc = 1;
  Handle<Value> argv[argc] = {
    QMouseEventWrap::NewInstance(e)
  };
  Handle<Function> cb = Persistent<Function>::Cast(mouseMoveCallback_);
  cb->Call(Context::GetCurrent()->Global(), argc, argv);
}

template<class WC> void QImplPrint<WC>::mousePressEvent(QMouseEvent* e) {
  e->ignore(); // ensures event bubbles up
  HandleScope scope;
  if (!mousePressCallback_->IsFunction()) return;
  const unsigned argc = 1;
  Handle<Value> argv[argc] = {
    QMouseEventWrap::NewInstance(e)
  };
  Handle<Function> cb = Persistent<Function>::Cast(mousePressCallback_);
  cb->Call(Context::GetCurrent()->Global(), argc, argv);
}

template<class WC> void QImplPrint<WC>::mouseReleaseEvent(QMouseEvent* e) {
  e->ignore(); // ensures event bubbles up
  HandleScope scope;
  if (!mouseReleaseCallback_->IsFunction()) return;
  const unsigned argc = 1;
  Handle<Value> argv[argc] = {
    QMouseEventWrap::NewInstance(e)
  };
  Handle<Function> cb = Persistent<Function>::Cast(mouseReleaseCallback_);
  cb->Call(Context::GetCurrent()->Global(), argc, argv);
}

template<class WC> void QImplPrint<WC>::paintEvent(QPaintEvent* e) {
  HandleScope scope;
  if (!paintEventCallback_->IsFunction()) return;
  const unsigned argc = 1;
  Handle<Value> argv[argc] = {
    QEventWrap::NewInstance((QEvent*)e) // TODO: QPaintEventWrap::NewInstance(*e)
  };
  Handle<Function> cb = Persistent<Function>::Cast(paintEventCallback_);
  cb->Call(Context::GetCurrent()->Global(), argc, argv);
}

template<class WC> void QImplPrint<WC>::hideEvent(QEvent* e) {
  HandleScope scope;
  if (!hideEventCallback_->IsFunction()) return;
  const unsigned argc = 1;
  Handle<Value> argv[argc] = {
    QEventWrap::NewInstance(e)
  };
  Handle<Function> cb = Persistent<Function>::Cast(hideEventCallback_);
  cb->Call(Context::GetCurrent()->Global(), argc, argv);
}

template<class WC> void QImplPrint<WC>::showEvent(QEvent* e) {
  HandleScope scope;
  if (!showEventCallback_->IsFunction()) return;
  const unsigned argc = 1;
  Handle<Value> argv[argc] = {
    QEventWrap::NewInstance(e)
  };
  Handle<Function> cb = Persistent<Function>::Cast(showEventCallback_);
  cb->Call(Context::GetCurrent()->Global(), argc, argv);
}


//test: used by editors
//template<class WC> void QImplPrint<WC>::printPreview(QPrinter *printer) {
//	print(printer);
//}

