#ifndef QCALENDARWIDGETWRAP_H
#define QCALENDARWIDGETWRAP_H

#include "qwidget.h"

class QCalendarWidgetWrap : public node::ObjectWrap {
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  QCalendarWidget* GetWrapped() const { return q_; };
  void SetWrapped(QCalendarWidget *q) { q_ = q; };
  static v8::Handle<v8::Value> NewInstance(QCalendarWidget *q);
	bool hasEvents;
	
 private:
  QCalendarWidgetWrap(const v8::Arguments& args);
  ~QCalendarWidgetWrap();
  
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods
	DEFINE_METHOD(on)
	DEFINE_METHOD(off)
	
	DEFINE_METHOD(selectedDate)
	DEFINE_METHOD(setSelectedDate)
		
  // Wrapped object
  QCalendarWidget* q_;
};

#endif
