#ifndef QCHECKBOXWRAP_H
#define QCHECKBOXWRAP_H


#include "qwidget.h"

class QCheckBoxWrap : public node::ObjectWrap {
	
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  QCheckBox* GetWrapped() const { return q_; };
  void SetWrapped(QCheckBox *q) { q_ = q; };
  static v8::Handle<v8::Value> NewInstance(QCheckBox *q);
	bool hasEvents;
	
 private:
  QCheckBoxWrap(const v8::Arguments& args);
  ~QCheckBoxWrap();
  
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods
  DEFINE_METHOD(on)
  DEFINE_METHOD(off)
  
  DEFINE_METHOD(isChecked)
  DEFINE_METHOD(setChecked)
  DEFINE_METHOD(setText)
  DEFINE_METHOD(text)
  DEFINE_METHOD(toggle)
  		
  // Wrapped object
  QCheckBox* q_;
};

#endif
