#ifndef QCOMBOBOXWRAP_H
#define QCOMBOBOXWRAP_H

#include "qwidget.h"
#include "../Types/qvariant.h"

class QComboBoxWrap : public node::ObjectWrap {
	
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  QComboBox* GetWrapped() const { return q_; };
  void SetWrapped(QComboBox *q) { q_ = q;};
  static v8::Handle<v8::Value> NewInstance(QComboBox *q);
	bool hasEvents;
	
 private:
  QComboBoxWrap(const v8::Arguments& args);
  ~QComboBoxWrap();
  
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods
  DEFINE_METHOD(on)
  DEFINE_METHOD(off)
  
	DEFINE_METHOD(addItem)
	DEFINE_METHOD(currentIndex)
	DEFINE_METHOD(currentText)
	DEFINE_METHOD(itemData)
	DEFINE_METHOD(itemText)
	DEFINE_METHOD(removeItem)
	DEFINE_METHOD(setCurrentIndex)
	DEFINE_METHOD(setEditable)
	DEFINE_METHOD(setEditText)
	DEFINE_METHOD(setItemData)
	DEFINE_METHOD(setItemText)
	
	DEFINE_METHOD(setModel)
	DEFINE_METHOD(count)
	DEFINE_METHOD(findText)
	DEFINE_METHOD(clear)
		
  // Wrapped object
  QComboBox* q_;
};

#endif
