#ifndef QDOCKWIDGETWRAP_H
#define QDOCKWIDGETWRAP_H

#include "qwidget.h"

class QDockWidgetWrap : public node::ObjectWrap {
	
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  QDockWidget* GetWrapped() const { return q_; };
  void SetWrapped(QDockWidget *q) { q_ = q; };
  static v8::Handle<v8::Value> NewInstance(QDockWidget *q);
	bool hasEvents;
	
 private:
  QDockWidgetWrap(const v8::Arguments& args);
  ~QDockWidgetWrap();
  
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods
  DEFINE_METHOD(on)
  DEFINE_METHOD(off)

  DEFINE_METHOD(setAllowedAreas)
  DEFINE_METHOD(setFeatures)
  DEFINE_METHOD(setFloating)
  DEFINE_METHOD(setWidget)
  DEFINE_METHOD(setWindowTitle)
  DEFINE_METHOD(widget)
  
  // Wrapped object
  QDockWidget* q_;
};

#endif
