#ifndef QFRAMEWRAP_H
#define QFRAMEWRAP_H


#include "qwidget.h"

class QFrameWrap : public node::ObjectWrap {
	
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  QFrame* GetWrapped() const { return q_; };
  void SetWrapped(QFrame *q) { q_ = q; };
  static v8::Handle<v8::Value> NewInstance(QFrame *q);
	bool hasEvents;
	
 private:
  QFrameWrap(const v8::Arguments& args);
  ~QFrameWrap();
  
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods
  DEFINE_METHOD(on)
  DEFINE_METHOD(off)
  	
	DEFINE_METHOD(setFrameRect)
	DEFINE_METHOD(setFrameShadow)
	DEFINE_METHOD(setFrameShape)
	DEFINE_METHOD(setFrameStyle)
	DEFINE_METHOD(setLineWidth)
	DEFINE_METHOD(setMidLineWidth)
			
  // Wrapped object
  QFrame* q_;
};

#endif
