#ifndef QLABELWRAP_H
#define QLABELWRAP_H


#include "qwidget.h"

class QLabelWrap : public node::ObjectWrap {
	
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  QLabel* GetWrapped() const { return q_; };
  void SetWrapped(QLabel *q) { q_ = q; };
  static v8::Handle<v8::Value> NewInstance(QLabel *q);
	bool hasEvents;
	
 private:
  QLabelWrap(const v8::Arguments& args);
  ~QLabelWrap();
  
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods
	DEFINE_METHOD(on)
  DEFINE_METHOD(off)
  
	DEFINE_METHOD(setAlignment)
	DEFINE_METHOD(setImage)
	DEFINE_METHOD(setIndent)
	DEFINE_METHOD(setMargin)
	DEFINE_METHOD(setOpenExternalLinks)
	DEFINE_METHOD(setText)
	DEFINE_METHOD(setTextFormat)
	DEFINE_METHOD(setWordWrap)
	DEFINE_METHOD(text)
		
  // Wrapped object
  QLabel* q_;
};

#endif
