#ifndef QLINEEDITWRAP_H
#define QLINEEDITWRAP_H


#include "qwidget.h"

class QLineEditWrap : public node::ObjectWrap {
	
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  QLineEdit* GetWrapped() const { return q_; };
  void SetWrapped(QLineEdit *q) { q_ = q; };
  static v8::Handle<v8::Value> NewInstance(QLineEdit *q);
	bool hasEvents;
	
 private:
  QLineEditWrap(const v8::Arguments& args);
  ~QLineEditWrap();
  
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods
  DEFINE_METHOD(on)
  DEFINE_METHOD(off)
  
  DEFINE_METHOD(setText)
  DEFINE_METHOD(text)
  	
	DEFINE_METHOD(setEchoMode)
	
  // Wrapped object
  QLineEdit* q_;
};

#endif
