#ifndef QLISTWIDGETWRAP_H
#define QLISTWIDGETWRAP_H

#include "qwidget.h"
#include "../Types/qlistwidgetitem.h"

class QListWidgetWrap : public node::ObjectWrap {
	
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  QListWidget* GetWrapped() const { return q_; };
  void SetWrapped(QListWidget *q) { q_ = q; };
  static v8::Handle<v8::Value> NewInstance(QListWidget *q);
	bool hasEvents;
	
 private:
  QListWidgetWrap(const v8::Arguments& args);
  ~QListWidgetWrap();
  
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods
  DEFINE_METHOD(on)
  DEFINE_METHOD(off)
  
  DEFINE_METHOD(addItem)
  DEFINE_METHOD(clear)
  DEFINE_METHOD(count)
  DEFINE_METHOD(currentRow)
  DEFINE_METHOD(insertItem)
  DEFINE_METHOD(isSortingEnabled)
  DEFINE_METHOD(item)
  DEFINE_METHOD(selectedItems)
  DEFINE_METHOD(setCurrentRow)
  DEFINE_METHOD(setSortingEnabled)
  DEFINE_METHOD(sortItems)
  		
  DEFINE_METHOD(currentItem)
  DEFINE_METHOD(setCurrentItem)
  
  DEFINE_METHOD(findItems)
  DEFINE_METHOD(itemAt)
    
  // Wrapped object
  QListWidget* q_;
};

#endif
