#ifndef QMAINWINDOWWRAP_H
#define QMAINWINDOWWRAP_H


#include "qwidget.h"

#include "qstatusbar.h"
#include "qtoolbar.h"
#include "qmenubar.h"
#include "qdockwidget.h"

#include "../Events/qevent.h"


/*************************************************
 QMainWindowWrap
*************************************************/
class QMainWindowWrap : public node::ObjectWrap {
	
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  QMainWindow* GetWrapped() const { return q_; };
	void SetWrapped(QMainWindow *q) { q_ = q; };
	static v8::Handle<v8::Value> NewInstance(QMainWindow *q);
	bool hasEvents;
	
 private:
  QMainWindowWrap(const v8::Arguments& args);
  ~QMainWindowWrap();
  
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods
  DEFINE_METHOD(on)
  DEFINE_METHOD(off)
  //DEFINE_METHOD(listeners)
	//DEFINE_METHOD(addListener)
	
	DEFINE_METHOD(addDockWidget)
	DEFINE_METHOD(addToolBar)
	DEFINE_METHOD(setCentralWidget)
	DEFINE_METHOD(setMenuBar)
	DEFINE_METHOD(setStatusBar)
	
 	DEFINE_METHOD(menuBar)
 	DEFINE_METHOD(statusBar)
 	
 	DEFINE_METHOD(activateWindow)
 	
  // Wrapped object
  QMainWindow* q_;
};

#endif
