#ifndef QMENUWRAP_H
#define QMENUWRAP_H


#include "qwidget.h"
#include "qaction.h"

class QMenuWrap : public node::ObjectWrap {
	
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  QMenu* GetWrapped() const { return q_; };
  void SetWrapped(QMenu *q) { q_ = q; };
  static v8::Handle<v8::Value> NewInstance(QMenu *q);
	bool hasEvents;
	
 private:
  QMenuWrap(const v8::Arguments& args);
  ~QMenuWrap();
  
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods
  DEFINE_METHOD(on)
  DEFINE_METHOD(off)
  
  DEFINE_METHOD(addAction)
  DEFINE_METHOD(addSeparator)
  DEFINE_METHOD(exec)
  	
  DEFINE_METHOD(insertAction)
  DEFINE_METHOD(insertSeparator)
  DEFINE_METHOD(removeAction)
  
  DEFINE_METHOD(clear)
  
  DEFINE_METHOD(addMenu)
  DEFINE_METHOD(setIcon)
  
  // Wrapped object
  QMenu* q_;
};

#endif
