#ifndef QMENUBARWRAP_H
#define QMENUBARWRAP_H


#include "qwidget.h"
#include "qmenu.h"

class QMenuBarWrap : public node::ObjectWrap {
	
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  QMenuBar* GetWrapped() const { return q_; };
  void SetWrapped(QMenuBar *q) { q_ = q; };
  static v8::Handle<v8::Value> NewInstance(QMenuBar *q);
	bool hasEvents;
	
 private:
  QMenuBarWrap(const v8::Arguments& args);
  ~QMenuBarWrap();
  
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods
  DEFINE_METHOD(on)
  DEFINE_METHOD(off)
  
  DEFINE_METHOD(addMenu)
  
  DEFINE_METHOD(addSeparator)
  
  // Wrapped object
  QMenuBar* q_;
};

#endif
