
#include "qplaintextedit.h"
//#include "moc_qplaintextedit.cpp"
#include "qwidgeteventstpl.h"

#include "../Types/qprinter.h"

using namespace v8;

template class QImpl<QPlainTextEdit>;

		// QWidgetImpl()
		//
		//QPlainTextEditImpl::QPlainTextEditImpl() : QWidget() {
		//  // Initialize callbacks as boolean values so we can test if the callback
		//  // has been set via ->IsFunction() below
		//  //closeEventCallback_ = Persistent<Boolean>::New(Boolean::New(false));
		//}
		//
		//QPlainTextEditImpl::~QPlainTextEditImpl() {
		//  //closeEventCallback_.Dispose();
		//}

//void QPlainTextEditImpl::printPreview(QPrinter *printer){
//	print(printer);
//}

/*************************************************
 QPlainTextEditWrap
*************************************************/

Persistent<Function> QPlainTextEditWrap::constructor;

QPlainTextEditWrap::QPlainTextEditWrap(const Arguments& args) : q_(NULL) {
	QWidget * q_parent = 0;
	//QWidgetImpl* q_parent = 0;
	if (args.Length()>0 && args[0]->IsObject()){
    QWidgetWrap* w_parent = ObjectWrap::Unwrap<QWidgetWrap>(args[0]->ToObject());
    q_parent = w_parent->GetWrapped();
	}
	hasEvents = args.Length()>1?args[1]->BooleanValue():false;
	bool fixScope = args.Length()>2?args[2]->BooleanValue():false;
	
	if (hasEvents)
		q_ = new QImpl<QPlainTextEdit>(q_parent, fixScope); //QPlainTextEditImpl
	else
  	q_ = new QPlainTextEdit(q_parent); //QPlainTextEditImpl
}

QPlainTextEditWrap::~QPlainTextEditWrap() {
  // Since q_ is never new'd (it's always a pointer to an existing scrollbar), 
  // don't delete it! It'll segfault.
  //delete q_;
}

void QPlainTextEditWrap::Initialize(Handle<Object> target) {
  // Prepare constructor template
  Local<FunctionTemplate> tpl = FunctionTemplate::New(New);
  tpl->SetClassName(String::NewSymbol("QPlainTextEdit"));
  tpl->InstanceTemplate()->SetInternalFieldCount(1);  

  ADD_METHOD(on)
  ADD_METHOD(off)
  
  ADD_METHOD(appendHtml)
  ADD_METHOD(appendPlainText)
  
  ADD_METHOD(clear)
  ADD_METHOD(copy)
  ADD_METHOD(cut)
  ADD_METHOD(find)
  ADD_METHOD(paste)
  ADD_METHOD(print)
  ADD_METHOD(selectAll)
  ADD_METHOD(setPlainText)
  ADD_METHOD(setTabStopWidth)
  ADD_METHOD(toPlainText)
  ADD_METHOD(undo)
  
  ADD_METHOD(setReadOnly)
  
	//geerbt
	ADD_WIDGET_METHODS(QPlainTextEditWrap, QPlainTextEdit)
	
  constructor = Persistent<Function>::New(tpl->GetFunction());
  target->Set(String::NewSymbol("QPlainTextEdit"), constructor);
}

Handle<Value> QPlainTextEditWrap::New(const Arguments& args) {
  HandleScope scope;

  QPlainTextEditWrap* w = new QPlainTextEditWrap(args);
  w->Wrap(args.This());

  return args.This();
}

Handle<Value> QPlainTextEditWrap::NewInstance(QPlainTextEdit *q) {
  HandleScope scope;
  
  Local<Object> instance = constructor->NewInstance(0, NULL);
  QPlainTextEditWrap* w = node::ObjectWrap::Unwrap<QPlainTextEditWrap>(instance);
  w->SetWrapped(q);

  return scope.Close(instance);
}

Handle<Value> QPlainTextEditWrap::on(const Arguments& args) {
	HandleScope scope;
	ASSERT_TYPE(args[0],IsString);
	ASSERT_TYPE(args[1],IsFunction);
	
	QString sign = qt_v8::ToQString(args[0]->ToString());
	Local<Function> callback = Local<Function>::Cast(args[1]);

  QPlainTextEditWrap* w = ObjectWrap::Unwrap<QPlainTextEditWrap>(args.This());
  //QPlainTextEdit* q = w->GetWrapped();
	QImpl<QPlainTextEdit>* q = (QImpl<QPlainTextEdit>*)(w->GetWrapped());
	
	Receiver* rec = new Receiver(callback, args.This());
	
	// SIGNALS	
	
	if (sign=="customContextMenuRequested") //WIDGET
		QObject::connect(q, SIGNAL(customContextMenuRequested(const QPoint &)), rec, SLOT(evtP(const QPoint &)));
	
	else if (sign=="blockCountChanged") 
		QObject::connect(q, SIGNAL(blockCountChanged(int)), rec, SLOT(evtI(int)));	
	else if (sign=="copyAvailable") 
		QObject::connect(q, SIGNAL(copyAvailable(bool)), rec, SLOT(evtB(bool)));	
	else if (sign=="cursorPositionChanged") 
		QObject::connect(q, SIGNAL(cursorPositionChanged()), rec, SLOT(evtV()));	
	else if (sign=="modificationChanged") 
		QObject::connect(q, SIGNAL(modificationChanged(bool)), rec, SLOT(evtB(bool)));
	else if (sign=="redoAvailable") 
		QObject::connect(q, SIGNAL(redoAvailable(bool)), rec, SLOT(evtB(bool)));	
	else if (sign=="selectionChanged") 
		QObject::connect(q, SIGNAL(selectionChanged()), rec, SLOT(evtV()));	
	else if (sign=="textChanged") 
		QObject::connect(q, SIGNAL(textChanged()), rec, SLOT(evtV()));	
	else if (sign=="undoAvailable") 
		QObject::connect(q, SIGNAL(undoAvailable(bool)), rec, SLOT(evtB(bool)));	
		
	else {
		delete rec;
		rec = 0;
		HANDLE_WIDGET_EVENTS
  }
	
	//return args.This();
	return scope.Close(rec ? QObjectWrap::NewInstance(rec) : Undefined());
}

Handle<Value> QPlainTextEditWrap::off(const Arguments& args) {
	HandleScope scope;
  QPlainTextEditWrap* w = node::ObjectWrap::Unwrap<QPlainTextEditWrap>(args.This());
  
 	//QPlainTextEdit* q = w->GetWrapped();
	QImpl<QPlainTextEdit>* q = (QImpl<QPlainTextEdit>*)(w->GetWrapped());
	
	if (args.Length()==0){
		QObject::disconnect(q, 0, 0, 0);
		
		HANDLE_WIDGET_EVENTS_OFF_ALL
		
	}else {
		QString sign = qt_v8::ToQString(args[0]->ToString());
		
		QObject* rec = 0;
		if (args.Length()>1){
	  	QObjectWrap* object_wrap = ObjectWrap::Unwrap<QObjectWrap>(args[1]->ToObject());
	  	rec = object_wrap->GetWrapped();
		}
		
		if (sign=="customContextMenuRequested") //WIDGET
			QObject::disconnect(q, SIGNAL(customContextMenuRequested(const QPoint &)), rec, 0);	
		
		else if (sign=="blockCountChanged") 
			QObject::disconnect(q, SIGNAL(blockCountChanged(int)), rec, 0);	
		else if (sign=="copyAvailable") 
			QObject::disconnect(q, SIGNAL(copyAvailable(bool)), rec, 0);	
		else if (sign=="cursorPositionChanged") 
			QObject::disconnect(q, SIGNAL(cursorPositionChanged()), rec, 0);	
		else if (sign=="modificationChanged") 
			QObject::disconnect(q, SIGNAL(modificationChanged(bool)), rec, 0);	
		else if (sign=="redoAvailable") 
			QObject::disconnect(q, SIGNAL(redoAvailable(bool)), rec, 0);	
		else if (sign=="selectionChanged") 
			QObject::disconnect(q, SIGNAL(selectionChanged()), rec, 0);	
		else if (sign=="textChanged") 
			QObject::disconnect(q, SIGNAL(textChanged()), rec, 0);	
		else if (sign=="undoAvailable") 
			QObject::disconnect(q, SIGNAL(undoAvailable(bool)), rec, 0);	

		// delete receivers?
		
	  HANDLE_WIDGET_EVENTS_OFF
	  
	}
	return args.This();
}

Handle<Value> QPlainTextEditWrap::appendHtml(const Arguments& args) {
  HandleScope scope;
  QPlainTextEditWrap* w = ObjectWrap::Unwrap<QPlainTextEditWrap>(args.This());
  QPlainTextEdit* q = w->GetWrapped();
  q->appendHtml(qt_v8::ToQString(args[0]->ToString()));
  return scope.Close(Undefined());
}

Handle<Value> QPlainTextEditWrap::appendPlainText(const Arguments& args) {
  HandleScope scope;
  QPlainTextEditWrap* w = ObjectWrap::Unwrap<QPlainTextEditWrap>(args.This());
  QPlainTextEdit* q = w->GetWrapped();
  q->appendPlainText(qt_v8::ToQString(args[0]->ToString()));
  return scope.Close(Undefined());
}

Handle<Value> QPlainTextEditWrap::clear(const Arguments& args) {
  HandleScope scope;
  QPlainTextEditWrap* w = ObjectWrap::Unwrap<QPlainTextEditWrap>(args.This());
  QPlainTextEdit* q = w->GetWrapped();
  q->clear();
  return scope.Close(Undefined());
}

Handle<Value> QPlainTextEditWrap::copy(const Arguments& args) {
  HandleScope scope;
  QPlainTextEditWrap* w = ObjectWrap::Unwrap<QPlainTextEditWrap>(args.This());
  QPlainTextEdit* q = w->GetWrapped();
  q->copy();
  return scope.Close(Undefined());
}

Handle<Value> QPlainTextEditWrap::cut(const Arguments& args) {
  HandleScope scope;
  QPlainTextEditWrap* w = ObjectWrap::Unwrap<QPlainTextEditWrap>(args.This());
  QPlainTextEdit* q = w->GetWrapped();
  q->cut();
  return scope.Close(Undefined());
}

Handle<Value> QPlainTextEditWrap::find(const Arguments& args) {
  HandleScope scope;
  QPlainTextEditWrap* w = ObjectWrap::Unwrap<QPlainTextEditWrap>(args.This());
  QPlainTextEdit* q = w->GetWrapped();
  return scope.Close(Boolean::New( q->find(qt_v8::ToQString(args[0]->ToString())) ));
}

Handle<Value> QPlainTextEditWrap::paste(const Arguments& args) {
  HandleScope scope;
  QPlainTextEditWrap* w = ObjectWrap::Unwrap<QPlainTextEditWrap>(args.This());
  QPlainTextEdit* q = w->GetWrapped();
  q->paste();
  return scope.Close(Undefined());
}

Handle<Value> QPlainTextEditWrap::print(const Arguments& args) {
	if (args.Length() < 1) return v8::ThrowException(v8::Exception::Error(v8::String::New("Illegal arguments")));
  HandleScope scope;
  QPlainTextEditWrap* w = ObjectWrap::Unwrap<QPlainTextEditWrap>(args.This());
  QPlainTextEdit* q = w->GetWrapped();
  QPrinterWrap* printer_wrap = ObjectWrap::Unwrap<QPrinterWrap>(args[0]->ToObject()); 
  q->print( printer_wrap->GetWrapped() );
  return scope.Close(Undefined());
}

Handle<Value> QPlainTextEditWrap::selectAll(const Arguments& args) {
  HandleScope scope;
  QPlainTextEditWrap* w = ObjectWrap::Unwrap<QPlainTextEditWrap>(args.This());
  QPlainTextEdit* q = w->GetWrapped();
  q->selectAll();
  return scope.Close(Undefined());
}

//Handle<Value> QPlainTextEditWrap::setFont(const Arguments& args) {
//  HandleScope scope;
//  QPlainTextEditWrap* w = ObjectWrap::Unwrap<QPlainTextEditWrap>(args.This());
//  QPlainTextEdit* q = w->GetWrapped();
//  
//  int pointSize = -1;
//  int weight = -1;
//  bool italic = false;
//  if (args.Length() > 1) pointSize = args[1]->IntegerValue();
//  if (args.Length() > 2) weight = args[2]->IntegerValue();
//  if (args.Length() > 3) italic = args[3]->BooleanValue();
//  q->setFont( QFont(qt_v8::ToQString(args[0]->ToString()), pointSize, weight, italic) );
//  
//  return scope.Close(Undefined());
//}

Handle<Value> QPlainTextEditWrap::setPlainText(const Arguments& args) {
  HandleScope scope;
  QPlainTextEditWrap* w = ObjectWrap::Unwrap<QPlainTextEditWrap>(args.This());
  QPlainTextEdit* q = w->GetWrapped();
  q->setPlainText(qt_v8::ToQString(args[0]->ToString()));
  return scope.Close(Undefined());
}

Handle<Value> QPlainTextEditWrap::setTabStopWidth(const Arguments& args) {
  HandleScope scope;
  QPlainTextEditWrap* w = ObjectWrap::Unwrap<QPlainTextEditWrap>(args.This());
  QPlainTextEdit* q = w->GetWrapped();
  q->setTabStopWidth(args[0]->IntegerValue());
  return scope.Close(Undefined());
}

Handle<Value> QPlainTextEditWrap::toPlainText(const Arguments& args) {
  HandleScope scope;
  QPlainTextEditWrap* w = ObjectWrap::Unwrap<QPlainTextEditWrap>(args.This());
  QPlainTextEdit* q = w->GetWrapped();
  return scope.Close(qt_v8::FromQString(q->toPlainText()));
}

Handle<Value> QPlainTextEditWrap::undo(const Arguments& args) {
  HandleScope scope;
  QPlainTextEditWrap* w = ObjectWrap::Unwrap<QPlainTextEditWrap>(args.This());
  QPlainTextEdit* q = w->GetWrapped();
  q->undo();
  return scope.Close(Undefined());
}

Handle<Value> QPlainTextEditWrap::setReadOnly(const Arguments& args) {
  HandleScope scope;
  QPlainTextEditWrap* w = ObjectWrap::Unwrap<QPlainTextEditWrap>(args.This());
  QPlainTextEdit* q = w->GetWrapped();
  q->setReadOnly(args[0]->BooleanValue());
  return scope.Close(Undefined());
}

////- font () -> string
//Handle<Value> QPlainTextEditWrap::font(const Arguments& args) {
//  HandleScope scope;
//  
//  QPlainTextEditWrap* w = ObjectWrap::Unwrap<QPlainTextEditWrap>(args.This());
//  QPlainTextEdit* q = w->GetWrapped();
//  
//  QFont font = q->font();
//  
//  return scope.Close(qt_v8::FromQString(font.toString()));
//}