#ifndef QPROGRESSBARWRAP_H
#define QPROGRESSBARWRAP_H


#include "qwidget.h"

class QProgressBarWrap : public node::ObjectWrap {
	
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  QProgressBar* GetWrapped() const { return q_; };
  void SetWrapped(QProgressBar *q) { q_ = q; };
  static v8::Handle<v8::Value> NewInstance(QProgressBar *q);
	bool hasEvents;
	
 private:
  QProgressBarWrap(const v8::Arguments& args);
  ~QProgressBarWrap();
  
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods
  DEFINE_METHOD(on)
  DEFINE_METHOD(off)
  
  DEFINE_METHOD(setFormat)
  DEFINE_METHOD(setMaximum)
  DEFINE_METHOD(setMinimum)
  DEFINE_METHOD(setValue)
  DEFINE_METHOD(text)
  DEFINE_METHOD(value)
  		
  // Wrapped object
  QProgressBar* q_;
};

#endif
