#ifndef QRADIOBUTTONWRAP_H
#define QRADIOBUTTONWRAP_H


#include "qwidget.h"

class QRadioButtonWrap : public node::ObjectWrap {
	
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  QRadioButton* GetWrapped() const { return q_; };
  void SetWrapped(QRadioButton *q) { q_ = q; };
  static v8::Handle<v8::Value> NewInstance(QRadioButton *q);
	bool hasEvents;
	
 private:
  QRadioButtonWrap(const v8::Arguments& args);
  ~QRadioButtonWrap();
  
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods
  DEFINE_METHOD(on)
  DEFINE_METHOD(off)
  
  DEFINE_METHOD(isChecked)
  DEFINE_METHOD(setChecked)
  DEFINE_METHOD(setText)
  DEFINE_METHOD(text)
  DEFINE_METHOD(toggle)

//- isChecked () -> bool
//- setChecked (bool)
//- setText (string)
//- text () -> string
//- toggle ()
	
  // Wrapped object
  QRadioButton* q_;
};

#endif
