#ifndef QSCROLLAREAWRAP_H
#define QSCROLLAREAWRAP_H

//#include "../qt.h"
//#include "../Widgets/qwidget.h"

#include "qwidget.h"
#include "qscrollbar.h"
#include "../Types/qsize.h"


// QScrollAreaWrap()
class QScrollAreaWrap : public node::ObjectWrap {
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  QScrollArea* GetWrapped() const { return q_; };
	bool hasEvents;
	
 private:
  QScrollAreaWrap(const v8::Arguments& args);
  ~QScrollAreaWrap();
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  DEFINE_METHOD(on)
  DEFINE_METHOD(off)
  
  // QScrollArea-specific methods
  DEFINE_METHOD(horizontalScrollBar)
  DEFINE_METHOD(setFrameShape)
  DEFINE_METHOD(setHorizontalScrollBarPolicy)
  DEFINE_METHOD(setVerticalScrollBarPolicy)
  DEFINE_METHOD(setWidget)
  DEFINE_METHOD(verticalScrollBar)
  DEFINE_METHOD(widget)
	
  // Wrapped object
  QScrollArea* q_;
};

#endif
