#ifndef QSCROLLBARWRAP_H
#define QSCROLLBARWRAP_H


#include "qwidget.h"

class QScrollBarWrap : public node::ObjectWrap {
	
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  QScrollBar* GetWrapped() const { return q_; };
  void SetWrapped(QScrollBar *q) { q_ = q; };
  static v8::Handle<v8::Value> NewInstance(QScrollBar *q);
	bool hasEvents;
	
 private:
  QScrollBarWrap(const v8::Arguments& args);
  ~QScrollBarWrap();
  
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods
  DEFINE_METHOD(on)
  DEFINE_METHOD(off)
  
  DEFINE_METHOD(setOrientation)
  DEFINE_METHOD(setRange)
  DEFINE_METHOD(setTracking)
  DEFINE_METHOD(setValue)
  DEFINE_METHOD(value)
    
//- setOrientation (int)
//- setRange (int min, int max)
//- setTracking (bool enable)
//- setValue (int)
//- value () -> int

  // Wrapped object
  QScrollBar* q_;
};

#endif
