#ifndef QSPINBOXWRAP_H
#define QSPINBOXWRAP_H


#include "qwidget.h"

class QSpinBoxWrap : public node::ObjectWrap {
	
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  QSpinBox* GetWrapped() const { return q_; };
  void SetWrapped(QSpinBox *q) { q_ = q; };
  static v8::Handle<v8::Value> NewInstance(QSpinBox *q);
	bool hasEvents;
	
 private:
  QSpinBoxWrap(const v8::Arguments& args);
  ~QSpinBoxWrap();
  
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods
  DEFINE_METHOD(on)
  DEFINE_METHOD(off)

  DEFINE_METHOD(setRange)
  DEFINE_METHOD(setValue)
  DEFINE_METHOD(value)
	
  // Wrapped object
  QSpinBox* q_;
};

#endif
