#ifndef QSPLITTERWRAP_H
#define QSPLITTERWRAP_H


#include "qwidget.h"

class QSplitterWrap : public node::ObjectWrap {
	
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  QSplitter* GetWrapped() const { return q_; };
  void SetWrapped(QSplitter *q) { q_ = q; };
  static v8::Handle<v8::Value> NewInstance(QSplitter *q);
	bool hasEvents;
	
 private:
  QSplitterWrap(const v8::Arguments& args);
  ~QSplitterWrap();
  
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods
	DEFINE_METHOD(on)
	DEFINE_METHOD(off)

	//addWidget ( QWidget * widget )
	//insertWidget ( int index, QWidget * widget )
	
	DEFINE_METHOD(addWidget)
	DEFINE_METHOD(insertWidget)
	
	DEFINE_METHOD(orientation)
	DEFINE_METHOD(setOrientation)
			
	DEFINE_METHOD(setSizes)
	
	DEFINE_METHOD(setCollapsible)
	DEFINE_METHOD(setHandleWidth)
	
	DEFINE_METHOD(setStretchFactor)
	
  // Wrapped object
  QSplitter* q_;
};

#endif
