#ifndef QSTATUSBARWRAP_H
#define QSTATUSBARWRAP_H


#include "qwidget.h"

class QStatusBarWrap : public node::ObjectWrap {
	
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  QStatusBar* GetWrapped() const { return q_; };
  void SetWrapped(QStatusBar *q) { q_ = q; };
  static v8::Handle<v8::Value> NewInstance(QStatusBar *q);
	bool hasEvents;
	
 private:
  QStatusBarWrap(const v8::Arguments& args);
  ~QStatusBarWrap();
  
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

//- isVisible () -> bool
//- setSizeGripEnabled (bool)
//- setVisible (bool)
//- showMessage (string, *int timeout)

  // Wrapped methods
  DEFINE_METHOD(on)
  DEFINE_METHOD(off)

  DEFINE_METHOD(isVisible)
  DEFINE_METHOD(setSizeGripEnabled)
  DEFINE_METHOD(setVisible)
  DEFINE_METHOD(showMessage)

  DEFINE_METHOD(addWidget)
  DEFINE_METHOD(addPermanentWidget)
  
  // Wrapped object
  QStatusBar* q_;
};

#endif
