#ifndef QTABBARWRAP_H
#define QTABBARWRAP_H


#include "qwidget.h"

class QTabBarWrap : public node::ObjectWrap {
	
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  QTabBar* GetWrapped() const { return q_; };
  void SetWrapped(QTabBar *q) { q_ = q; };
  static v8::Handle<v8::Value> NewInstance(QTabBar *q);
	bool hasEvents;
	
 private:
  QTabBarWrap(const v8::Arguments& args);
  ~QTabBarWrap();
  
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods
  DEFINE_METHOD(on)
  DEFINE_METHOD(off)

//- addTab (string text, *string|image icon) -> int
//- count () -> int
//- currentIndex () -> int
//- insertTab (int index, string text, *string|image icon) -> int
//- removeTab (int index)
//- setMovable (bool)

//- setShape (int)
//- setTabEnabled (int index, bool enabled)
//- setTabsClosable (bool)
//- setTabText (int index, string text)
//- setTabTextColor (int index, color)
//- setTabToolTip int index, string text)

//- setTabWhatsThis (int index, string text)
//- setUsesScrollButtons (bool)

	DEFINE_METHOD(addTab)
	DEFINE_METHOD(count)
	DEFINE_METHOD(currentIndex)
	DEFINE_METHOD(insertTab)
	DEFINE_METHOD(removeTab)
	DEFINE_METHOD(setMovable)
	DEFINE_METHOD(setShape)
	DEFINE_METHOD(setTabEnabled)
	DEFINE_METHOD(setTabsClosable)
	DEFINE_METHOD(setTabText)
	DEFINE_METHOD(setTabTextColor)
	DEFINE_METHOD(setTabToolTip)
	DEFINE_METHOD(setTabWhatsThis)
	DEFINE_METHOD(setUsesScrollButtons)
			
  // Wrapped object
  QTabBar* q_;
};

#endif
