#ifndef QTABLEVIEWWRAP_H
#define QTABLEVIEWWRAP_H

#include "qwidget.h"
//#include "qtablewidgetitem.h"

class QTableViewWrap : public node::ObjectWrap {
	
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  QTableView* GetWrapped() const { return q_; };
  void SetWrapped(QTableView *q) { q_ = q; };
  static v8::Handle<v8::Value> NewInstance(QTableView *q);
  static v8::Handle<v8::Value> NewInstance(QTabBar *q);
	bool hasEvents;
	
 private:
  QTableViewWrap(const v8::Arguments& args);
  ~QTableViewWrap();
  
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods
  DEFINE_METHOD(on)
  DEFINE_METHOD(off)
				
	DEFINE_METHOD(setModel)
	DEFINE_METHOD(setRootIndex)

	DEFINE_METHOD(resizeColumnsToContents)
	DEFINE_METHOD(resizeRowsToContents)
	DEFINE_METHOD(scrollToBottom)
	DEFINE_METHOD(scrollToTop)
	DEFINE_METHOD(setAlternatingRowColors)
	DEFINE_METHOD(setColumnWidth)
	DEFINE_METHOD(setDragDropMode)
	DEFINE_METHOD(setEditTriggers)
	DEFINE_METHOD(setRowDefaultHeight)
	DEFINE_METHOD(setRowHeight)
	DEFINE_METHOD(setSelectionBehavior)
	DEFINE_METHOD(setSelectionMode)
	DEFINE_METHOD(setShowGrid)
	
	DEFINE_METHOD(setColumnHidden)
	DEFINE_METHOD(setVerticalHeaderVisible)
	
	DEFINE_METHOD(sortByColumn)
	DEFINE_METHOD(setSortingEnabled)
	
	DEFINE_METHOD(setHorizontalStretchLastSection)
	DEFINE_METHOD(setVerticalStretchLastSection)
	DEFINE_METHOD(setHorizontalHeaderDefaultAlignment)
	
	DEFINE_METHOD(setDragEnabled)
	
	DEFINE_METHOD(setCurrentIndex)
	DEFINE_METHOD(selectedIndexes)
	DEFINE_METHOD(setSelectedIndexes)
	DEFINE_METHOD(indexAt)
	
  // Wrapped object
  QTableView* q_;
};

#endif
