#ifndef QTABLEWIDGETWRAP_H
#define QTABLEWIDGETWRAP_H

#include "qwidget.h"
#include "../Types/qtablewidgetitem.h"

class QTableWidgetWrap : public node::ObjectWrap {
	
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  QTableWidget* GetWrapped() const { return q_; };
  void SetWrapped(QTableWidget *q) { q_ = q; };
  static v8::Handle<v8::Value> NewInstance(QTableWidget *q);
  static v8::Handle<v8::Value> NewInstance(QTabBar *q);
	bool hasEvents;
	
 private:
  QTableWidgetWrap(const v8::Arguments& args);
  ~QTableWidgetWrap();
  
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods
  DEFINE_METHOD(on)
  DEFINE_METHOD(off)

//- item (int row, int col) -> string
//- setAlternatingRowColors (bool)
//- setColumnCount (int)
//- setCurrentCell (int row, int col)
//- setItem (int row, int col, string)
//- setRowCount (int)
//- sortItems (int column, int order)
//- setHorizontalHeaderLabels (list)
//- setVerticalHeaderLabels (list)
				
	DEFINE_METHOD(item)
	DEFINE_METHOD(setAlternatingRowColors)
	DEFINE_METHOD(setColumnCount)
	DEFINE_METHOD(setCurrentCell)
	DEFINE_METHOD(setItem)
	DEFINE_METHOD(setRowCount)
	DEFINE_METHOD(sortByColumn)
	DEFINE_METHOD(sortItems)
	DEFINE_METHOD(setHorizontalHeaderLabels)
	DEFINE_METHOD(setVerticalHeaderLabels)

	DEFINE_METHOD(setHorizontalHeaderVisible)
	DEFINE_METHOD(setVerticalHeaderVisible)
	DEFINE_METHOD(resizeColumnsToContents)
	DEFINE_METHOD(resizeRowsToContents)
	DEFINE_METHOD(setColumnWidth)
	
	DEFINE_METHOD(setRowHeight)
	DEFINE_METHOD(setRowDefaultHeight)
	
	DEFINE_METHOD(setHorizontalHeaderResizeMode)
	DEFINE_METHOD(setVerticalHeaderResizeMode)
	DEFINE_METHOD(setHorizontalStretchLastSection)
	DEFINE_METHOD(setVerticalStretchLastSection)
	
	DEFINE_METHOD(setHorizontalHeaderDefaultAlignment)
	DEFINE_METHOD(setVerticalHeaderDefaultAlignment)
	
	DEFINE_METHOD(horizontalHeaderItem)
	DEFINE_METHOD(verticalHeaderItem)
	
	DEFINE_METHOD(setHorizontalHeaderMovable)
	DEFINE_METHOD(setVerticalHeaderMovable)
	
	DEFINE_METHOD(insertRow)
	DEFINE_METHOD(removeRow)
	
	DEFINE_METHOD(setSelectionBehavior)
	DEFINE_METHOD(setSelectionMode)
	DEFINE_METHOD(setEditTriggers)
	DEFINE_METHOD(setDragDropMode)
	
	DEFINE_METHOD(setCellWidget)
	DEFINE_METHOD(cellWidget)
	DEFINE_METHOD(removeCellWidget)
	
	DEFINE_METHOD(setItemPrototype)
	
	DEFINE_METHOD(currentRow)
	
	DEFINE_METHOD(scrollToTop)
	DEFINE_METHOD(scrollToBottom)
	DEFINE_METHOD(setShowGrid)
	
	DEFINE_METHOD(setRootIndex)
	
	DEFINE_METHOD(setSortingEnabled)
	DEFINE_METHOD(setDragEnabled)
	
	DEFINE_METHOD(columnCount)
	DEFINE_METHOD(rowCount)
	
	DEFINE_METHOD(selectedItems)
	DEFINE_METHOD(findItems)

	DEFINE_METHOD(itemAt)
	
	DEFINE_METHOD(currentItem)
	DEFINE_METHOD(setCurrentItem)
	
	DEFINE_METHOD(selectedIndexes)
	DEFINE_METHOD(setSelectedIndexes)
	
	//DEFINE_METHOD(test)

  // Wrapped object
  QTableWidget* q_;
};

#endif
