#ifndef QTABWIDGETWRAP_H
#define QTABWIDGETWRAP_H


#include "qwidget.h"

class QTabWidgetWrap : public node::ObjectWrap {
	
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  QTabWidget* GetWrapped() const { return q_; };
  void SetWrapped(QTabWidget *q) { q_ = q; };
  static v8::Handle<v8::Value> NewInstance(QTabWidget *q);
	bool hasEvents;
	
 private:
  QTabWidgetWrap(const v8::Arguments& args);
  ~QTabWidgetWrap();
  
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods
  DEFINE_METHOD(on)
  DEFINE_METHOD(off)

//if (!ico.isNull()) ((QTabWidget*)w)->addTab(pageWidget, ico, tabText);
//else ((QTabWidget*)w)->addTab(pageWidget, tabText);
//				
//if (!ico.isNull()) ((QTabWidget*)w)->insertTab(index, pageWidget, ico, tabText);
//else ((QTabWidget*)w)->insertTab(index, pageWidget, tabText);

//- addTab ( object widget, string ico, string text || widget, text ) -> ???
//- count () -> int
//- currentIndex () -> int
//- insertTab (int index, object widget, string ico, string text || index, widget, text) -> ???
//- removeTab (int index)
//- setMovable (bool)
//- setShape (int)
//- setTabEnabled (int index, bool enabled)
//- setTabsClosable (bool)
//- setTabText (int index, string text)
		//- setTabTextColor (int index, color)
//- setTabToolTip int index, string text)
//- setTabWhatsThis (int index, string text)
//- setUsesScrollButtons (bool)

	DEFINE_METHOD(addTab)
	DEFINE_METHOD(count)
	DEFINE_METHOD(currentIndex)
	DEFINE_METHOD(insertTab)
	DEFINE_METHOD(removeTab)
	DEFINE_METHOD(setMovable)
	DEFINE_METHOD(setTabShape)
	DEFINE_METHOD(setTabEnabled)
	DEFINE_METHOD(setTabsClosable)
	DEFINE_METHOD(setTabText)
	//DEFINE_METHOD(setTabTextColor)
	DEFINE_METHOD(setTabToolTip)
	DEFINE_METHOD(setTabWhatsThis)
	DEFINE_METHOD(setUsesScrollButtons)
	
	DEFINE_METHOD(setTabPosition)
	
	//DEFINE_METHOD(tabBar)
		
  // Wrapped object
  QTabWidget* q_;
};

#endif
