#ifndef QTEXTBROWSERWRAP_H
#define QTEXTBROWSERWRAP_H


#include "qwidget.h"

class QTextBrowserWrap : public node::ObjectWrap {
	
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  QTextBrowser* GetWrapped() const { return q_; };
  void SetWrapped(QTextBrowser *q) { q_ = q; };
  static v8::Handle<v8::Value> NewInstance(QTextBrowser *q);
	bool hasEvents;
	
 private:
  QTextBrowserWrap(const v8::Arguments& args);
  ~QTextBrowserWrap();
  
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods
  DEFINE_METHOD(on)
  DEFINE_METHOD(off)

//- backward ()
//- forward ()
//- home ()
//- reload ()
//- setOpenLinks (bool)
//- setOpenExternalLinks (bool)
//- setSource (string)
//- source () -> string
//- setHtml (string)
//- setText (string)

	DEFINE_METHOD(backward)
	DEFINE_METHOD(forward)
	DEFINE_METHOD(home)
	DEFINE_METHOD(reload)
	DEFINE_METHOD(setOpenLinks)
	DEFINE_METHOD(setOpenExternalLinks)
	DEFINE_METHOD(setSource)
	DEFINE_METHOD(source)
	DEFINE_METHOD(setHtml)
	DEFINE_METHOD(setText)
			
  // Wrapped object
  QTextBrowser* q_;
};

#endif
