#ifndef QTOOLBARWRAP_H
#define QTOOLBARWRAP_H


#include "qwidget.h"
#include "qaction.h"

class QToolBarWrap : public node::ObjectWrap {
	
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  QToolBar* GetWrapped() const { return q_; };
  void SetWrapped(QToolBar *q) { q_ = q; };
  static v8::Handle<v8::Value> NewInstance(QToolBar *q);
	bool hasEvents;
	
 private:
  QToolBarWrap(const v8::Arguments& args);
  ~QToolBarWrap();
  
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods
  DEFINE_METHOD(on)
  DEFINE_METHOD(off)

  DEFINE_METHOD(addAction)
  DEFINE_METHOD(addSeparator)
  		
  DEFINE_METHOD(setIconSize)
  
  DEFINE_METHOD(addWidget)
  
  DEFINE_METHOD(setOrientation)
  DEFINE_METHOD(setAllowedAreas)
  
  // Wrapped object
  QToolBar* q_;
};

#endif
