#ifndef QTOOLBUTTONWRAP_H
#define QTOOLBUTTONWRAP_H

#include "qwidget.h"

class QToolButtonWrap : public node::ObjectWrap {
	
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  QToolButton* GetWrapped() const { return q_; };
  void SetWrapped(QToolButton *q) { q_ = q; };
  static v8::Handle<v8::Value> NewInstance(QToolButton *q);
	bool hasEvents;
	
 private:
  QToolButtonWrap(const v8::Arguments& args);
  ~QToolButtonWrap();
  
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods
  DEFINE_METHOD(on)
  DEFINE_METHOD(off)

  DEFINE_METHOD(menu)
  DEFINE_METHOD(setMenu)
  DEFINE_METHOD(setToolButtonStyle)
  DEFINE_METHOD(setPopupMode)
  
  DEFINE_METHOD(setDefaultAction)
  
  // abstractButton
  DEFINE_METHOD(setText)
  DEFINE_METHOD(text)
  DEFINE_METHOD(setIcon)
  DEFINE_METHOD(setCheckable)
  DEFINE_METHOD(setChecked)
  DEFINE_METHOD(isChecked)
  
  // Wrapped object
  QToolButton* q_;
};

#endif
