#ifndef QTREEVIEWWRAP_H
#define QTREEVIEWWRAP_H

#include "qwidget.h"

#include "../Objects/qfilesystemmodel.h"
#include "../Types/qmodelindex.h"

class QTreeViewWrap : public node::ObjectWrap {
	
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  QTreeView* GetWrapped() const { return q_; };
  void SetWrapped(QTreeView *q) { q_ = q; };
  static v8::Handle<v8::Value> NewInstance(QTreeView *q);
	bool hasEvents;
	
 private:
  QTreeViewWrap(const v8::Arguments& args);
  ~QTreeViewWrap();
  
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods
  DEFINE_METHOD(on)
  DEFINE_METHOD(off)

//- keyboardSearch (string)
//- model () -> object
//- reset ()
//- selectAll ()
//- setAlternatingRowColors (bool)
//- setModel (object)
//- setRootIndex (object)
		//- setRootPath (string)
//- setSortingEnabled (bool)
//- sortByColumn (int column, *int order)

	DEFINE_METHOD(keyboardSearch)
	DEFINE_METHOD(model)
	DEFINE_METHOD(reset)
	DEFINE_METHOD(rootIndex)
	DEFINE_METHOD(selectAll)
	DEFINE_METHOD(setAlternatingRowColors)
	DEFINE_METHOD(setColumnHidden)
	DEFINE_METHOD(setHeaderHidden)
	DEFINE_METHOD(setModel)
	DEFINE_METHOD(setRootIndex)
	DEFINE_METHOD(setRootIsDecorated)
	DEFINE_METHOD(setSortingEnabled)
	DEFINE_METHOD(sortByColumn)
		
	DEFINE_METHOD(setColumnWidth)
	DEFINE_METHOD(resizeColumnToContents)
		
	// index
	DEFINE_METHOD(currentIndex)
	DEFINE_METHOD(indexAt)
	DEFINE_METHOD(selectedIndexes)
	DEFINE_METHOD(setCurrentIndex)
	DEFINE_METHOD(setSelectedIndexes)
	
	DEFINE_METHOD(setExpanded)
	
  // Wrapped object
  QTreeView* q_;
};

#endif
