#ifndef QTREEWIDGETWRAP_H
#define QTREEWIDGETWRAP_H

#include "qwidget.h"
#include "../Types/qrect.h"
#include "../Types/qtreewidgetitem.h"

class QTreeWidgetWrap : public node::ObjectWrap {
	
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  QTreeWidget* GetWrapped() const { return q_; };
  void SetWrapped(QTreeWidget *q) { q_ = q; };
  static v8::Handle<v8::Value> NewInstance(QTreeWidget *q);
	bool hasEvents;
	
 private:
  QTreeWidgetWrap(const v8::Arguments& args);
  ~QTreeWidgetWrap();
  
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods
  DEFINE_METHOD(on)
  DEFINE_METHOD(off)

	DEFINE_METHOD(addTopLevelItem)
	DEFINE_METHOD(columnCount)
	DEFINE_METHOD(currentColumn)
	DEFINE_METHOD(currentItem)
	DEFINE_METHOD(insertTopLevelItem)
	DEFINE_METHOD(invisibleRootItem)
	DEFINE_METHOD(itemAt)
	DEFINE_METHOD(selectedItems)
	DEFINE_METHOD(setColumnCount)
	DEFINE_METHOD(setCurrentItem)
	DEFINE_METHOD(setHeaderItem)
	DEFINE_METHOD(setHeaderLabel)
	DEFINE_METHOD(setHeaderLabels)
	DEFINE_METHOD(sortColumn)
	DEFINE_METHOD(sortItems)
	DEFINE_METHOD(topLevelItem)
	DEFINE_METHOD(topLevelItemCount)
	DEFINE_METHOD(visualItemRect)
	
	DEFINE_METHOD(setHeaderHidden)
	
	DEFINE_METHOD(setDropIndicatorShown)
	DEFINE_METHOD(setDragDropMode) 
		
	DEFINE_METHOD(currentIndex)
	DEFINE_METHOD(indexAt)
	DEFINE_METHOD(selectedIndexes)
	DEFINE_METHOD(setCurrentIndex)
	DEFINE_METHOD(setSelectedIndexes)

  // Wrapped object
  QTreeWidget* q_;
};

#endif
