#ifndef QWIDGETWRAP_H
#define QWIDGETWRAP_H

#include "../qt.h"
#include "../receiver.h"
#include "../Types/qsize.h"

#include "../Events/qevent.h"
#include "../Events/qcontextmenuevent.h"
#include "../Events/qdropevent.h"
#include "../Events/qkeyevent.h"
#include "../Events/qmouseevent.h"
#include "../Events/qdragenterevent.h"
#include "../Events/qdragmoveevent.h"

#include "../Objects/qobject.h"

#include "qwidgettpl.h"

#include "../macros.h"


/*************************************************
 QWidgetWrap
*************************************************/
class QWidgetWrap : public node::ObjectWrap {
	
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  static void InitializeMethods(v8::Handle<v8::FunctionTemplate> tpl);
  
  QWidget* GetWrapped() const { return q_; };
  void SetWrapped(QWidget *q) { q_ = q;};
  
  static v8::Handle<v8::Value> NewInstance(QWidget *q);

	// test
	//static QList<QWidgetWrap*> instances;
    
	bool hasEvents;
	//list<Receiver*> filterList;
		
 private:
  QWidgetWrap(const Arguments& args);
  ~QWidgetWrap();
  
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

 protected:
 
  // Wrapped methods
  DEFINE_METHOD(on)
	DEFINE_METHOD(off)
  	
  // Wrapped object
  QWidget* q_;
};

#endif
