#ifndef QWIDGETTPL_H
#define QWIDGETTPL_H

#include "../qt.h"

#include "../Types/qimage.h"
#include "../Types/qpalette.h"
#include "../Types/qpoint.h"
#include "../Types/qrect.h"
#include "../Types/qmodelindex.h"

#include "../Objects/qgridlayout.h"
#include "../Objects/qhboxlayout.h"
#include "../Objects/qvboxlayout.h"
#include "../Objects/qfilesystemmodel.h"

#include "qmenu.h"
#include "Dialogs/qdialog.h"

//test
#include "../getwrap.h"

using namespace std;
using namespace v8;

#define ADD_METHOD_WIDGET_TPL(X,Y,Z) tpl->PrototypeTemplate()->Set(String::NewSymbol(#X), FunctionTemplate::New(QWidgetTpl<Y,Z>::X)->GetFunction());

//#define ADD_STATIC_METHOD_WIDGET_TPL(X,Y,Z) tpl->Set(String::NewSymbol(#X), FunctionTemplate::New(QWidgetTpl<Y,Z>::X)->GetFunction());

#define ADD_WIDGET_METHODS(TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(childAt,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(className,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(close,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(destroy,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(equals,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(findChild,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(font,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(geometry,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(grabImage,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(hasMouseTracking,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(height,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(hide,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(inspect,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(isEnabled,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(isMinimized,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(isVisible,TWC,TIC)\
	ADD_METHOD_WIDGET_TPL(layout,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(maximumHeight,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(maximumSize,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(maximumWidth,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(minimumHeight,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(minimumSize,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(minimumWidth,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(move,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(objectName,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(palette,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(parent,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(parentWidget,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(pos,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(rect,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(resize,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(setAcceptDrops,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(setContextMenuPolicy,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(setEnabled,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(setFixedHeight,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(setFixedSize,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(setFixedWidth,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(setFocusPolicy,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(setFont,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(setGeometry,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(setLayout,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(setMaximumHeight,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(setMaximumSize,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(setMaximumWidth,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(setMinimumHeight,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(setMinimumSize,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(setMinimumWidth,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(setMouseTracking,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(setObjectName,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(setPalette,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(setParent,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(setStatusTip,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(setStyleSheet,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(setToolTip,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(setVisible,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(setWindowIcon,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(setWindowModality,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(setWindowState,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(setWindowTitle,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(show,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(size,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(styleSheet,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(toolTip,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(update,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(width,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(windowModality,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(windowState,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(winId,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(x,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(y,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(listeners,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(installEventFilter,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(setSizePolicy,TWC,TIC) \
	ADD_METHOD_WIDGET_TPL(setWindowFlags,TWC,TIC)
	
template<class TW, class TI> class QWidgetTpl{
	
 public:
	// test
	//static QList<TW*> instances;
	
 public:
	DEFINE_METHOD(childAt)
	DEFINE_METHOD(className)
	DEFINE_METHOD(close)
	DEFINE_METHOD(destroy)
	DEFINE_METHOD(equals)
	DEFINE_METHOD(findChild)
	DEFINE_METHOD(font)
	DEFINE_METHOD(geometry)
	DEFINE_METHOD(grabImage)
	DEFINE_METHOD(hasMouseTracking)
	DEFINE_METHOD(height)
	DEFINE_METHOD(hide)
	DEFINE_METHOD(inspect)
	DEFINE_METHOD(isEnabled)
	DEFINE_METHOD(isMinimized)
	DEFINE_METHOD(isVisible)
	DEFINE_METHOD(layout)
	DEFINE_METHOD(maximumHeight)
	DEFINE_METHOD(maximumSize)
	DEFINE_METHOD(maximumWidth)
	DEFINE_METHOD(minimumHeight)
	DEFINE_METHOD(minimumSize)
	DEFINE_METHOD(minimumWidth)
	DEFINE_METHOD(move)
	DEFINE_METHOD(objectName)
	DEFINE_METHOD(palette)
	DEFINE_METHOD(parent)
	DEFINE_METHOD(parentWidget)
	DEFINE_METHOD(pos)
	DEFINE_METHOD(rect)
	DEFINE_METHOD(resize)
	DEFINE_METHOD(setAcceptDrops)
	DEFINE_METHOD(setContextMenuPolicy)
	DEFINE_METHOD(setEnabled)
	DEFINE_METHOD(setFixedHeight)
	DEFINE_METHOD(setFixedSize)
	DEFINE_METHOD(setFixedWidth)
	DEFINE_METHOD(setFocusPolicy)
	DEFINE_METHOD(setFont)
	DEFINE_METHOD(setGeometry)
	DEFINE_METHOD(setLayout)
	DEFINE_METHOD(setMaximumSize)
	DEFINE_METHOD(setMinimumSize)
	
	DEFINE_METHOD(setMaximumWidth)
	DEFINE_METHOD(setMinimumWidth)
	DEFINE_METHOD(setMaximumHeight)
	DEFINE_METHOD(setMinimumHeight)
	
	DEFINE_METHOD(setMouseTracking)
	DEFINE_METHOD(setObjectName)
	DEFINE_METHOD(setPalette)
	DEFINE_METHOD(setParent)
	DEFINE_METHOD(setStatusTip)
	DEFINE_METHOD(setStyleSheet)
	DEFINE_METHOD(setToolTip)
	DEFINE_METHOD(setVisible)
	DEFINE_METHOD(setWindowIcon)
	DEFINE_METHOD(setWindowModality)
	DEFINE_METHOD(setWindowState)
	DEFINE_METHOD(setWindowTitle)
	DEFINE_METHOD(show)
	DEFINE_METHOD(size)
	DEFINE_METHOD(styleSheet)
	DEFINE_METHOD(toolTip)
	DEFINE_METHOD(update)
	DEFINE_METHOD(width)
	DEFINE_METHOD(windowModality)
	DEFINE_METHOD(windowState)
	DEFINE_METHOD(winId)
	DEFINE_METHOD(x)
	DEFINE_METHOD(y)
	DEFINE_METHOD(listeners)
	DEFINE_METHOD(installEventFilter)
	DEFINE_METHOD(setSizePolicy)
	DEFINE_METHOD(setWindowFlags)
	
};

// childAt (int, int) -> object widget
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::childAt(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
  
  QWidget * widget = q->childAt(args[0]->IntegerValue(),args[1]->IntegerValue());
  
  //TODO: wrap according to actual className  
  return scope.Close(QWidgetWrap::NewInstance(widget));
}

// className () -> string
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::className(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
  
	return scope.Close(qt_v8::FromQString(q->metaObject()->className()));
}

// close ()
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::close(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
  q->close();
  return scope.Close(Undefined());
}

//- destroy ()
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::destroy(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
  
  //TEST
  //instances.removeOne(w);
  	
  delete q;
  
  return scope.Close(Undefined());
}

//- equals ()
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::equals(const Arguments& args) {
  HandleScope scope;
  TW* w  = node::ObjectWrap::Unwrap<TW>(args.This());
  TW* w2 = node::ObjectWrap::Unwrap<TW>(args[0]->ToObject());
    
  return scope.Close(Boolean::New( w->GetWrapped()==w2->GetWrapped() ));
}

// findChild (string widgetName) -> object
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::findChild(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
    
  QWidget * widget = q->findChild<QWidget *>(qt_v8::ToQString(args[0]->ToString()));
  
  return scope.Close(GetInstanceWrap(widget));
}

// font () -> string
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::font(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
    
  QFont font = q->font();
  
  return scope.Close(qt_v8::FromQString(font.toString()));
}

// geometry () -> object QRect
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::geometry(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
  return scope.Close( QRectWrap::NewInstance(q->geometry()) );
}

// grabImage () -> object QImage
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::grabImage(const Arguments& args) {
  HandleScope scope;
	
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
  QPixmap p;
  
	if (args.Length()>0){
		//windowId = (long)getStageHwnd();
		int windowId = args[0]->IntegerValue();
		p = QPixmap::grabWindow( (WId)windowId );		
	}else{
		p = QPixmap::grabWidget(q);
	}
  
	//if (od->createdByDir) delete img; // ???
	QImage* img = new QImage(p.toImage()); //.mirrored()
  //od->createdByDir = true;
  
  // wrap as object
	//  Local<Object> instance = constructor->NewInstance(0, NULL);
	//  QImageWrap* w = node::ObjectWrap::Unwrap<QImageWrap>(instance);
	//  w->SetWrapped(q);  
 
 	return scope.Close(QImageWrap::NewInstance(img));
}

// hasMouseTracking () -> bool
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::hasMouseTracking(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
  return scope.Close(Boolean::New(q->hasMouseTracking()));
}

// height () -> int
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::height(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
  return scope.Close( Integer::New(q->height()) );
}

// hide ()
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::hide(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
  q->hide();
  return scope.Close(Undefined());
}

//  TEST: USED BY CONSOLE.LOG!
// inspect() -> string
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::inspect(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
  
  char buf [32];
  sprintf (buf, "[object %s]", q->metaObject()->className());
  
  return scope.Close(qt_v8::FromQString(buf));
}
//function(){return "[object "+this.className()+"]";};

// isEnabled () -> bool
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::isEnabled(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
  return scope.Close(Boolean::New(q->isEnabled()));
}

// isMinimized () -> bool
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::isMinimized(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
  return scope.Close(Boolean::New(q->isMinimized()));
}

// isVisible () -> bool
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::isVisible(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
  return scope.Close(Boolean::New(q->isVisible()));
}

// layout () -> object layout
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::layout(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
  
  QLayout* layout = q->layout();
  
  const char * qclass = layout->metaObject()->className();
  	
  if (qclass=="QGridLayout"){
  	return scope.Close(QGridLayoutWrap::NewInstance((QGridLayout *)layout));
  }else if(qclass=="QHBoxLayout"){
  	return scope.Close(QHBoxLayoutWrap::NewInstance((QHBoxLayout *)layout));
  }else if(qclass=="QVBoxLayout"){
  	return scope.Close(QVBoxLayoutWrap::NewInstance((QVBoxLayout *)layout));
  }
  
  //TMP
  //else return scope.Close(String::New(qclass));
  //return scope.Close(qt_v8::FromQString(layout->metaObject()->className()));
  //return scope.Close(QLayoutWrap::NewInstance(layout));

  return scope.Close(Undefined());
}

// maximumHeight () -> int
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::maximumHeight(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
  return scope.Close( Integer::New(q->maximumHeight()) );
}

// maximumSize () -> QSize
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::maximumSize(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
  return scope.Close( QSizeWrap::NewInstance(q->maximumSize()) );
}

// maximumWidth () -> int
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::maximumWidth(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
  return scope.Close( Integer::New(q->maximumWidth()) );
}

// minimumHeight () -> int
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::minimumHeight(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
  return scope.Close( Integer::New(q->minimumHeight()) );
}

// minimumSize () -> QSize
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::minimumSize(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
  return scope.Close( QSizeWrap::NewInstance(q->minimumSize()) );
}

// minimumWidth () -> int
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::minimumWidth(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
  return scope.Close( Integer::New(q->minimumWidth()) );
}

// move (int, int)
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::move(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
  q->move(args[0]->IntegerValue(), args[1]->IntegerValue());
  return scope.Close(Undefined());
}

// objectName () -> string
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::objectName(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
  return scope.Close(qt_v8::FromQString(q->objectName()));
}

// palette () -> object
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::palette(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
    
  const QPalette pal = q->palette();
    
  return scope.Close(QPaletteWrap::NewInstance(pal)); 
}

//- parent () -> object
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::parent(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
  
  // TEST
  QObject* o = q->parent();
  //MyTableWidgetItem const *item = dynamic_cast<MyTableWidgetItem const*>(&other);
  QWidget* widget = dynamic_cast<QWidget*>(o);
  return scope.Close(widget?QWidgetWrap::NewInstance(widget):Undefined());
  
  
  // SAME AS parentWidget?
  //return parentWidget(args);
  
//  QObject* parent = q->parent();
//  return scope.Close(parent?qt_v8::FromQString(parent->objectName()):Undefined());
  
//  //TODO: wrap object according to actual className?
//  QWidget * widget = q->parent();
//  return scope.Close(QWidgetWrap::NewInstance(widget));

}

// parentWidget () -> object
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::parentWidget(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
    
  QWidget* widget = q->parentWidget();
  
  //TODO: wrap according to actual className?
  return scope.Close(widget?QWidgetWrap::NewInstance(widget):Undefined()); 
}

// pos () -> object QPoint
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::pos(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
      
  return scope.Close( QPointWrap::NewInstance(q->pos()) );
}

// rect () -> object QRect
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::rect(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
  return scope.Close( QRectWrap::NewInstance(q->rect()) );
}

// resize (int, int)
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::resize(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
  q->resize(args[0]->IntegerValue(), args[1]->IntegerValue());
  return scope.Close(Undefined());
}

// setAcceptDrops (bool)
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::setAcceptDrops(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
  q->setAcceptDrops(args[0]->BooleanValue());
  return scope.Close(Undefined());
}

// setContextMenuPolicy (int)
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::setContextMenuPolicy(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
  q->setContextMenuPolicy((Qt::ContextMenuPolicy)args[0]->IntegerValue());
  return scope.Close(Undefined());
}

// setEnabled (bool)
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::setEnabled(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
  q->setEnabled(args[0]->BooleanValue());
  return scope.Close(Undefined());
}

// setFixedHeight (int)
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::setFixedHeight(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
    
	q->setFixedHeight(args[0]->IntegerValue());
    
  return scope.Close(Undefined());
}

// setFixedSize (int w, int h)
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::setFixedSize(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
    
	q->setFixedSize(args[0]->IntegerValue(), args[1]->IntegerValue());
    
  return scope.Close(Undefined());
}

// setFixedWidth (int)
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::setFixedWidth(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
    
	q->setFixedWidth(args[0]->IntegerValue());
    
  return scope.Close(Undefined());
}

// setFocusPolicy (int)
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::setFocusPolicy(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
  q->setFocusPolicy((Qt::FocusPolicy)(args[0]->IntegerValue()));
  return scope.Close(Undefined());
}

// setFont (string, *int pointSize, int weight, bool italic)
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::setFont(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
    
  int pointSize = -1;
  int weight = -1;
  bool italic = false;
  if (args.Length() > 1) pointSize = args[1]->IntegerValue();
  if (args.Length() > 2) weight = args[2]->IntegerValue();
  if (args.Length() > 3) italic = args[3]->BooleanValue();
  q->setFont( QFont(qt_v8::ToQString(args[0]->ToString()), pointSize, weight, italic) );
  
  return scope.Close(Undefined());
}

// setGeometry (object QRect)
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::setGeometry(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
    
  QRectWrap* rect_wrap = node::ObjectWrap::Unwrap<QRectWrap>(args[0]->ToObject());
  q->setGeometry(*rect_wrap->GetWrapped());
    
  return scope.Close(Undefined());
}

// setLayout (object layout)
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::setLayout(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped(); 
  
  QString qclass = qt_v8::ToQString(args[0]->ToObject()->GetConstructorName());
  
  if (qclass=="QGridLayout"){
	  QGridLayoutWrap* layout_wrap = node::ObjectWrap::Unwrap<QGridLayoutWrap>(args[0]->ToObject());
	  QLayout* layout = layout_wrap->GetWrapped();
		q->setLayout(layout);
  }else if(qclass=="QHBoxLayout"){
	  QHBoxLayoutWrap* layout_wrap = node::ObjectWrap::Unwrap<QHBoxLayoutWrap>(args[0]->ToObject());
	  QLayout* layout = layout_wrap->GetWrapped();
		q->setLayout(layout);
  }else if(qclass=="QVBoxLayout"){
	  QVBoxLayoutWrap* layout_wrap = node::ObjectWrap::Unwrap<QVBoxLayoutWrap>(args[0]->ToObject());
	  QLayout* layout = layout_wrap->GetWrapped();
		q->setLayout(layout);
  }

  return scope.Close(Undefined());
}

//- setMaximumHeight (int)
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::setMaximumHeight(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
    
	q->setMaximumHeight(args[0]->IntegerValue());
    
  return scope.Close(Undefined());
}

//- setMaximumSize (int w, int h)
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::setMaximumSize(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
    
	q->setMaximumSize(args[0]->IntegerValue(), args[1]->IntegerValue());
    
  return scope.Close(Undefined());
}

//- setMaximumWidth (int)
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::setMaximumWidth(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
    
	q->setMaximumWidth(args[0]->IntegerValue());
    
  return scope.Close(Undefined());
}

//- setMinimumHeight (int)
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::setMinimumHeight(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
    
	q->setMinimumHeight(args[0]->IntegerValue());
    
  return scope.Close(Undefined());
}

//- setMinimumSize (int w, int h)
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::setMinimumSize(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
    
	q->setMinimumSize(args[0]->IntegerValue(), args[1]->IntegerValue());
    
  return scope.Close(Undefined());
}

//- setMinimumWidth (int)
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::setMinimumWidth(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
    
	q->setMinimumWidth(args[0]->IntegerValue());
    
  return scope.Close(Undefined());
}

// setMouseTracking (bool)
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::setMouseTracking(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
  q->setMouseTracking(args[0]->BooleanValue());
  return scope.Close(Undefined());
}

// setObjectName (string)
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::setObjectName(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
  q->setObjectName(qt_v8::ToQString(args[0]->ToString()));
  return scope.Close(Undefined());
}

// setPalette (object)
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::setPalette(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
    
  QPaletteWrap* pal_wrap = node::ObjectWrap::Unwrap<QPaletteWrap>(args[0]->ToObject());
  q->setPalette(*pal_wrap->GetWrapped());
    
  return scope.Close(Undefined());
}

// setParent (object widget)
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::setParent(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();

  //TODO: wrap according to actual className ?
  QWidgetWrap* widget_wrap = node::ObjectWrap::Unwrap<QWidgetWrap>(args[0]->ToObject());
  q->setParent(widget_wrap->GetWrapped());
    
  return scope.Close(Undefined());
}

//- setStatusTip (string)
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::setStatusTip(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
    
  q->setStatusTip(qt_v8::ToQString(args[0]->ToString()));
  
  return scope.Close(Undefined());
}

// setStyleSheet (string)
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::setStyleSheet(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
  
  q->setStyleSheet(qt_v8::ToQString(args[0]->ToString()));
  
  return scope.Close(Undefined());
}

// setToolTip (string)
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::setToolTip(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
    
  q->setToolTip(qt_v8::ToQString(args[0]->ToString()));
  
  return scope.Close(Undefined());
}

// setVisible (bool)
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::setVisible(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
  q->setVisible(args[0]->BooleanValue());
  return scope.Close(Undefined());
}

// setWindowIcon (string|image icon)
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::setWindowIcon(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();

	QIcon ico;
  if (args[0]->IsString()) { //A: LOAD ICON FROM FILE
		 ico.addFile(qt_v8::ToQString(args[0]->ToString()));
		 
  } else if (args[0]->IsObject() && qt_v8::ToQString(args[0]->ToObject()->GetConstructorName())=="QImage") { 
  	  	
  	// C:LOAD ICON FROM IMAGE
	  QImageWrap* img_wrap = node::ObjectWrap::Unwrap<QImageWrap>(args[0]->ToObject());
	  QImage* img = img_wrap->GetWrapped();
		QPixmap pm = QPixmap::fromImage(*img);
		ico.addPixmap(pm);
	}
  if (!ico.isNull()) q->setWindowIcon(ico);

  return scope.Close(Undefined());
}

// setWindowModality (int)
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::setWindowModality(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
    
 q->setWindowModality((Qt::WindowModality)args[0]->IntegerValue());
    
  return scope.Close(Undefined());
}

//- setWindowState (int)
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::setWindowState(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
    
  q->setWindowState((Qt::WindowState)args[0]->IntegerValue());
  
  return scope.Close(Undefined());
}

// setWindowTitle (string)
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::setWindowTitle(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
  q->setWindowTitle(qt_v8::ToQString(args[0]->ToString()));
  return scope.Close(Undefined());
}

// show ()
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::show(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
  q->show();
  return scope.Close(Undefined());
}

// size () -> object QSize ???
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::size(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
  return scope.Close( QSizeWrap::NewInstance(q->size()) );
}

// styleSheet () -> string
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::styleSheet(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
  
	return scope.Close(qt_v8::FromQString(q->styleSheet()));
}

// toolTip () -> string
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::toolTip(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
      
  return scope.Close(qt_v8::FromQString(q->toolTip()));
}

// update ()
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::update(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
  q->update();
  return scope.Close(Undefined());
}

// width () -> int
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::width(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
  return scope.Close( Integer::New(q->width()) );
}

// windowModality () -> int
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::windowModality(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
    
  return scope.Close( Integer::New(q->windowModality()) );
}

//- windowState () -> int
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::windowState(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
    
  return scope.Close( Integer::New(q->windowState()) );
}

// winId () -> int
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::winId(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
  return scope.Close(Integer::New((int)q->winId()));
}

// x () -> int
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::x(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
  return scope.Close(Integer::New(q->x()));
}

// y () -> int
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::y(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
  return scope.Close(Integer::New(q->y()));
}

// listeners
template<class TW, class TI>
Handle<Value> QWidgetTpl<TW,TI>::listeners(const Arguments& args) {
	HandleScope scope;
	
//  QMainWindowWrap* w = node::ObjectWrap::Unwrap<QMainWindowWrap>(args.This());

//	//QMainWindow* q = w->GetWrapped();
//	QImpl<QMainWindow>* q = (QImpl<QMainWindow>*)(w->GetWrapped()); //TODO: check if really QMainWindowImpl!!!
	
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
	if (!w->hasEvents) return scope.Close(Undefined());
  
  //TI* q = w->GetWrapped();
  QImpl<TI>* q = (QImpl<TI>*)(w->GetWrapped());
  
 
	QString sign = qt_v8::ToQString(args[0]->ToString());
	QList<v8::Persistent<v8::Value>> callbacks = q->eventCallbacks.values(sign);
	
  // create array
  int cnt = callbacks.count();
  Handle<Array> cbArray = v8::Array::New(cnt);
  for (int i=0;i<cnt;i++){  	
  	cbArray->Set(i, callbacks[cnt-i-1]);
  }
  
  return scope.Close(cbArray);
}

//template<class TW, class TI>
//Handle<Value> QWidgetTpl<TW,TI>::addListener(const Arguments& args) {
//  return on(args);
//}


//TEST

// installEventFilter (int eventType, function callback)
template<class TW, class TI>
Handle<Value> QWidgetTpl<TW,TI>::installEventFilter(const Arguments& args) {
  HandleScope scope;
  
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
 
 	int eventType = args[0]->IntegerValue();
	Local<Function> callback = Local<Function>::Cast(args[1]);
	
	Receiver *rec = new Receiver(callback, args.This());
	rec->eventType = eventType;
	
	q->installEventFilter(rec);
	  
  return scope.Close(Undefined());
}

// setSizePolicy (int, int)
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::setSizePolicy(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
    
  q->setSizePolicy(
  (QSizePolicy::Policy)args[0]->IntegerValue(),
  (QSizePolicy::Policy)args[1]->IntegerValue()
  );
  
  return scope.Close(Undefined());
}

// setWindowFlags (int)
template<class TW, class TI> 
Handle<Value> QWidgetTpl<TW,TI>::setWindowFlags(const Arguments& args) {
  HandleScope scope;
  TW* w = node::ObjectWrap::Unwrap<TW>(args.This());
  TI* q = w->GetWrapped();
    
  q->setWindowFlags((Qt::WindowFlags)args[0]->IntegerValue());
  
  return scope.Close(Undefined());
}

#endif