#ifndef QWIZARDPAGEWRAP_H
#define QWIZARDPAGEWRAP_H


#include "qwidget.h"

class QWizardPageWrap : public node::ObjectWrap {
	
 public:
  static void Initialize(v8::Handle<v8::Object> target);
  QWizardPage* GetWrapped() const { return q_; };
  void SetWrapped(QWizardPage *q) { q_ = q; };
  static v8::Handle<v8::Value> NewInstance(QWizardPage *q);
	bool hasEvents;
	
 private:
  QWizardPageWrap(const v8::Arguments& args);
  ~QWizardPageWrap();
  
  static v8::Persistent<v8::Function> constructor;
  static v8::Handle<v8::Value> New(const v8::Arguments& args);

  // Wrapped methods
	DEFINE_METHOD(on)
  DEFINE_METHOD(off)
  
	DEFINE_METHOD(buttonText)
	DEFINE_METHOD(pixmap)
	DEFINE_METHOD(setButtonText)
	DEFINE_METHOD(setPixmap)
	DEFINE_METHOD(setSubTitle)
	DEFINE_METHOD(setFinalPage)
	DEFINE_METHOD(setTitle)
	DEFINE_METHOD(subTitle)
	DEFINE_METHOD(title)
		
  // Wrapped object
  QWizardPage* q_;
};

#endif
