#include "getwrap.h"

// EVENTS
#include "Events/qevent.h"
#include "Events/qcontextmenuevent.h"
#include "Events/qdropevent.h"
#include "Events/qkeyevent.h"
#include "Events/qmouseevent.h"
#include "Events/qdragenterevent.h"
//#include "Events/qdragmoveevent.h"
//#include "Events/qkeyevent.h"
//#include "Events/qmouseevent.h"


// QOBJECTS
#include "Objects/qgridlayout.h"
#include "Objects/qhboxlayout.h"
#include "Objects/qvboxlayout.h"
#include "Objects/qdrag.h"


// WIDGETS
#include "Widgets/qcalendarwidget.h"
#include "Widgets/qcheckbox.h"
#include "Widgets/qcombobox.h"
#include "Widgets/qdateedit.h"
#include "Widgets/qdatetimeedit.h"
#include "Widgets/qdial.h"
#include "Widgets/qdialogbuttonbox.h"
#include "Widgets/qframe.h"
#include "Widgets/qlabel.h"
#include "Widgets/qlineedit.h"
#include "Widgets/qlistwidget.h"
#include "Widgets/qmainwindow.h"
#include "Widgets/qmenu.h"
#include "Widgets/qmenubar.h"
#include "Widgets/qplaintextedit.h"
#include "Widgets/qprogressbar.h"
#include "Widgets/qpushbutton.h"
#include "Widgets/qradiobutton.h"
#include "Widgets/qscrollbar.h"
#include "Widgets/qslider.h"
#include "Widgets/qspinbox.h"
#include "Widgets/qsplitter.h"
#include "Widgets/qstatusbar.h"
#include "Widgets/qtabbar.h"
#include "Widgets/qtablewidget.h"
#include "Widgets/qtabwidget.h"
#include "Widgets/qtextbrowser.h"
#include "Widgets/qtextedit.h"
#include "Widgets/qtimeedit.h"
#include "Widgets/qtoolbar.h"
#include "Widgets/qtoolbutton.h"
#include "Widgets/qtreeview.h"
#include "Widgets/qtreewidget.h"
	//#include "Widgets/qwidget.h"
#include "Widgets/qwizardpage.h"


// WIDGEST/DIALOGS
#include "Widgets/Dialogs/qdialog.h"
#include "Widgets/Dialogs/qcolordialog.h"
#include "Widgets/Dialogs/qfiledialog.h"
#include "Widgets/Dialogs/qfontdialog.h"
#include "Widgets/Dialogs/qinputdialog.h"
#include "Widgets/Dialogs/qmessagebox.h"
#include "Widgets/Dialogs/qpagesetupdialog.h"
#include "Widgets/Dialogs/qprintdialog.h"
#include "Widgets/Dialogs/qprintpreviewdialog.h"
#include "Widgets/Dialogs/qprogressdialog.h"
#include "Widgets/Dialogs/qwizard.h"

				
// TYPES
#include "Types/qcolor.h"
#include "Types/qimage.h"
#include "Types/qlistwidgetitem.h"
#include "Types/qmodelindex.h"
#include "Types/qpalette.h"
#include "Types/qpoint.h"
//#include "Types/qpointf.h"
#include "Types/qprinter.h"
#include "Types/qrect.h"
//#include "Types/qsize.h"
#include "Types/qtablewidgetitem.h"
#include "Types/qtreewidgetitem.h"


#define CONC(A,B) A ## B
#define RETURN_INSTANCE_BY_CLASS(X) if (strcmp(className,#X)==0) return CONC(X,Wrap)::NewInstance(qobject_cast<X *>(widget));

v8::Handle<v8::Value> GetInstanceWrap(QWidget *widget){
	
  const char * className = widget->metaObject()->className();
	RETURN_INSTANCE_BY_CLASS(QCalendarWidget)
	RETURN_INSTANCE_BY_CLASS(QCheckBox)
	RETURN_INSTANCE_BY_CLASS(QComboBox)
	RETURN_INSTANCE_BY_CLASS(QDateEdit)
	RETURN_INSTANCE_BY_CLASS(QDateTimeEdit)
	RETURN_INSTANCE_BY_CLASS(QDial)
	RETURN_INSTANCE_BY_CLASS(QFrame)
	RETURN_INSTANCE_BY_CLASS(QLabel)
	RETURN_INSTANCE_BY_CLASS(QLineEdit)
	RETURN_INSTANCE_BY_CLASS(QListWidget)
	RETURN_INSTANCE_BY_CLASS(QMainWindow)
	RETURN_INSTANCE_BY_CLASS(QMenu)
	RETURN_INSTANCE_BY_CLASS(QMenuBar)
	RETURN_INSTANCE_BY_CLASS(QPlainTextEdit)
	RETURN_INSTANCE_BY_CLASS(QProgressBar)
	RETURN_INSTANCE_BY_CLASS(QPushButton)
	RETURN_INSTANCE_BY_CLASS(QRadioButton)
	RETURN_INSTANCE_BY_CLASS(QScrollBar)
	RETURN_INSTANCE_BY_CLASS(QSlider)
	RETURN_INSTANCE_BY_CLASS(QSpinBox)
	RETURN_INSTANCE_BY_CLASS(QSplitter)
	RETURN_INSTANCE_BY_CLASS(QStatusBar)
//	#ifdef QT_SVG_LIB
//	  RETURN_INSTANCE_BY_CLASS(QSvgWidget)
//	#endif
	RETURN_INSTANCE_BY_CLASS(QTabBar)
	RETURN_INSTANCE_BY_CLASS(QTableWidget)
	RETURN_INSTANCE_BY_CLASS(QTabWidget)
	RETURN_INSTANCE_BY_CLASS(QTextBrowser)
	RETURN_INSTANCE_BY_CLASS(QTextEdit)
	RETURN_INSTANCE_BY_CLASS(QTimeEdit)
	RETURN_INSTANCE_BY_CLASS(QToolBar)
	RETURN_INSTANCE_BY_CLASS(QToolButton)
	RETURN_INSTANCE_BY_CLASS(QTreeView)
	RETURN_INSTANCE_BY_CLASS(QTreeWidget)
	RETURN_INSTANCE_BY_CLASS(QWizardPage)
	//DIALOGS
	RETURN_INSTANCE_BY_CLASS(QDialog)
	RETURN_INSTANCE_BY_CLASS(QColorDialog)
	RETURN_INSTANCE_BY_CLASS(QFileDialog)
	RETURN_INSTANCE_BY_CLASS(QFontDialog)
	RETURN_INSTANCE_BY_CLASS(QInputDialog)
	RETURN_INSTANCE_BY_CLASS(QMessageBox)
	RETURN_INSTANCE_BY_CLASS(QPageSetupDialog)
	RETURN_INSTANCE_BY_CLASS(QPrintDialog)
	RETURN_INSTANCE_BY_CLASS(QPrintPreviewDialog)
	RETURN_INSTANCE_BY_CLASS(QProgressDialog)
	RETURN_INSTANCE_BY_CLASS(QWizard)
	
	return QWidgetWrap::NewInstance(widget);
}