
//#include <node.h>
//TEST
//#include "qt.h"

// TYPES
#include "Types/qbrush.h"
#include "Types/qcolor.h"
#include "Types/qfont.h"
#include "Types/qimage.h"
#include "Types/qlistwidgetitem.h"
#include "Types/qmatrix.h"
#include "Types/qmodelindex.h"
#include "Types/qpainter.h"
#include "Types/qpainterpath.h"
#include "Types/qpalette.h"
#include "Types/qpen.h"
#include "Types/qpixmap.h"
#include "Types/qpoint.h"
#include "Types/qpointf.h"
#include "Types/qprinter.h"
#include "Types/qrect.h"
#include "Types/qsize.h"
#include "Types/qtablewidgetitem.h"
#include "Types/qtreewidgetitem.h"
#include "Types/qvariant.h"
//#include "Types/qmimedata.h"

// QOBJECTS
#include "Objects/qaction.h"
#include "Objects/qapplication.h"
#include "Objects/qclipboard.h"
#include "Objects/qdrag.h"
#include "Objects/qfilesystemmodel.h"
#include "Objects/qgridlayout.h"
#include "Objects/qvboxlayout.h"
#include "Objects/qhboxlayout.h"
#include "Objects/qsettings.h"
#include "Objects/qsound.h"
#include "Objects/qsystemtrayicon.h"

#include "Objects/qobject.h"

// WIDGETS
#include "Widgets/qcalendarwidget.h"
#include "Widgets/qcheckbox.h"
#include "Widgets/qcombobox.h"
#include "Widgets/qdateedit.h"
#include "Widgets/qdatetimeedit.h"
#include "Widgets/qdial.h"
#include "Widgets/qdialogbuttonbox.h"
#include "Widgets/qdockwidget.h"
#include "Widgets/qframe.h"
#include "Widgets/qlabel.h"
#include "Widgets/qlineedit.h"
#include "Widgets/qlistwidget.h"
#include "Widgets/qmainwindow.h"
#include "Widgets/qmenu.h"
#include "Widgets/qmenubar.h"
#include "Widgets/qplaintextedit.h"
#include "Widgets/qprogressbar.h"
#include "Widgets/qpushbutton.h"
#include "Widgets/qradiobutton.h"
#include "Widgets/qscrollarea.h"
#include "Widgets/qscrollbar.h"
#include "Widgets/qslider.h"
#include "Widgets/qspinbox.h"
#include "Widgets/qsplitter.h"
#include "Widgets/qstatusbar.h"
#include "Widgets/qtabbar.h"
#include "Widgets/qtableview.h"
#include "Widgets/qtablewidget.h"
#include "Widgets/qtabwidget.h"
#include "Widgets/qtextbrowser.h"
#include "Widgets/qtextedit.h"
#include "Widgets/qtimeedit.h"
#include "Widgets/qtoolbar.h"
#include "Widgets/qtoolbutton.h"
#include "Widgets/qtreeview.h"
#include "Widgets/qtreewidget.h"
#include "Widgets/qwidget.h"
#include "Widgets/qwizardpage.h"

// DIALOGS
#include "Widgets/Dialogs/qdialog.h"

#include "Widgets/Dialogs/qcolordialog.h"
#include "Widgets/Dialogs/qfiledialog.h"
#include "Widgets/Dialogs/qfontdialog.h"
#include "Widgets/Dialogs/qinputdialog.h"
#include "Widgets/Dialogs/qmessagebox.h"
#include "Widgets/Dialogs/qpagesetupdialog.h"
#include "Widgets/Dialogs/qprintdialog.h"
#include "Widgets/Dialogs/qprintpreviewdialog.h"
#include "Widgets/Dialogs/qprogressdialog.h"
#include "Widgets/Dialogs/qwizard.h"

// EVENTS
#include "Events/qkeyevent.h"
#include "Events/qmouseevent.h"
#include "Events/qevent.h"
#include "Events/qdropevent.h"
#include "Events/qdragenterevent.h"
//#include "Events/qdragmoveevent.h"
#include "Events/qcontextmenuevent.h"



#ifdef QT_SVG_LIB
	#include "Widgets/QtSvg/qsvgwidget.h"
#endif

#ifdef QTTEST
	#include "QtTest/qtesteventlist.h"
#endif

#include "Objects/QtUiTools/quiloader.h"

using namespace v8;

void Initialize(Handle<Object> target) {
			
	//gMap = new std::map<int, int>;
	
	// TYPES
  QBrushWrap::Initialize(target);
  QColorWrap::Initialize(target);
  QFontWrap::Initialize(target);
  QImageWrap::Initialize(target);
  QListWidgetItemWrap::Initialize(target);
  QMatrixWrap::Initialize(target);
  QModelIndexWrap::Initialize(target);
  QPainterWrap::Initialize(target);
  QPainterPathWrap::Initialize(target);
  QPaletteWrap::Initialize(target);
  QPenWrap::Initialize(target);
  QPixmapWrap::Initialize(target);
  QPointWrap::Initialize(target);
  QPointFWrap::Initialize(target);
	QPrinterWrap::Initialize(target);
  QRectWrap::Initialize(target);
  QSizeWrap::Initialize(target);
  QTableWidgetItemWrap::Initialize(target);
  QTreeWidgetItemWrap::Initialize(target);
  QVariantWrap::Initialize(target);

    
  // WIDGETS
  QCalendarWidgetWrap::Initialize(target);
  QCheckBoxWrap::Initialize(target);
  QComboBoxWrap::Initialize(target);
  QDateEditWrap::Initialize(target);
  QDateTimeEditWrap::Initialize(target);
  QDialWrap::Initialize(target);
	QDialogButtonBoxWrap::Initialize(target);
	QDockWidgetWrap::Initialize(target);
	QDragWrap::Initialize(target);
  QFrameWrap::Initialize(target);
  QLabelWrap::Initialize(target);
  QLineEditWrap::Initialize(target);
  QListWidgetWrap::Initialize(target);
  QMainWindowWrap::Initialize(target);
  QMenuBarWrap::Initialize(target);
  QMenuWrap::Initialize(target);
  QPlainTextEditWrap::Initialize(target);
  QProgressBarWrap::Initialize(target);
  QPushButtonWrap::Initialize(target);
  QRadioButtonWrap::Initialize(target);
  QScrollAreaWrap::Initialize(target);
  QScrollBarWrap::Initialize(target);
  QSliderWrap::Initialize(target);
  QSpinBoxWrap::Initialize(target);
  QSplitterWrap::Initialize(target);
  QStatusBarWrap::Initialize(target);
  QTabBarWrap::Initialize(target);
  QTableViewWrap::Initialize(target);
  QTableWidgetWrap::Initialize(target);
  QTabWidgetWrap::Initialize(target);
	QTextBrowserWrap::Initialize(target);
	QTextEditWrap::Initialize(target);
  QTimeEditWrap::Initialize(target);
  QToolBarWrap::Initialize(target);
  QToolButtonWrap::Initialize(target);
	QTreeViewWrap::Initialize(target);
	QTreeWidgetWrap::Initialize(target);
  QWidgetWrap::Initialize(target);
  QWizardPageWrap::Initialize(target);
  

  // DIALOGS
  QDialogWrap::Initialize(target);
    
	QColorDialogWrap::Initialize(target);
	QFileDialogWrap::Initialize(target);
	QFontDialogWrap::Initialize(target);
	QInputDialogWrap::Initialize(target);
	QMessageBoxWrap::Initialize(target);
	QPageSetupDialogWrap::Initialize(target);
	QPrintDialogWrap::Initialize(target);
	QPrintPreviewDialogWrap::Initialize(target);
	QProgressDialogWrap::Initialize(target);
	QWizardWrap::Initialize(target);
     
     
  // EVENTS
  QEventWrap::Initialize(target);
  
	QContextMenuEventWrap::Initialize(target);
  QDropEventWrap::Initialize(target);
  QKeyEventWrap::Initialize(target);
  QMouseEventWrap::Initialize(target);
	
  //QDragEnterEventWrap::Initialize(target);
  //QDragMoveEventWrap::Initialize(target);
  
	// OBJECTS
  QActionWrap::Initialize(target);
  QApplicationWrap::Initialize(target);
	QClipboardWrap::Initialize(target);
  QFileSystemModelWrap::Initialize(target);
	QGridLayoutWrap::Initialize(target);
	QHBoxLayoutWrap::Initialize(target);
  QSettingsWrap::Initialize(target);
  QSoundWrap::Initialize(target);
  QSystemTrayIconWrap::Initialize(target);
	QVBoxLayoutWrap::Initialize(target);

  //QMimeDataWrap::Initialize(target);	
	QUiLoaderWrap::Initialize(target);
	
  QObjectWrap::Initialize(target); // TEST
  
#ifdef QT_SVG_LIB
  QSvgWidgetWrap::Initialize(target);
#endif

}

NODE_MODULE(qt, Initialize)
