#ifndef QT_H
#define QT_H

//#define BUILDING_NODE_EXTENSION


//CONFIG
// #define QT_DECLARATIVE_LIB
// #define QT_NETWORK_LIB
// #define QT_PHONON
// #define QT_SVG_LIB
// #define QT_WEBKIT_LIB


// TEST
#include <node.h>
#include "node_buffer.h"

// CORE
#include <QApplication>
#include <QResource>

// WIDGETS
#include <QWidget>
#include <QMainWindow>
#include <QCalendarWidget>
#include <QCheckBox>
#include <QComboBox>
#include <QDateEdit>
#include <QDateTimeEdit>
#include <QDial>
#include <QDialogButtonBox>
#include <QDockWidget>
#include <QFileSystemModel>
#include <QFontComboBox>
#include <QFrame>
#include <QLabel>
#include <QLineEdit>
#include <QListWidget>
#include <QMenuBar>
#include <QPlainTextEdit>
#include <QProgressBar>
#include <QPushButton>
#include <QQueue>
#include <QRadioButton>
#include <QScrollBar>
#include <QSlider>
#include <QSpinBox>
#include <QSplitter>
#include <QStaticText>
#include <QStatusBar>
#include <QSystemTrayIcon>
#include <QTableView>
#include <QTableWidget>
#include <QTextBrowser>
#include <QTextEdit>
#include <QTimeEdit>
#include <QToolBar>
#include <QToolButton>
#include <QTreeWidget>

// DIALOGS
#include <QDialog>
#include <QColorDialog>
#include <QErrorMessage>
#include <QFileDialog>
#include <QFontDialog>
#include <QInputDialog>
#include <QMessageBox>
#include <QPageSetupDialog>
#include <QPrintDialog>
#include <QPrintPreviewDialog>
#include <QProgressDialog>
#include <QWizard>

// LAYOUTS
#include <QLayout>
#include <QBoxLayout>
#include <QHBoxLayout>
#include <QVBoxLayout>
#include <QGridLayout>

// OBJECTS
#include <QAction>
#include <QBrush>
#include <QClipboard>
#include <QColor>
#include <QDesktopServices>
#include <QFocusFrame>
#include <QImage>
#include <QMenu>
#include <QMetaMethod>
#include <QMetaObject>
#include <QMimeData>
#include <QPainter>
#include <QPainterPath>
#include <QPen>
#include <QPixmap>
#include <QPoint>
#include <QPointF>
#include <QPrinter>
#include <QRect>
#include <QSettings>
#include <QSize>
#include <QtUiTools/QUiLoader>
#include <QWhatsThis>

// DATA TYPES
#include <QBuffer>
#include <QUrl>
#include <QFile>
#include <QObject>
#include <QDir>
#include <QBitmap>
#include <QPicture>
#include <QStringList>
#include <QVariant>

 // SONST
#include <QScrollArea>
#include <QSound>

#include <QHeaderView>

#ifdef QT_DECLARATIVE_LIB
	#include <QtDeclarative/QDeclarativeView>
#endif

#ifdef QT_NETWORK_LIB
	#include <QtNetwork/QFtp>
	#include <QtNetwork/QNetworkRequest>
	#include <QtNetwork/QNetworkReply>
	#include <QtNetwork/QAbstractSocket>
	#include <QtNetwork/QTcpSocket>
	#include <QtNetwork/QUdpSocket>
#endif

#ifdef QT_PHONON
	#include <Phonon/MediaObject>
	
	#include <Phonon/VideoWidget>
	#include <Phonon/AudioOutput>
	#include <Phonon/MediaSource>
#endif

#ifdef QT_SVG_LIB
	#include <QtSvg/QSvgWidget>
#endif

#ifdef QT_WEBKIT_LIB
	#include <QtWebKit/QWebView>
	#include <QtWebKit/QWebSettings>
	#include <QtWebKit/QWebFrame>
	#include <QtWebKit/QWebHistory>
#endif


// OTHER
//#include <QtDebug>

// DEFINES

#define DEFINE_METHOD(X) static v8::Handle<v8::Value> X(const v8::Arguments& args);

#define ADD_METHOD(X) tpl->PrototypeTemplate()->Set(String::NewSymbol(#X), FunctionTemplate::New(X)->GetFunction());
#define ADD_STATIC_METHOD(X) tpl->Set(String::NewSymbol(#X), FunctionTemplate::New(X)->GetFunction());

#define ALERT(X) MessageBoxA (0, X, "INFO", 0)

#define DBGS(X) printf ("%s\n", X);
#define DBGQS(X) printf ("%s\n", X.toAscii().constData());
#define DBGJS(X) printf ("%s\n", qt_v8::ToQString(X).toAscii().constData());

#define DBGI(X) {char buf[32];sprintf(buf, "%d", X); DBGS(buf);}


// "QPainterWrap::DrawImage: image is null, no size set?"
// "QPainterWrap::DrawPixmap: pixmap argument not recognized"

#define ASSERT_NARGS(X) if (args.Length()<X) {return ThrowException(Exception::TypeError(String::New("not enough arguments specified")));};
#define ASSERT_NOT_NULL(X) if (X->isNull()) {return ThrowException(Exception::TypeError(String::New("object is null")));};
#define ASSERT_OBJECT_TYPE(X,Y) if (!X->IsObject() || qt_v8::ToQString(X->ToObject()->GetConstructorName())!=Y){return ThrowException(Exception::TypeError(String::New("wrong argument type")));};
#define ASSERT_TYPE(X,F) if (!X->F()){return ThrowException(Exception::TypeError(String::New("wrong argument type")));};
//	String::New("Second argument must be a callback function")));

#define STRINGIFY(X) #X

#define THROW_ERROR_BAD_TYPES return ThrowException(Exception::TypeError(String::New("bad arguments")));


//	if (strcmp(className,"QLabel")==0){
//  	return scope.Close(QLabelWrap::NewInstance(qobject_cast<QLabel *>(widget)));
//  }

#define CONC(A,B) A ## B
#define RETURN_INSTANCE_IF_CLASS(X) if (strcmp(className,#X)==0) return scope.Close(CONC(X,Wrap)::NewInstance(qobject_cast<X *>(widget)));


namespace qt_v8 {

// JS TO QSTRING
inline QString ToQString(v8::Local<v8::String> str) {
  return QString::fromUtf16( *v8::String::Value(str) );
}

// QSTRING TO JS
inline v8::Local<v8::String> FromQString(QString str) {
  return v8::String::New( str.utf16() );
}

} // namespace


#endif // QT_H
