#include "receiver_moc.cc"

//#define QSTR_TO_PCHAR(X) X.toUtf8()
//#include "QtGui/qwidget.h"

#include "qwrappers.h"

using namespace v8;

// CLASS RECEIVER
Receiver::Receiver(Handle<Function> callback, Handle<Object> w) : QObject(){//, int evtType=0
	this->callback = Persistent<Function>::New(callback);
	//QObject * parent, long id, long targetId, long callbackHandlerSymbol, int receiverType, long eventType){
	//	if (parent) this->setParent(parent);
	
	this->eventType = 0;//evtType;
	this->wrap = Persistent<Object>::New(w);;
}

Receiver::~Receiver(){
	this->clearCallback();
}

void Receiver::clearCallback(){
	if (this->callback.IsEmpty()) {
		this->callback.Dispose();
		this->callback.Clear();
	}
}

void Receiver::evtV(){
	//HandleScope scope;
	this->callback->Call(this->wrap, 0, 0); //argc, argv
}

void Receiver::evtI(int i){
	//HandleScope scope;
	const unsigned argc = 1;
	Local<Value> argv[argc] = {
		Local<Value>::New(Integer::New(i))
	};
	this->callback->Call(this->wrap, argc, argv);
}

//void Receiver::evtA(QAction *action){
////	pMmValue->StringToValue(QSTR_TO_PCHAR(action->text()), &resultValue);
//}

void Receiver::evtW(QWidget * newTarget){
	//HandleScope scope;
	const unsigned argc = 1;
	Handle<Value> argv[argc] = {
		Persistent<Value>::New( QWidgetWrap::NewInstance(newTarget) )
	};
	this->callback->Call(this->wrap, argc, argv);
}

void Receiver::evtU(const QUrl &url){
	//HandleScope scope;
	const unsigned argc = 1;
	Local<Value> argv[argc] = {
		Local<Value>::New(String::New( url.toString().utf16() ))
	};
	this->callback->Call(this->wrap, argc, argv);
	//pMmValue->StringToValue(gIsUtf8?url.toString().toUtf8():url.toString().toLatin1(), &resultValue);
}

void Receiver::evtB(bool b){
	//HandleScope scope;
	const unsigned argc = 1;
	Local<Value> argv[argc] = {
		Local<Value>::New(Boolean::New(b))
	};
	//this->callback->Call(Context::GetCurrent()->Global(), argc, argv);
	this->callback->Call(this->wrap, argc, argv);
}

void Receiver::evtS(const QString &str){
	//HandleScope scope;
	const unsigned argc = 1;
	Local<Value> argv[argc] = {
		Local<Value>::New(String::New( str.utf16() ))
	};
	this->callback->Call(this->wrap, argc, argv);
}

void Receiver::evtII(int i, int j){
	//HandleScope scope;
	const unsigned argc = 2;
	Local<Value> argv[argc] = {
		Local<Value>::New(Integer::New(i)),
		Local<Value>::New(Integer::New(j))
	};
	this->callback->Call(this->wrap, argc, argv);
}

void Receiver::evtIB(int i, bool b){
	//HandleScope scope;
	const unsigned argc = 2;
	Local<Value> argv[argc] = {
		Local<Value>::New(Integer::New(i)),
		Local<Value>::New(Boolean::New(b))
	};
	this->callback->Call(this->wrap, argc, argv);
}

void Receiver::evtDT(const QDateTime &dateTime){
	//HandleScope scope;
	const unsigned argc = 1;
	Local<Value> argv[argc] = {
		Local<Value>::New(String::New( dateTime.toString("yyyyMMdd hh:mm:ss").utf16() ))
	};
	this->callback->Call(this->wrap, argc, argv);
}

//void Receiver::evtI64(qint64 i){
////	pMmValue->IntegerToValue(i, &resultValue);
//}

//void Receiver::evtI64I64(qint64 i, qint64 j){
////	pMmValue->IntegerToValue(i, &resultValue);
////	pMmValue->IntegerToValue(j, &resultValue2);
//}

#ifdef QT_NETWORK_LIB
void Receiver::evtUI(const QUrlInfo & i){
	
//	MoaMmValue moaValue;
//	MoaMmValue propValue;
//	pMmList->NewPropListValue(&resultValue);
//
//	pMmValue->StringToValue("name", &propValue);
//	pMmValue->StringToValue(gIsUtf8?i.name().toUtf8():i.name().toLatin1(), &moaValue);
////dbgs(i.name().toUtf8());
//	pMmList->AppendValueToPropList(&resultValue, &propValue, &moaValue);
//
//	pMmValue->StringToValue("owner", &propValue);
//	pMmValue->StringToValue(gIsUtf8?i.owner().toUtf8():i.owner().toLatin1(), &moaValue);
//	pMmList->AppendValueToPropList(&resultValue, &propValue, &moaValue);
//
//	pMmValue->StringToValue("group", &propValue);
//	pMmValue->StringToValue(gIsUtf8?i.group().toUtf8():i.group().toLatin1(), &moaValue);
//	pMmList->AppendValueToPropList(&resultValue, &propValue, &moaValue);
//
//	pMmValue->StringToValue("size", &propValue);
//	pMmValue->IntegerToValue(i.size(), &moaValue);
//	pMmList->AppendValueToPropList(&resultValue, &propValue, &moaValue);
//
//	pMmValue->StringToValue("permissions", &propValue);
//	pMmValue->IntegerToValue(i.permissions(), &moaValue);
//	pMmList->AppendValueToPropList(&resultValue, &propValue, &moaValue);
//
//	pMmValue->StringToValue("flags", &propValue);
//	bool flags = (i.isDir()<<6) + (i.isExecutable()<<5) + (i.isFile()<<4) + (i.isReadable()<<3) + (i.isSymLink()<<2) + (i.isValid()<<1) + i.isWritable();
//	pMmValue->IntegerToValue(flags, &moaValue);
//	pMmList->AppendValueToPropList(&resultValue, &propValue, &moaValue);
}
#endif

void Receiver::evtC(const QColor & col){
	//HandleScope scope;
	const unsigned argc = 1;
	Handle<Value> argv[argc] = {
		Persistent<Value>::New( QColorWrap::NewInstance(col) )
	};
	this->callback->Call(this->wrap, argc, argv);
}


//	QStringList formatList = mime->formats();
//	Handle<Array> formatArray = v8::Array::New(formatList.count());
//	for (int i=0;i<formatList.count();i++){
//		formatArray->Set(i, qt_v8::FromQString(formatList[i]) );
//	}
//  return scope.Close(formatArray);


void Receiver::evtSL(const QStringList & sl){	
	//HandleScope scope;
	Handle<Array> a = v8::Array::New(sl.count());
	for (int i=0;i<sl.count();i++){
		a->Set(i, qt_v8::FromQString(sl[i]) );
	}
	const unsigned argc = 1;
	Handle<Value> argv[argc] = {
		a
	};
	this->callback->Call(this->wrap, argc, argv);
}

//void Receiver::evtF(const QFont & font){
////	pMmValue->StringToValue(gIsUtf8?font.toString().toUtf8():font.toString().toLatin1(), &resultValue);
//}

void Receiver::evtM(const QModelIndex & index){
	//HandleScope scope;
	const unsigned argc = 1;
	// WAS: Local<Value>::
	Handle<Value> argv[argc] = {
		Persistent<Value>::New( QModelIndexWrap::NewInstance(index) ) //was: (QModelIndex *)&index)
	};
	this->callback->Call(this->wrap, argc, argv);
}

void Receiver::evtMM(const QModelIndex & index,const QModelIndex & index2){
	//HandleScope scope;
	const unsigned argc = 2;
	Handle<Value> argv[argc] = {
		Persistent<Value>::New( QModelIndexWrap::NewInstance(index) ), //(QModelIndex *)&index)
		Persistent<Value>::New( QModelIndexWrap::NewInstance(index2) )
	};
	this->callback->Call(this->wrap, argc, argv);
}

void Receiver::evtP(const QPoint & p){
	//HandleScope scope;
	const unsigned argc = 1;
	// WAS: Local<Value>::
	Handle<Value> argv[argc] = {
		//Persistent<Value>::New( QPointWrap::NewInstance((QPoint *)&p) )
		Persistent<Value>::New( QPointWrap::NewInstance(p) )
	};
	this->callback->Call(this->wrap, argc, argv);
}

#ifdef QT_NETWORK_LIB
void Receiver::evtR(const QNetworkRequest & request){
//	pMmValue->StringToValue(gIsUtf8?request.url().toString().toUtf8():request.url().toString().toLatin1(), &resultValue);
//}
}
#endif

//ENUMERATIONS
//void Receiver::evtE1(QNetworkReply::NetworkError e){
////	pMmValue->IntegerToValue((int)e, &resultValue);
//}
//void Receiver::evtE2(Phonon::State s1,Phonon::State s2){
////	pMmValue->IntegerToValue((int)s1, &resultValue);
////	pMmValue->IntegerToValue((int)s2, &resultValue2);
//}

void Receiver::evtE3(QSystemTrayIcon::ActivationReason r){
	//HandleScope scope;
	const unsigned argc = 1;
	Handle<Value> argv[argc] = {
		Local<Value>::New(Integer::New((int)r))
	};
	this->callback->Call(this->wrap, argc, argv);
}

//void Receiver::evtE4(QAbstractSocket::SocketError e){
////	pMmValue->IntegerToValue((int)e, &resultValue);
//}
//void Receiver::evtE5(QAbstractSocket::SocketState s){
////	pMmValue->IntegerToValue((int)s, &resultValue);
//}

void Receiver::evtT(QTreeWidgetItem * item){
	//HandleScope scope;
	const unsigned argc = 1;
	Handle<Value> argv[argc] = {
		Persistent<Value>::New( QTreeWidgetItemWrap::NewInstance(item) )
	};
	this->callback->Call(this->wrap, argc, argv);
}

void Receiver::evtL(QListWidgetItem * item){
	//HandleScope scope;
	const unsigned argc = 1;
	Handle<Value> argv[argc] = {
		Persistent<Value>::New( QListWidgetItemWrap::NewInstance(item) )
	};
	this->callback->Call(this->wrap, argc, argv);
}


void Receiver::evtTI(QTreeWidgetItem * item, int i){
	//HandleScope scope;
	const unsigned argc = 2;
	Handle<Value> argv[argc] = {
		Persistent<Value>::New( QTreeWidgetItemWrap::NewInstance(item) ),
		Local<Value>::New(Integer::New(i))
	};
	this->callback->Call(this->wrap, argc, argv);
}

void Receiver::evtTT(QTreeWidgetItem * item, QTreeWidgetItem * item2){
	//HandleScope scope;
	const unsigned argc = 2;
	Handle<Value> argv[argc] = {
		Persistent<Value>::New( QTreeWidgetItemWrap::NewInstance(item) ),
		Persistent<Value>::New( QTreeWidgetItemWrap::NewInstance(item2) )
	};
	this->callback->Call(this->wrap, argc, argv);
}
	
void Receiver::evtPr(QPrinter * printer){
	//HandleScope scope;
	const unsigned argc = 1;
	Handle<Value> argv[argc] = {
		Persistent<Value>::New( QPrinterWrap::NewInstance(printer) )
	};
	this->callback->Call(this->wrap, argc, argv);
}

void Receiver::evtTw(QTableWidgetItem * item){
	//HandleScope scope;
	const unsigned argc = 1;
	Handle<Value> argv[argc] = {
		Persistent<Value>::New( QTableWidgetItemWrap::NewInstance(item) )
	};
	this->callback->Call(this->wrap, argc, argv);
}

void Receiver::evtTwTw(QTableWidgetItem * item, QTableWidgetItem * item2){
	//HandleScope scope;
	const unsigned argc = 2;
	Handle<Value> argv[argc] = {
		Persistent<Value>::New( QTableWidgetItemWrap::NewInstance(item) ),
		Persistent<Value>::New( QTableWidgetItemWrap::NewInstance(item2) )
	};
	this->callback->Call(this->wrap, argc, argv);
}


bool Receiver::eventFilter(QObject *obj, QEvent *e){

	if (e->type()==eventType){ // QEvent::Close){
		
		// e.g.
		// QKeyEvent *keyEvent = static_cast<QKeyEvent *>(event);
		
		const unsigned argc = 1;
		Handle<Value> argv[argc] = {
			Persistent<Value>::New( QEventWrap::NewInstance(e) )
		};
		this->callback->Call(this->wrap, argc, argv);
		  
		//e->setAccepted(true); // ???
		//e->ignore();
		
		return false; // passed
		
	} else {
		// standard event processing
		return QObject::eventFilter(obj, e);
	}
}
