#ifndef RECEIVER_H
#define RECEIVER_H

//
#include "qt.h"
#include "Objects/qaction.h"

class Receiver : public QObject {
Q_OBJECT

public:
	int eventType;
	v8::Persistent<v8::Function> callback;
	v8::Persistent<v8::Object> wrap;
	
public:
	Receiver(v8::Handle<v8::Function> callback, v8::Handle<v8::Object> w=v8::Object::New());//, int evtType
	~Receiver();
	void clearCallback();

public slots:
  void evtV();
	void evtI(int i);
	void evtU(const QUrl &url);
	
	//void evtA(QAction *action);
	void evtW(QWidget * newTarget);
	
	void evtB(bool b);
	void evtS(const QString &url);
	void evtII(int i, int j);
	void evtIB(int i, bool b);
  void evtDT(const QDateTime &datetime);
//	void evtI64(qint64 i);
//	void evtI64I64(qint64 i, qint64 j);
#ifdef QT_NETWORK_LIB
  void evtUI(const QUrlInfo & i);
#endif
	void evtC(const QColor &col);
	void evtSL(const QStringList & sl);
//	void evtF(const QFont &col);
	void evtM(const QModelIndex & index);
	void evtMM(const QModelIndex & index,const QModelIndex & index2);
	void evtP(const QPoint & p);
#ifdef QT_NETWORK_LIB
	void evtR(const QNetworkRequest & request);
	//void evtNR(const QNetworkReply & reply);
#endif	

//	void evtE1(QNetworkReply::NetworkError e);
//	void evtE2(Phonon::State s1,Phonon::State s2);
	void evtE3(QSystemTrayIcon::ActivationReason r);
//	void evtE4(QAbstractSocket::SocketError e);
//	void evtE5(QAbstractSocket::SocketState s);

	void evtT(QTreeWidgetItem * item);
	void evtL(QListWidgetItem * item);
	void evtTI(QTreeWidgetItem * item, int i);
	void evtTT(QTreeWidgetItem * item, QTreeWidgetItem * item2);
	void evtPr(QPrinter * printer);
	
	void evtTw(QTableWidgetItem * item);
	void evtTwTw(QTableWidgetItem * item, QTableWidgetItem * item2);
	
	//TEST
	bool eventFilter(QObject *obj, QEvent *e);
	
//private:
//	v8::Persistent<v8::Function> callback;
	
};

#endif // RECEIVER_H
